2013-12-17  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.7.0 Released.

2013-12-16  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.7.0-rc2 Released.

	* AST-2013-006 - app_sms: BufferOverflow when receiving odd length 16
	  bit message

	  This patch prevents an infinite loop overwriting memory when a
	  message is received into the unpacksms16() function, where the length
	  of the message is an odd number of bytes.
	  (closes issue ASTERISK-22590)

	* AST-2013-007 - security: Inhibit execution of privilege escalating
	  functions

	  This patch allows individual dialplan functions to be marked as
	  'dangerous', to inhibit their execution from external sources.

	  A 'dangerous' function is one which results in a privilege
	  escalation. For example, if one were to read the channel variable
	  SHELL(rm -rf /) Bad Things(TM) could happen; even if the external
	  source has only read permissions.

	  Execution from external sources may be enabled by setting
	  'live_dangerously' to 'yes' in the [options] section of
	  asterisk.conf. Although doing so is not recommended.

	  (closes issue ASTERISK-22905)

2013-10-28  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.7.0-rc1 Released.

2013-10-25 23:32 +0000 [r401960-402042]  Scott Griepentrog <sgriepentrog@digium.com>

	* /, include/asterisk/rtp_engine.h, main/rtp_engine.c: rtp_engine:
	  fix rtp payloads copy and improve argument names In function
	  ast_rtp_instance_early _bridge_make_compatible the use of
	  instance 0/1 as arguments doesn't clearly communicate a direction
	  that the copying of payloads from the source channel to the
	  destination channel will occur, making it more probable to have
	  the arguments to ast_rtp_codecs_payloads_copy() put in the
	  reverse order. This patch renames the arguments with _dst and
	  _src suffixes and corrects the copy direction. (closes issue
	  ASTERISK-21464) Reported by: Kevin Stewart Review:
	  https://reviewboard.asterisk.org/r/2894/ ........ Merged
	  revisions 402000 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 Test shows
	  rtpmap:119 being copied per this change, but is not in sip invite

	* include/asterisk/pbx.h, main/pbx.c, /: pbx.c: fix confused match
	  caller id that deleted exten still in hash This fixes a bug where
	  a zero length callerid match adjacent to a no match callerid
	  extension entry would be deleted together, which then resulted in
	  hashtable references to free'd memory. A third state of the
	  matchcid value has been added to indicate match to any extension
	  which allows enforcing comparison of matchcid on/off without
	  errors. (closes issue AST-1235) Reported by: Guenther Kelleter
	  Review: https://reviewboard.asterisk.org/r/2930/ ........ Merged
	  revisions 401959 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-25 17:29 +0000 [r401896-401935]  Jonathan Rose <jrose@digium.com>

	* /, utils/clicompat.c: Put clicompat-r2.patch back in We've
	  figured out how to resolve the problems this was causing in
	  12/trunk, so this can go back in now. (issue ASTERISK-22467)
	  Reported by: Corey Farrell Patches: clicompat-r2.patch uploaded
	  by coreyfarrell (license 5909) ........ Merged revisions 401914
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* utils/clicompat.c, /: revert clicompat-r2.patch from r401704
	  Patch caused the following build errors against testsuite
	  https://bamboo.asterisk.org/bamboo/browse/AST-ATRUNKBUILD4-244
	  (issue ASTERISK-22467) Reported by: Corey Farrell ........ Merged
	  revisions 401895 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-25 16:05 +0000 [r401833-401884]  Kevin Harwell <kharwell@digium.com>

	* channels/chan_sip.c: chan_sip: Allow a sip peer to accept both
	  AVP and AVPF calls Adapts the behaviour of avpf to only impact
	  the format of outgoing calls. For inbound calls, both AVP and
	  AVPF calls will be accepted regardless of the value of avpf in
	  the configuration. (closes issue ASTERISK-22005) Reported by:
	  Torrey Searle Patches: optional_avpf_trunk.patch uploaded by
	  tsearle (license 5334)

	* main/logger.c: Logging: Logging types ignored after specifying a
	  verbose level If one specified a verbose level within a logging
	  facility in logger.conf then any component after it was ignored.
	  Fixed so all values are correctly read. (closes issue
	  ASTERISK-22456) Reported by: Kevin Harwell

2013-10-24 20:33 +0000 [r401620-401830]  Jonathan Rose <jrose@digium.com>

	* /, main/utils.c: utils: Fix memory leaks and missed
	  unregistration of CLI commands on shutdown Final set of patches
	  in a series of memory leak/cleanup patches by Corey Farrell
	  (closes issue ASTERISK-22467) Reported by: Corey Farrell Patches:
	  main-utils-1.8.patch uploaded by coreyfarrell (license 5909)
	  main-utils-11.patch uploaded by coreyfarrell (license 5909)
	  main-utils-12up.patch uploaded by coreyfarrell (license 5909)
	  ........ Merged revisions 401829 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, tests/test_linkedlists.c: test_linkedlists: Fix memory leak
	  (issue ASTERISK-22467) Reported by: Corey Farrell Patches:
	  test_linkedlists-1.8.patch uploaded by coreyfarrell (license
	  5909) test_linkedlists-11up.patch uploaded by coreyfarrell
	  (license 5909) ........ Merged revisions 401790 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/jitterbuf.c, /: jitterbuf: Fix memory leak on jitter buffer
	  reset (issue ASTERISK-22467) Reported by: Corey Farrell Patches:
	  jitterbuf-jb_reset-leak-1.8.patch
	  jitterbuf-jb_reset-leak-11up.patch ........ Merged revisions
	  401786 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/astobj2.c: astobj2: Unregister debug CLI commands at exit
	  (issue ASTERISK-22467) Reported by: Corey Farrell Patches:
	  astobj2-clean-debug-cli-1.8-11.patch uploaded by coreyfarrell
	  (license 5909) astobj2-clean-debug-cli-12up.patch uploaded by
	  coreyfarrell (license 5909) ........ Merged revisions 401781 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_voicemail.c: app_voicemail: Memory Leaks against
	  tests (issue ASTERISK-22467) Reported by: Corey Farrell Patches:
	  app_voicemail-1.8.patch uploaded by coreyfarrell (license 5909)
	  app_voicemail-11up.patch uploaded by coreyfarrell (license 5909)
	  ........ Merged revisions 401743 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* utils/clicompat.c, channels/chan_dahdi.c, codecs/ilbc/doCPLC.c,
	  main/data.c, /, main/app.c, main/asterisk.c: memory leaks: Memory
	  leak cleanup patch by Corey Farrell (second set) Also covers
	  ast_app_parse_timelen-fail-zero-length.patch, but the patch was
	  replaced with one of my own. (issue ASTERISK-22467) Reported by:
	  Corey Farrell Patches: chan_dahdi-cleanup_push.patch uploaded by
	  coreyfarrell (license 5909) clicompat-r2.patch uploaded by
	  coreyfarrell (license 5909) codecs-ilbc-doCPLC.patch uploaded by
	  coreyfarrell (license 5909) data-cleanup-test-registration.patch
	  uploaded by coreyfarrell (license 5909)
	  main-asterisk-kill-listener.patch uploaded by coreyfarrell
	  (license 5909) ........ Merged revisions 401704 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* tests/test_dlinklists.c, funcs/func_math.c,
	  channels/sip/reqresp_parser.c, main/test.c,
	  main/editline/readline.c, /: memory leaks: Memory leak cleanup
	  patch by Corey Farrell (first set) (issue ASTERSIK-22467)
	  Reported by: Corey Farrell Patches:
	  chan_sip-parse_contact_header_test-free-contacts.patch uploaded
	  by coreyfarrell (license 5909) cli-filename-completion-leak.patch
	  uploaded by coreyfarrell (license 5909) func_math.patch uploaded
	  by corefarrell (license 5909) main-test-cleanup.patch uploaded by
	  coreyfarrell (license 5909) test_dlinklists.patch uploaded by
	  coreyfarrell (license 5909) ........ Merged revisions 401660 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* res/res_rtp_asterisk.c, /, main/translate.c: res_rtp_asterisk:
	  Address jittery DTMF events in RTP streams (closes issue
	  ASTERISK-21170) Reported by: NITESH BANSAL Patches:
	  dtmf-timestamp.patch uploaded by NITESH BANSAL (license 6418)
	  Review: https://reviewboard.asterisk.org/r/2938/ ........ Merged
	  revisions 401619 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-23 16:46 +0000 [r401579]  Richard Mudgett <rmudgett@digium.com>

	* cdr/cdr_adaptive_odbc.c, /: cdr_adaptive_odbc: Also apply a
	  filter when the CDR value is empty. Extra CDR records are written
	  if a filtered CDR value is empty because the filter is not
	  checked. (closes issue ASTERISK-22272) Reported by: Jordi Llull
	  Chavarria ........ Merged revisions 401577 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-23 15:22 +0000 [r401538]  Kinsey Moore <kmoore@digium.com>

	* channels/chan_mgcp.c, /: chan_mgcp: Properly handle malformed
	  media lines This corrects a situation in which a media line was
	  not parsed properly and resulted in a crash. (closes issue
	  ASTERISK-21190) Reported by: adomjan Patches:
	  chan_mgcp.c-sscnaf_fix uploaded by adomjan (License 5448)
	  ........ Merged revisions 401537 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-23 11:11 +0000 [r401498]  Joshua Colp <jcolp@digium.com>

	* /, channels/chan_sip.c: Fix an issue where an incompatible audio
	  format may be added to SDP. If preferred codecs included any
	  non-audio format the code would mistakenly add the audio format,
	  even if it was not a joint capability with the remote side.
	  (closes issue ASTERISK-21131) Reported by: nbougues Patches:
	  patch_unsupported_codec_1.8.patch uploaded by nbougues (license
	  6470) ........ Merged revisions 401497 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-22 22:42 +0000 [r401446]  Matthew Jordan <mjordan@digium.com>

	* res/res_rtp_asterisk.c, /: res_rtp_asterisk: Fix crash when RTCP
	  is not available during SSRC change In r400089, a patch was put
	  in to correct erroneous RTCP statistic resets. Unfortunately,
	  ast_rtp_read can be called on an RTP instance that does not have
	  RTCP information. This patch prevents that crash by only
	  resetting the statistics if we do actually have an RTCP instance.
	  (issue AST-1174) (closes issue ASTERISK-22667) Reported by: John
	  Bigelow ........ Merged revisions 401445 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-22 19:02 +0000 [r401379-401433]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_queue.c: app_queue: Fix CLI "queue remove member"
	  queue_log entry. The queue_log entry resulting from CLI "queue
	  remove member" when log_membername_as_agent is enabled is wrong.
	  It always uses the interface name instead of the member name in
	  the queue_log entry. * Get the queue member before removing it
	  from the queue so the member name is available for the queue_log
	  entry. (closes issue ASTERISK-21826) Reported by: Oscar Esteve
	  Patches: fix_membername.diff (license #6505) patch uploaded by
	  Oscar Esteve (modified to fix potential ref leak)

	* channels/sig_analog.c, /: chan_dahdi: Fix unable to get index
	  warning when transferring an analog call. Transferring an analog
	  call using flashhooks generated an unable to get index WARNING
	  message when the transfer is completed. * Removed unnecessary
	  analog subchannel shell games when transferring a call using
	  flashhooks. Thanks to Tzafrir Cohen for mentioning this in a
	  comment on issue ASTERISK-22720. ........ Merged revisions 401378
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-21 19:46 +0000 [r401326]  Kevin Harwell <kharwell@digium.com>

	* main/editline/term.c, /: Segfault in LIBEDIT_INTERNAL after
	  tgetstr(), when libncurses5-dev isn't installed Include the
	  appropriate declarations when not using termcap, but term+curses
	  and [n]curses do not exist. (closes issue ASTERISK-22351)
	  Reported by: A. Iglesias Patches:
	  issueA22351_libedit_internal_without_ncurses_dev.patch uploaded
	  by wdoekes (license 5674) ........ Merged revisions 401325 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-18 15:11 +0000 [r401182]  Michael L. Young <elgueromexicano@gmail.com>

	* channels/chan_sip.c: Remove Port Restriction When Checking For
	  NAT When trying to determine if a peer is behind NAT, we should
	  not be using the ports when comparing addresses. This patch
	  removes the port from being checked and just useds the addresses
	  now. (closes issue ASTERISK-22729) Reported by: Michael L. Young
	  Tested by: Michael L. Young Patches:
	  asterisk-remove-using-port-for-nat-check.diff uploaded by Michael
	  L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2927/

2013-10-18 14:43 +0000 [r401179]  Walter Doekes <walter+asterisk@wjd.nu>

	* main/channel.c, /: Properly copy/remove the device state cache
	  flag over a masquerade. In r378303 the
	  AST_FLAG_DISABLE_DEVSTATE_CACHE flag was added that tells the
	  devstate system to not cache states for non-real devices.
	  However, when optimizing away channels (ast_do_masquerade), that
	  flag wasn't copied. In my case, using Local devices as queue
	  members created a situation where the endpoint was considered in
	  use, but the state change of the device being available again was
	  ignored (not cached). The endpoint channel was optimized into the
	  (previously) Local channel, but kept the do-not-cache flag. The
	  end result being that the queue member apparently stayed in use
	  forever. (closes issue ASTERISK-22718) Reported by: Walter Doekes
	  Review: https://reviewboard.asterisk.org/r/2925/ ........ Merged
	  revisions 401178 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-17 20:32 +0000 [r401167]  Michael L. Young <elgueromexicano@gmail.com>

	* channels/chan_sip.c: Fix Setting A chan_sip Dialog's
	  SIP_NAT_FORCE_RPORT Flag A condition was added in a commit to fix
	  ASTERISK-21374, that, if the SIP_PAGE3_NAT_AUTO_RPORT flag was
	  set, to then copy a peer's SIP_NAT_FORCE_RPORT flag to the
	  dialog. This condition should not have been there since it
	  assumed that if Asterisk is in an environment where NAT is
	  involved, that the auto_* nat settings or force_rport setting
	  would be on in the global settings. If the nat setting in the
	  global setting is set to 'nat=no' and then turned on for peers
	  (which is not quite the recommended way, although it is allowed)
	  this flag is never copied to the dialog resulting in problems
	  like, REGISTER replies going to the wrong port. This patch
	  removes this conditional check and will now always use the peer's
	  flag which by this point in the code the checks on whether the
	  peer is behind NAT or not (if using auto_force_rport) have
	  already been run. (closes issue ASTERISK-22236) Reported by:
	  Filip Frank Tested by: Michael L. Young Patches:
	  asterisk-2236-always-set-rport.diff uploaded by Michael L. Young
	  (license 5026) Review: https://reviewboard.asterisk.org/r/2919/

2013-10-17 15:36 +0000 [r401120]  Kinsey Moore <kmoore@digium.com>

	* /, res/res_xmpp.c, res/res_jabber.c: Reduce log level of a
	  non-pubsub error message Drop an error log message to debug level
	  1 since distributed device state functions correctly when
	  receiving this message and it spams the logs. (closes issue
	  ASTERISK-22410) Reported by: abelbeck Patches:
	  asterisk-1.8-res_jabber-log-nonpubsub-error-to-debug.patch
	  uploaded by abelbeck (License 5903)
	  asterisk-11-res_xmpp-log-nonpubsub-error-to-debug.patch uploaded
	  by abelbeck (License 5903) ........ Merged revisions 401119 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-16 11:52 +0000 [r401076]  Walter Doekes <walter+asterisk@wjd.nu>

	* apps/app_queue.c, /: Don't check all realtime queues when doing
	  "queue show some_queue". When using realtime queues, queues have
	  to be fetched from the database every now and then to see if any
	  info has been changed or to see if the queue has been removed.
	  When fetching info for an individual queue, the pruning of other
	  queues is unnecessarily costly. Review:
	  https://reviewboard.asterisk.org/r/2907/ ........ Merged
	  revisions 401049 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-15 19:57 +0000 [r401016]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_iax2.c: chan_iax2: Fix channel left locked in off
	  nominal code path.

2013-10-15 14:58 +0000 [r400971]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Prevent chan_sip from sending duplicate
	  BYEs. When a 200 OK for an initial INVITE is received, we were
	  doing the right thing by ACKing and sending an immediate BYE.
	  However, we also were doing the wrong thing and queuing an answer
	  frame, thus causing the call to be answered. This would cause the
	  call to be hung up by the channel thread, thus resulting in a
	  second BYE being sent out. In this fix, I also have set the
	  hangupcause to be correct since the initial BYE being sent by
	  Asterisk had an unknown hangup cause. I have changed to using
	  "Bearer capabilty not available" since the call was hung up due
	  to an SDP offer/answer error. (closes issue ASTERISK-22621)
	  reported by Kinsey Moore ........ Merged revisions 400970 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-14 21:44 +0000 [r400909]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_dahdi.c, /: chan_dahdi: Reflect the set software
	  gain in the CLI "dahdi show channel" output. * Remember the
	  swgain setting from CLI "dahdi set swgain" command so the CLI
	  "dahdi show channel" output will reflect the current setting. *
	  Updated CLI "dahdi set hwgain" and "dahdi set swgain"
	  documentation. (issue ASTERISK-22429) Reported by: Jaco Kroon
	  Patches: jira_asterisk_22429_v1.8_v2.patch (license #5621) patch
	  uploaded by rmudgett ........ Merged revisions 400907 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-14 21:42 +0000 [r400908]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Do not increment the SDP version between
	  183 and 200 responses. Bumping the SDP version number can cause
	  interoperability problems since receivers of the responses will
	  expect that a 200 SDP will be identical to a previous 183 SDP.
	  (closes issue ASTERISK-21204) reported by NITESH BANSAL Patches:
	  dont-increment-session-version-in-2xx-after-183.patch uploaded by
	  NITESH BANSAL (License #6418) ........ Merged revisions 400906
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-08 22:27 +0000 [r400768]  Kinsey Moore <kmoore@digium.com>

	* /, configure, configure.ac: Add warning when compiling with iODBC
	  support When running configure, libiodbc2 development headers
	  will fulfill the requirement for ODBC development headers, but
	  will not function properly. This adds a warning when libiodbc2
	  development headers are detected instead of unixodbc development
	  headers. (closes issue ASTERISK-22459) Reported by: Patrick
	  Maille Tested by: Walter Doekes Patches:
	  issueA22459_warn_when_using_iodbc.patch uploaded by Walter Doekes
	  (License 5674) ........ Merged revisions 400767 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-08 20:14 +0000 [r400723-400741]  Richard Mudgett <rmudgett@digium.com>

	* UPGRADE.txt, apps/app_confbridge.c,
	  apps/confbridge/conf_config_parser.c,
	  configs/confbridge.conf.sample,
	  apps/confbridge/include/confbridge.h: app_confbridge: Can now set
	  the language used for announcements to the conference. ConfBridge
	  now has the ability to set the language of announcements to the
	  conference. The language can be set on a bridge profile in
	  confbridge.conf or by the dialplan function
	  CONFBRIDGE(bridge,language)=en. (closes issue ASTERISK-19983)
	  Reported by: Jonathan White Patches: M19983_rev2.diff (license
	  #5138) patch uploaded by junky (modified) Tested by: rmudgett

	* apps/confbridge/conf_config_parser.c: app_confbridge: Fix
	  duplicate default_user profile. * Fixed looking in the wrong
	  profiles container to see if the default_user profile is already
	  created in verify_default_profiles(). The bridge profile
	  container is never going to hold user profiles. :)

2013-10-08 18:18 +0000 [r400681-400697]  Kinsey Moore <kmoore@digium.com>

	* funcs/func_config.c, /: Fix func_config list entry allocation The
	  AST_CONFIG dialplan function defined in func_config.c allocates
	  its config file list entries using ast_malloc. List entry
	  allocations destined for use with Asterisk's linked list API must
	  be ast_calloc()d or otherwise initialized so that list pointers
	  are set to NULL. These uses of ast_malloc have been replaced by
	  ast_calloc to prevent dereferencing of uninitialized pointer
	  values when traversing the list. (closes issue ASTERISK-22483)
	  Reported by: Brian Scott ........ Merged revisions 400694 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* res/res_rtp_asterisk.c: Fix STUN crash when using IPv6 any
	  address Ensure that when chan_sip binds to the IPv6 any address
	  ([::]), IPv4 candidates are also added. (closes issue
	  ASTERISK-21917) Reported by: Torrey Searle Patches:
	  0023_ipv6_stun_crash.patch uploaded by Torrey Searle (License
	  5334)

2013-10-06 17:09 +0000 [r400623]  Michael L. Young <elgueromexicano@gmail.com>

	* apps/app_queue.c, /: Fix Regression With Queuelog EXITWITHKEY
	  Only Logging Two Out Of Four Fields Commit r62462 added two extra
	  fields for logging "the original position the caller entered the
	  queue at, and the amount of time the caller was waiting in the
	  queue." But when r75969 was merged from 1.4 into trunk (r75977),
	  these two fields disappeared. Those two extra fields were not
	  logged in 1.4 and when the patch was merged, those fields went
	  away. Therefore, this is a regression and was caught by the
	  reporter because he was reading the awesome "Asterisk: The
	  Definitive Guide" book. (closes issue ASTERISK-22197) Reported
	  by: Dalius M. Tested by: Dalius M. Patches:
	  asterisk-22197-q-log-exitwithkey.diff uploaded by Michael L.
	  Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2901/ ........ Merged
	  revisions 400622 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-03 22:59 +0000 [r400470]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c: chan_sip: Don't ignore expires value in
	  contact header if it lacks semicolon (closes issue
	  ASTERISK-22574) Reported by: Filip Jenicek Patches:
	  chan_sip_expires.patch uploaded by Filip Jenicek (license 6277)
	  ........ Merged revisions 400469 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-03 19:22 +0000 [r400394-400421]  Kinsey Moore <kmoore@digium.com>

	* main/security_events.c: Fix security events for AMI invalid
	  password In r337595, additional security events were added for
	  chan_sip authentication failures. The new IEs added to the
	  existing invalid password event were defined as required IEs, but
	  existing users of the event did not set the new IEs and could not
	  since they didn't apply to existing uses. They are now marked as
	  optional IEs. (closes issue ASTERISK-22578) Reported by: Matt
	  Jordan

	* res/res_rtp_multicast.c, /: Ensure res_rtp_mutlicast sets SSRC
	  properly This fixes a bug where the SSRC field on multicast RTP
	  can be stuck at 0 which can cause problems for endpoints trying
	  to make sense of incoming streams. (closes issue ASTERISK-22567)
	  Reported by: Simone Camporeale Patches:
	  22567_res_mulitcast_ssrc.patch uploaded by Simone Camporeale
	  (License 6536) ........ Merged revisions 400393 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-02 21:31 +0000 [r400315]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_iax2.c: Cast Integer Argument To Unsigned Char
	  The member reg in the peercnt structure is an unsigned char and
	  peercnt_modify() is expecting an unsigned char argument which
	  gets assigned to peercnt->reg. This patch fixes that by casting
	  the integer argument being passed to peercnt_modify to unsigned
	  char. ........ Merged revisions 400314 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-02 17:36 +0000 [r400279]  Tzafrir Cohen <tzafrir.cohen@xorcom.com>

	* Makefile, doc/astdb2sqlite3.8 (added), doc/astdb2bdb.8 (added):
	  man pages for astdb2bdb and astdb2sqlite3 Review:
	  https://reviewboard.asterisk.org/r/2898/

2013-09-30 15:26 +0000 [r400140]  Kinsey Moore <kmoore@digium.com>

	* UPGRADE.txt, configs/sip.conf.sample, /, channels/chan_sip.c:
	  Allow Asterisk to retry after 403 on register This adds a global
	  option in chan_sip to allow it to continue attempting
	  registration if a 403 is received, clearing the cached nonce and
	  treating it as a non-fatal response. Normally, this would cause
	  registration attempts to that endpoint to stop. (closes issue
	  ASTERISK-17138) Review: https://reviewboard.asterisk.org/r/2874/
	  Reported by: Rudi ........ Merged revisions 400137 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-28 22:21 +0000 [r400075-400093]  Matthew Jordan <mjordan@digium.com>

	* res/res_rtp_asterisk.c, /: res_rtp_asterisk: Correct erroneous
	  lost packet information in RTCP reports RTCP's calculation of the
	  number of lost packets in an RTP stream is based on that stream's
	  sequence number count, the number of received packets, and how
	  many packets we expect to receive. When the SSRC for an RTP
	  stream changes, there can - and almost always will be - a large
	  jump in the next packet's timestamp and sequence number. If we
	  don't reset the number of received packets, sequence number
	  count, and other metrics used by RTCP, the next RR/SR report will
	  use the previous SSRC's values to calculate the lost packet count
	  for the new SSRC - resulting in a very large number of lost
	  packets. This patch modifies res_rtp_asterisk such that, if it
	  detects a SSRC change, it will reset the various values used by
	  the RTCP calculations. From the perspective of RTCP, this appears
	  as a new media stream - which is what it is. Review:
	  https://reviewboard.asterisk.org/r/2886/ (closes issue AST-1174)
	  Reported by: Thomas Arimont ........ Merged revisions 400089 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, configure, configure.ac: Add check for openSUSE when detecting
	  bfd library In ASTERISK-17842, some additional library checks
	  were added to the configure script so that the bfd library could
	  be found on CentOS and Fedora systems. As it turns out, openSUSE
	  requires an additional library. This patch adds another check to
	  the configure script for openSUSE that will add that library.
	  Review: https://reviewboard.asterisk.org/r/2885/ (closes issue
	  AST-1169) Reported by: Guenther Kelleter ........ Merged
	  revisions 400073 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-27 21:35 +0000 [r400014]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/chan_sip.c, channels/sip/reqresp_parser.c: chan_sip:
	  Increase some scratch buffer sizes dealing with caller id. *
	  Eliminated an unnecessary initialization in check_user_full().
	  (closes issue ASTERISK-22477) Reported by: Michael Shepelev
	  ........ Merged revisions 400013 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-27 17:24 +0000 [r399962]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c, channels/sip/include/sip.h: chan_sip:
	  Reject calls on 200 OKs if no SDP has been received When Asterisk
	  receives a 200 OK in response to an invite, that peer should have
	  sent an SDP at some point by then. If the channel has never
	  received an SDP, media won't have been set and the remote address
	  won't be known. Endpoints in general should not be doing this.
	  This patch makes it so that Asterisk will simply hang up a call
	  if it sends a 200 OK at this point. So far this odd behavior for
	  endpoints has only been observed in tests which involved manually
	  created SIP transactions in SIPp. (closes issue ASTERISK-22424)
	  Reported by: Jonathan Rose Review:
	  https://reviewboard.asterisk.org/r/2827/ ........ Merged
	  revisions 399939 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-25 20:28 +0000 [r399834]  Richard Mudgett <rmudgett@digium.com>

	* channels/sig_ss7.c, channels/chan_dahdi.c, /: chan_dahdi: CLI
	  "core stop gracefully" has needless delay for PRI and SS7. The
	  PRI and SS7 link control threads are not stopped correctly when
	  the chan_dahdi.so module is unloaded. The link control threads
	  pri_dchannel() and ss7_linkset() are not awakened from a poll()
	  to cancel the thread. * Added a SIGURG signal after requesting
	  the thread cancel to break the link control thread poll()
	  immediately. For SS7 it was slightly worse, the link poll()
	  timeout would always be whatever was the last libss7 scheduled
	  event time used. If no libss7 scheduled event was pending, the
	  thread could run more often than necessary. * Set nextms to 60
	  seconds for the ss7_linkset() poll() if there is no other libss7
	  scheduled event. ........ Merged revisions 399818 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-25 19:27 +0000 [r399795]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_sip.c: Fix Realtime Peer Update Problem When
	  Un-registering And Expires Header In 200ok 1st Issue When a
	  realtime peer sends an un-REGISTER request, Asterisk un-registers
	  the peer but the database table record still has regseconds and
	  fullcontact for the peer. This results in calls attempting to be
	  routed to the peer which is no longer registered. The expected
	  behavior is to get busy/congested when attempting to call an
	  un-registered peer through the dialplan. What was discovered is
	  that we are clearing out the peer's registration in the database
	  in parse_register_contact() when calling expire_register() but
	  then upon returning from parse_register_contact(), update_peer()
	  is run which stores back in the database table regseconds and
	  fullcontact. 2nd Issue The reporter pointed out that the 200 ok
	  being returned by Asterisk after un-registering a peer contains a
	  Contact header with ;expires= and the Expires header is not set
	  to 0. This is actually a regression. Tests were created for this
	  second issue (ASTERISK-22548). The tests have been reviewed and a
	  Ship It! was received on those tests. This patch does the
	  following: * Do not ignore the Expires header value even when it
	  is set to 0. The patch sets the pvt->expiry earlier on in the
	  function so that it is set properly and used. * If pvt->expiry is
	  0, do not call update_peer since that means the peer has already
	  been un-registered and there is no need to update the database
	  record again since nothing has changed. (closes issue
	  ASTERISK-22428) Reported by: Ben Smithurst Tested by: Ben
	  Smithurst, Michael L. Young Patches:
	  asterisk-22428-rt-peer-update-and-expires-header.diff by Michael
	  L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2869/ ........ Merged
	  revisions 399794 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-24 20:20 +0000 [r399708]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/chan_iax2.c: chan_iax2: Prevent some needless
	  breaking of the native IAX2 bridge. * Clean up some twisted code
	  in the iax2_bridge() loop. * Add AST_CONTROL_VIDUPDATE and
	  AST_CONTROL_SRCCHANGE to a list of frames to prevent the native
	  bridge loop from breaking. * Passing the
	  AST_CONTROL_T38_PARAMETERS frame should also allow FAX over a
	  native IAX2 bridge. (issue ABE-2912) Review:
	  https://reviewboard.asterisk.org/r/2870/ ........ Merged
	  revisions 399697 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-20 22:35 +0000 [r399564]  Kinsey Moore <kmoore@digium.com>

	* main/config_options.c: Ensure global types in the config
	  framework are initialized If a config object was allocated but
	  one of its global objects was never encountered, then the global
	  object's defaults were never applied. Ensure that global objects
	  are initialized properly upon allocation instead of on
	  configuration. Review: https://reviewboard.asterisk.org/r/2866/

2013-09-20 14:23 +0000 [r399513]  Kevin Harwell <kharwell@digium.com>

	* main/logger.c: Fix memory leak in logger. Fixed a memory leak
	  discovered in the logger where a temporary string buffer was not
	  being freed. (closes issue ASTERISK-22540) Reported by: John
	  Hardin

2013-09-19 16:45 +0000 [r399457]  Jonathan Rose <jrose@digium.com>

	* /, channels/chan_sip.c: chan_sip: Make direct media reinvites for
	  T38 put Asterisk in the media path Prior to this patch, Asterisk
	  would incorrectly use the previous endpoint addresses in SDP in
	  spite of providing its own port. T38 is never meant to be done
	  through directmedia and Asterisk should always be in the media
	  path for these streams. (closes issue ASTERISK-17273) Reported
	  by: Kevin Stewart (closes issue ASTERISK-18706) Reported by:
	  Jeremy Kister Review: https://reviewboard.asterisk.org/r/2853/
	  ........ Merged revisions 399456 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-10-21  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.6.0 Released.

2013-10-18  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.6.0-rc2 Released.

	* Remove Port Restriction When Checking For NAT

	  When trying to determine if a peer is behind NAT, we should not be
	  using the ports when comparing addresses.
	  
	  This patch removes the port from being checked and just useds the
	  addresses now.

	* Properly copy/remove the device state cache flag over a masquerade.

	  In r378303 the AST_FLAG_DISABLE_DEVSTATE_CACHE flag was added that
	  tells	the devstate system to not cache states for non-real devices.
	  However, when optimizing away channels (ast_do_masquerade), that\
	  flag wasn't copied.

	  In my case, using Local devices as queue members created a situation
	  where the endpoint was considered in use, but the state change of the
	  device being available again was ignored (not cached). The endpoint
	  channel was optimized into the (previously) Local channel, but kept
	  the do-not-cache flag. The end result being that the queue member
	  apparently stayed in use forever.

	* Fix Setting A chan_sip Dialog's SIP_NAT_FORCE_RPORT Flag

	  A condition was added in a commit to fix ASTERISK-21374, that, if the
	  SIP_PAGE3_NAT_AUTO_RPORT flag was set, to then copy a peer's
	  SIP_NAT_FORCE_RPORT flag to the dialog.  This condition should not
	  have been there since	it assumed that if Asterisk is in an
	  environment where NAT is involved, that the auto_* nat settings or
	  force_rport setting would be on in the global settings. If the nat
	  setting in the global setting is set to 'nat=no' and then turned on
	  for peers (which is not quite the recommended way, although it is
	  allowed) this flag is never copied to the dialog resulting in
	  problems like, REGISTER replies going to the wrong port.

	  This patch removes this conditional check and will now always use the
	  peer's flag which by this point in the code the checks on whether the
	  peer is behind NAT or not (if using auto_force_rport) have already
	  been run.

	* Fix memory leak in logger

	  Fixed a memory leak discovered in the logger where a temporary string
	  buffer was not being freed.

2013-09-19  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.6.0-rc1 Released.

2013-09-18 23:36 +0000 [r399442]  Richard Mudgett <rmudgett@digium.com>

	* main/udptl.c: UDPTL: Backport some fixes from v12 that should be
	  in v11. Backported the following as applied to udptl.c: *
	  -r398020 Fixup udpdl defaults if config file not present. *
	  -r398533 Fixup improper use of ao2_global_obj_replace().

2013-09-18 19:55 +0000 [r399403]  Kinsey Moore <kmoore@digium.com>

	* main/abstract_jb.c, /: Fix jitter buffer log file creation This
	  adjusts '/'-to-'#' replacement to replace all instances of '/'
	  instead of just the first to ensure that the jitter buffer log
	  file gets the correct name as per Richard Kenner's suggestion.
	  (closes issue ASTERISK-21036) Reported by: Richard Kenner
	  ........ Merged revisions 399402 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-18 17:22 +0000 [r399353-399373]  Matthew Jordan <mjordan@digium.com>

	* /, build_tools/prep_tarball: Update prep_tarball with new
	  documentation files on the Asterisk wiki This will now pull both
	  a command reference for the version being prepared, as well as an
	  Admin Guide that applies to all versions of Asterisk. (issue
	  ASTERISK-22439) Reported by: Olle Johansson ........ Merged
	  revisions 399351 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* bridges/bridge_softmix.c: Add a WARNING in bridge_softmix when a
	  timing module isn't loaded If bridge_softmix fails to be created
	  because no timing source is present in Asterisk, this will
	  currently fail gracefully but with (most likely) a generic error
	  message by whatever module tried to create the softmix bridge.
	  This patch adds a more explicit warning so you can actually
	  diagnose and fix the problem. Review:
	  https://reviewboard.asterisk.org/r/2857/

2013-09-18 01:34 +0000 [r399305]  Michael L. Young <elgueromexicano@gmail.com>

	* /, main/features.c: Fix Segfault When Syntax Of A Line Under
	  [applicationmap] Is Invalid When processing the lines under the
	  [applicationmap] context in features.conf, a segfault occurs from
	  attempting to process a line with an invalid syntax (basically
	  missing most of the arguments). Example: [applicationmap]
	  automon=*6 * This patch moves the checking for empty arguments to
	  before they are accessed. * Also, checked the "todo" comment and
	  removed it. Some applications do not require arguments. (closes
	  issue ASTERISK-22416) Reported by: CGI.NET Tested by: CGI.NET
	  Patches: asterisk-22416-check-syntax-first_v2.diff by Michael L.
	  Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2803 ........ Merged revisions
	  399304 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-17 18:32 +0000 [r399222-399267]  Kevin Harwell <kharwell@digium.com>

	* main/asterisk.c, main/logger.c: Remote console: more output
	  discrepancies The remote console continued to have issues with
	  its output. In this case CLI command output would either not show
	  up (if verbose level = 0) or would contain verbose prefixes (if
	  verbose level > 0) once log messages were sent to the remote
	  console. The fix now now adds verbose prefix data to all new
	  lines contained in a verbose log string. (closes issue
	  ASTERISK-22450) Reported by: David Brillert (closes issue
	  AST-1193) Reported by: Guenther Kelleter Review:
	  https://reviewboard.asterisk.org/r/2825/

	* apps/confbridge/conf_state_multi_marked.c: Confbridge: empty
	  conference not being torn down Confbridge would not properly tear
	  down an empty conference bridge when all users were kicked via
	  end_marked=yes and at least one user was also set to wait_marked.
	  This occurred because while end_marked users were being kicked
	  and at least one was also set to wait_marked then the leave
	  wait_marked handler would be called on that user, but there would
	  be no waiting user (still considered active). The waiting users
	  would decrement and now be negative. The conference would remain,
	  but be put into an inactive state. The solution was to move from
	  the active list to the wait list, those users with wait_marked
	  set right before kicking. This allows both the active and wait
	  users to decrement correctly and the confbridge to tear down
	  properly. A crashed also occurred when trying to list the
	  specific conference from the CLI. This happened because the
	  conference specified was invalid. Since the conference properly
	  tears down now there is no way to reference it thus alleviating
	  the crash as well. (closes issue ASTERISK-21859) Reported by:
	  Chris Gentle Review: https://reviewboard.asterisk.org/r/2848/

2013-09-16 16:42 +0000 [r399159]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_iax2.c, /: chan_iax2: Fix saving the wrong expiry
	  time in astdb. When a new IAX2 client registers, the astdb
	  database is updated with the value of minregexpire defined in
	  iax.conf instead of using the expiry time that is provided by the
	  client. The provided expiry time of the client is updated after
	  inserting the astdb entry. As a consequence, restarting or
	  reloading asterisk creates clients whose registration may expire
	  before they reregister. The clients are therefore unavailable
	  after minregexpire seconds until they reregister. * Move updating
	  of the expiry time to before inserting into the astdb. (closes
	  issue ASTERISK-22504) Reported by: Stefan Wachtler Patches:
	  chan_iax2.c.patch (license #6533) patch uploaded by Stefan
	  Wachtler ........ Merged revisions 399158 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-13 20:49 +0000 [r399099]  David M. Lee <dlee@digium.com>

	* main/astobj2.c, /: Don't write to /tmp/refs when REF_DEBUG is not
	  defined. If MALLOC_DEBUG is enabled, then the debug destructor
	  for the container is used, which would erroneously write to
	  /tmp/refs. This patch only uses the debug destructor if ref_debug
	  is used. (closes issue ASTERISK-22536) ........ Merged revisions
	  399098 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-13 13:48 +0000 [r399034]  Kinsey Moore <kmoore@digium.com>

	* /, apps/app_meetme.c: Fix several crashes in MeetMeAdmin This
	  change ensures that MeetMeAdmin commands requiring a user
	  actually get a user and fixes another issue where an extra
	  dereference could occur for a last-entered user being ejected if
	  a user identifier was also provided. (closes issue
	  ASTERISK-21907) Reported by: Alex Epshteyn Review:
	  https://reviewboard.asterisk.org/r/2844/ ........ Merged
	  revisions 399033 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-12 20:19 +0000 [r398986]  Jonathan Rose <jrose@digium.com>

	* channels/sip/include/sip.h, /, channels/chan_sip.c: chan_sip:
	  Revert r398835 due to failing tests involving originate (issue
	  ASTERISK-22424) Reported by: Jonathan Rose ........ Merged
	  revisions 398977 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-12 00:02 +0000 [r398881-398885]  Rusty Newton <rnewton@digium.com>

	* /, apps/app_queue.c: 'queue add member' help text correction You
	  are adding dial strings to the queue, not channels. An aribitrary
	  string could be used, but you are typically referencing a
	  channel. Correcting the command help text. (issue ASTERISK-22263)
	  (closes issue ASTERISK-22263) Reported By: Rusty Newton ........
	  Merged revisions 398884 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* configs/chan_dahdi.conf.sample, /: Documentation fix -
	  waitfordialtone is not boolean, it's time in milliseconds
	  Changing text in chan_dahdi.conf sample to be accurate. (issue
	  ASTERISK-22308) (closes issue ASTERISK-22308) Reported By:
	  Malcolm Davenport ........ Merged revisions 398880 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-11 19:46 +0000 [r398836]  Jonathan Rose <jrose@digium.com>

	* channels/sip/include/sip.h, /, channels/chan_sip.c: chan_sip:
	  Reject calls without prior SDP on 200 OK If we receive a 200 OK
	  without SDP, we will now check to see if the remote address has
	  been established for that channel's RTP session and if the to tag
	  for that channel has changed from the most recent to tag in a
	  response less than 200. If either a change has been made since
	  the last to-tag was received or the remote address is unset, then
	  we will drop the call. (closes issue ASTERISK-22424) Reported by:
	  Jonathan Rose Review:
	  https://reviewboard.asterisk.org/r/2827/diff/#index_header
	  ........ Merged revisions 398835 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-11 18:01 +0000 [r398820]  Russell Bryant <russell@russellbryant.com>

	* configs/confbridge.conf.sample: Fix typo in
	  confbridge.conf.sample The denoise filter requires func_speex,
	  not codec_speex. Fix this in the description of the denoise=yes
	  option in confbridge.conf.

2013-09-10 17:56 +0000 [r398758]  Richard Mudgett <rmudgett@digium.com>

	* main/event.c, res/res_musiconhold.c, main/indications.c,
	  main/asterisk.c, main/xmldoc.c, main/cli.c, /,
	  funcs/func_dialgroup.c, main/heap.c: Fix incorrect usages of
	  ast_realloc(). There are several locations in the code base where
	  this is done: buf = ast_realloc(buf, new_size); This is going to
	  leak the original buf contents if the realloc fails. Review:
	  https://reviewboard.asterisk.org/r/2832/ ........ Merged
	  revisions 398757 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-10 17:48 +0000 [r398749-398753]  David M. Lee <dlee@digium.com>

	* utils/check_expr.c, /: Fixed utils directory breakage from
	  r398748, this time with extra hate. ........ Merged revisions
	  398752 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* utils/ael_main.c, utils/conf2ael.c, utils/check_expr.c, /: Fixed
	  utils directory breakage from r398648 ........ Merged revisions
	  398748 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-09 23:21 +0000 [r398721]  Richard Mudgett <rmudgett@digium.com>

	* /, main/astmm.c: MALLOC_DEBUG: Change fence magic number to be
	  completely different from the freed magic number. Race conditions
	  between freeing a nul terminated string and ast_strdup()'ing it
	  are more likely to be detected if the fence and freed magic
	  numbers are completely different. ........ Merged revisions
	  398703 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-09 20:02 +0000 [r398649]  David M. Lee <dlee@digium.com>

	* main/lock.c, /, main/utils.c, include/asterisk/lock.h: Fix
	  DEBUG_THREADS when lock is acquired in __constructor__ This patch
	  fixes some long-standing bugs in debug threads that were
	  exacerbated with recent Optional API work in Asterisk 12. With
	  debug threads enabled, on some systems, there's a lock ordering
	  problem between our mutex and glibc's mutex protecting its module
	  list (Ubuntu Lucid, glibc 2.11.1 in this instance). In one
	  thread, the module list will be locked before acquiring our
	  mutex. In another thread, our mutex will be locked before locking
	  the module list (which happens in the depths of calling
	  backtrace()). This patch fixes this issue by moving backtrace()
	  calls outside of critical sections that have the mutex acquired.
	  The bigger change was to reentrancy tracking for
	  ast_cond_{timed,}wait, which wrongly assumed that waiting on the
	  mutex was equivalent to a single unlock (it actually suspends all
	  recursive locks on the mutex). (closes issue ASTERISK-22455)
	  Review: https://reviewboard.asterisk.org/r/2824/ ........ Merged
	  revisions 398648 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-07 00:59 +0000 [r398510-398618]  Kinsey Moore <kmoore@digium.com>

	* res/res_xmpp.c: Prevent XMPP timeout on blank responses Sometimes
	  the Google Voice servers have a bad habit of sending out 1 byte
	  replies to the xmpp resource. When a blank 1 byte reply is
	  received from the socket the buffer attempts to wait (endlessly)
	  for the rest of the reply from google which effectively blocks
	  the socket and google voice calls will no longer come into the
	  server. This patch allows the xmpp module to correctly detect
	  empty packets and send out ping replies to google. It also sets a
	  socket timeout on the default socket which prevents the xmpp
	  socket from closing and preventing future google voice calls from
	  coming into the server. Furthermore instead of sending an empty
	  reply back to google we send a proper xmpp ping reply back. This
	  also adds several more socket messages. (closes issue
	  ASTERISK-22347) Reported by: Andrew Nagy Review:
	  https://reviewboard.asterisk.org/r/2771 Patches: xmpp_fix_1.diff
	  uploaded by Andrew Nagy (License #6524)

	* /, res/res_xmpp.c, res/res_jabber.c: Commit the remainder of
	  r398523 This is a missing part of the commit in revision 398523
	  that corrects the name of a variable. (issue ASTERISK-22435)
	  ........ Merged revisions 398576 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, res/res_xmpp.c, res/res_jabber.c: Fix Jabber/XMPP distributed
	  MWI The mailbox and context are swapped on the receiving end for
	  all users of Jabber and XMPP distributed MWI in Asterisk 1.8 and
	  all more recent versions. This swaps those values to be correct
	  when publishing to the internal event system from Jabber/XMPP
	  distributed MWI state. (closes issue ASTERISK-22435) Reported by:
	  abelbeck Tested by: Michael Keuter Patches:
	  asterisk-1.8-res_jabber-aji_handle_pubsub_event.patch uploaded by
	  abelbeck asterisk-11-res_xmpp-xmpp_pubsub_handle_event.patch
	  uploaded by abelbeck ........ Merged revisions 398523 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_h323.c: Fix chan_h323 compilation This fixes the
	  things in chan_h323 that were missed or ignored in the great
	  channel opaquification and gets chan_h323 back into a compiling
	  state. (closes issue ASTERISK-22365) Reported by: Dmitry Melekhov
	  Patches: chan_h323.patch uploaded by Dmitry Melekhov

2013-09-05 19:13 +0000 [r398302-398457]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_iax2.c, /: chan_iax2: Reduce indentation in
	  __attempt_transmit(). * Reduce indentation in
	  __attempt_transmit(). * Don't update the static last error time
	  variable every time in __schedule_action() and socket_read().
	  ........ Merged revisions 398456 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_iax2.c, /: chan_iax2: Fix stray reference to worker
	  thread idle_list. * Fix stray reference to idle_list in
	  cleanup_thread_list(). This may be the reason for the note in
	  iax2_process_thread() about threads not being removed from the
	  task lists. * Move cleanup_thread_list(&idle_list) to after the
	  other lists are cleaned up. ........ Merged revisions 398416 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_iax2.c, /: chan_iax2: Fix bridgecallno deadlock
	  avoidance. * Fix bridgecallno deadlock avoidance. When doing
	  deadlock avoidance, you need to retest the status of values for
	  each loop to see if you still need the lock for bridgecallno. *
	  As a safety check, after acquiring the bridgecallno lock you
	  should check if iaxs[bridgecallno] is NULL just like the current
	  callno checks. * Move setting thread->iostate to IAX_IOSTATE_IDLE
	  to after processing any deferred frames to ensure that the
	  iostate is IDLE when it is placed back into the idle list.
	  defer_full_frame() tries to ensure iax2_process_thread() wakes up
	  to process the frame. ........ Merged revisions 398379 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/iax2-parser.c: chan_iax2: Add missing control frame
	  names to debug frame decode output. (Part 2)

	* channels/iax2-parser.c, /: chan_iax2: Add missing control frame
	  names to debug frame decode output. ........ Merged revisions
	  398301 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-04 21:33 +0000 [r398281-398285]  Jonathan Rose <jrose@digium.com>

	* tests/test_voicemail_api.c: unit tests: test_voicemail_api leaks
	  stringfields from snapshots (closes issue ASTERISK-22414)
	  Reported by: Corey Farrell Patches:
	  test_voicemail_api-leaks-11.patch uploaded by coreyfarrell
	  (license 5909)

	* apps/app_voicemail.c: app_voicemail: Fix leaking config objects
	  when msg_id doesn't match (issues ASTERISK-22414) Reported by:
	  Corey Farrell Patch: test_voicemail_api-leaks-11.patch uploaded
	  by coreyfarrell (license 5909)

2013-09-04 15:57 +0000 [r398236]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_misdn.c, /: chan_misdn: Fix misdn debug output
	  printed with arbitrary verbose levels. Fix the misdn debug output
	  to remote consoles. chan_misdn uses ast_console_puts() which
	  doesn't know about verbose levels. Better to use ast_verbose()
	  instead. Without this patch the misdn debug messages are appended
	  to the verbose level which ever was set by the message sent to
	  the console before, i.e. any undefined level. (closes issue
	  AST-1218) Reported by: Guenther Kelleter Patches: misdnlog.patch
	  (license #6372) patch uploaded by Guenther Kelleter ........
	  Merged revisions 398235 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-09-03 19:45 +0000 [r398214]  Alexandr Anikin <may@telecom-service.ru>

	* addons/ooh323c/src/ooh245.c: Fix remote tcs sequence handling on
	  empty tcs received

2013-09-02 07:28 +0000 [r398168]  Walter Doekes <walter+asterisk@wjd.nu>

	* /, cel/cel_custom.c: Be a little more verbose when loading
	  cel_custom.conf. Review: https://reviewboard.asterisk.org/r/2805/
	  ........ Merged revisions 398167 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-30 19:16 +0000 [r398022-398103]  Kevin Harwell <kharwell@digium.com>

	* main/indications.c, main/config.c, res/res_security_log.c, /,
	  channels/chan_sip.c, main/translate.c, main/named_acl.c: Fix
	  various memory leaks main/config.c - cleanup cache fie includes
	  res/res_security_log.c - unregister logger level
	  channesl/chan_sip.c - cleanup io context and notify_types
	  main/translator.c - cleanup at shutdown main/named_acl.c -
	  cleanup cli commands main/indications.c -
	  ast_get_indication_tone() unref default_tone_zone if used (closes
	  issues ASTERISK-22378) Reported by: Corey Farrell Patches:
	  config_shutdown.patch uploaded by coreyfarrell (license 5909)
	  res_security_log.patch uploaded by coreyfarrell (license 5909)
	  chan_sip-11.patch uploaded by coreyfarrell (license 5909)
	  indications_refleak.patch uploaded by coreyfarrell (license 5909)
	  named_acl-cli_unreg-11.patch uploaded by coreyfarrell (license
	  5909) translate_shutdown.patch uploaded by coreyfarrell (license
	  5909) ........ Merged revisions 398102 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* res/res_agi.c, main/manager.c, /: Memory leak fix
	  ast_xmldoc_printable returns an allocated block that must be
	  freed by the caller. Fixed manager.c and res_agi.c to stop
	  leaking these results. (closes issue ASTERISK-22395) Reported by:
	  Corey Farrell Patches: manager-leaks-11.patch uploaded by
	  coreyfarrell (license 5909) res_agi-xmldoc-leaks.patch uploaded
	  by coreyfarrell (license 5909) ........ Merged revisions 398060
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/features.c: Fix memory leak Fixed a features.c test that
	  leaked a reference to a parked call. This caused chancount to
	  never reach 0, so graceful shutdown stops. Also added an
	  unregister test. (closes issue ASTERISK-22413) Reported by: Corey
	  Farrell Patches: features-TEST_FRAMEWORK.patch uploaded by
	  coreyfarrell (license 5909) ........ Merged revisions 398021 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-30 16:57 +0000 [r398019]  Richard Mudgett <rmudgett@digium.com>

	* tests/test_substitution.c, /: test_substituition: Fix failed test
	  reporting to actually report failure. You cannot put the "Testing
	  <blah> pass/fail" on a single line before actually performing the
	  test. Now any additional failure information is logged before the
	  test pass/fail announcement. * Added an additional CDR(answer,u)
	  test. ........ Merged revisions 398018 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-30 16:20 +0000 [r397948-398011]  Kevin Harwell <kharwell@digium.com>

	* /, apps/app_mixmonitor.c: Fix memory leaks (closes issue
	  ASTERISK-22368) Reported by: Corey Farrell Patches:
	  issueA22368_mixmonitor_free_filename.patch uploaded by wdoekes
	  (license 5674) ........ Merged revisions 398004 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* main/asterisk.c: Check return value on fwrite

	* channels/chan_misdn.c, apps/app_dumpchan.c, main/features.c,
	  main/logger.c, apps/app_verbose.c, main/asterisk.c: Verbose
	  logging discrepancies Refactored cases where a combination of
	  ast_verbose/options_verbose were present. Also in general tried
	  to eliminate, in as many places as possible, where the
	  options_verbose global variable was being used. Refactored the
	  way local and remote consoles handle verbose message logging in
	  an attempt to solve the various discrepancies that sometimes
	  would show between the two. (closes issue AST-1193) Reported by:
	  Guenther Kelleter Review:
	  https://reviewboard.asterisk.org/r/2798/

2013-08-27 18:03 +0000 [r397758]  Matthew Jordan <mjordan@digium.com>

	* /, channels/chan_sip.c: AST-2013-005: Fix crash caused by invalid
	  SDP If the SIP channel driver processes an invalid SDP that
	  defines media descriptions before connection information, it may
	  attempt to reference the socket address information even though
	  that information has not yet been set. This will cause a crash.
	  This patch adds checks when handling the various media
	  descriptions that ensures the media descriptions are handled only
	  if we have connection information suitable for that media. Thanks
	  to Walter Doekes, OSSO B.V., for reporting, testing, and
	  providing the solution to this problem. (closes issue
	  ASTERISK-22007) Reported by: wdoekes Tested by: wdoekes patches:
	  issueA22007_sdp_without_c_death.patch uploaded by wdoekes
	  (License 5674) ........ Merged revisions 397756 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 397757 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2013-08-27 16:40 +0000 [r397744]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_sip.c, channels/chan_motif.c, channels/chan_iax2.c,
	  channels/sig_pri.c, channels/sig_ss7.c, channels/chan_dahdi.c,
	  channels/sig_analog.c: Fix uninitialized value in struct
	  ast_control_pvt_cause_code usage.

2013-08-27 15:55 +0000 [r397712]  Matthew Jordan <mjordan@digium.com>

	* /, channels/chan_sip.c: AST-2013-004: Fix crash when handling ACK
	  on dialog that has no channel A remote exploitable crash
	  vulnerability exists in the SIP channel driver if an ACK with SDP
	  is received after the channel has been terminated. The handling
	  code incorrectly assumed that the channel would always be
	  present. This patch adds a check such that the SDP will only be
	  parsed and applied if Asterisk has a channel present that is
	  associated with the dialog. Note that the patch being applied was
	  modified only slightly from the patch provided by Walter Doekes
	  of OSSO B.V. (closes issue ASTERISK-21064) Reported by: Colin
	  Cuthbertson Tested by: wdoekes, Colin Cutherbertson patches:
	  issueA21064_fix.patch uploaded by wdoekes (License 5674) ........
	  Merged revisions 397710 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 397711 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2013-08-23 21:57 +0000 [r397604]  Joshua Colp <jcolp@digium.com>

	* res/res_rtp_asterisk.c, UPGRADE.txt, res/Makefile: Make libuuid
	  an optional dependency for res_rtp_asterisk instead of a
	  requirement. Review: https://reviewboard.asterisk.org/r/2777/

2013-08-23 16:07 +0000 [r397528]  Richard Mudgett <rmudgett@digium.com>

	* main/utils.c, include/asterisk/lock.h, main/astmm.c,
	  channels/sig_pri.c, main/astobj2.c, include/asterisk/logger.h,
	  main/lock.c, include/asterisk/utils.h, include/asterisk/astmm.h,
	  /, main/logger.c: Fix memory corruption when trying to get "core
	  show locks". Review https://reviewboard.asterisk.org/r/2580/
	  tried to fix the mismatch in memory pools but had a math error
	  determining the buffer size and didn't address other similar
	  memory pool mismatches. * Effectively reverted the previous patch
	  to go in the same direction as trunk for the returned memory pool
	  of ast_bt_get_symbols(). * Fixed memory leak in
	  ast_bt_get_symbols() when BETTER_BACKTRACES is defined. * Fixed
	  some formatting in ast_bt_get_symbols(). * Fixed sig_pri.c
	  freeing memory allocated by libpri when MALLOC_DEBUG is enabled.
	  * Fixed __dump_backtrace() freeing memory from
	  ast_bt_get_symbols() when MALLOC_DEBUG is enabled. * Moved
	  __dump_backtrace() because of compile issues with the utils
	  directory. (closes issue ASTERISK-22221) Reported by: Matt Jordan
	  Review: https://reviewboard.asterisk.org/r/2778/ ........ Merged
	  revisions 397525 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-22 08:22 +0000 [r397378]  Walter Doekes <walter+asterisk@wjd.nu>

	* default.exports, /, main/asterisk.exports.in: Add _IO_stdin_used
	  in version-script to fix SIGBUSes on Sparc. The
	  --version-script,asterisk.exports linker flag (and the module
	  exports) didn't provide _IO_stdin_used in the list of exported
	  symbols. That causes some kind of libc compatibility mode to kick
	  in, where stdio file structures (stdout/stderr) land somewhere
	  else. In the case of the Sparc, they landed on misaligned memory.
	  This became apparent first after r376428 (Reorder startup
	  sequence) when a lot of ast_log's were replaced with fprintf's.
	  Writing to stderr triggered a SIGBUS. (Compared to x86 and amd64
	  architectures, the Sparc is very picky about memory alignment.)
	  (issue ASTERISK-21763) (issue ASTERISK-21665) Reported by: Jeremy
	  Kister Review: https://reviewboard.asterisk.org/r/2760/ ........
	  Merged revisions 397377 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-21 23:02 +0000 [r397365]  Jonathan Rose <jrose@digium.com>

	* main/udptl.c: UDPTL: Fix a regression where UDPTL won't load
	  default settings If the file udptl.conf is unavailable at
	  startup, UDPTL will fail to initialize and while it makes some
	  noise, it isn't immediately obvious why consumers start to fail
	  when using it. This patch makes UDPTL load as though an empty
	  config was provided when udptl is unavailable at startup. (closes
	  issue ASTERISK-22349) Reported by: Jonathan Rose Review:
	  https://reviewboard.asterisk.org/r/2773/

2013-08-21 17:07 +0000 [r397309]  David M. Lee <dlee@digium.com>

	* /, main/http.c: Complete http_shutdown. This patch frees up some
	  resources allocated in http.c. * tcp listeners stopped * tls
	  settings freed * uri redirects freed * unregister internal http.c
	  uri's (closes issue ASTERISK-22237) Reported by: Corey Farrell
	  Patches: http.patch uploaded by Corey Farrell (license 5909)
	  ........ Merged revisions 397308 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-21 15:12 +0000 [r397257]  Matthew Jordan <mjordan@digium.com>

	* /, include/asterisk/frame.h: Set 14400 as the default max bit
	  rate if T38MaxBitRate is not specified If an endpoint fails to
	  include the T38MaxBitRate attribute during negotiation, Asterisk
	  will negotiate a bit rate of 2400 instead of the ITU recommended
	  bit rate of 14400. This patch fixes this by making
	  AST_T38_RATE_14400 the 'default' value of the enum by assigning
	  it a value of 0, such that if an endpoint fails to include the
	  attribute, the default will be 14400. Note that Walter Doekes
	  included the nice comment in frame.h about why we are
	  purposefully assigning AST_T38_RATE_14400 a value of 0. (closes
	  issue ASTERISK-22275) Reported by: Andreas Steinmetz patches:
	  fax-fix.patch uploaded by anstein (License 6523) ........ Merged
	  revisions 397256 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-21 14:36 +0000 [r397254]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Prevent a crash on outbound SIP MESSAGE
	  requests. If a From header on an outbound out-of-call SIP MESSAGE
	  were malformed, the result could crash Asterisk. In addition, if
	  a From header on an incoming out-of-call SIP MESSAGE request were
	  malformed, the message was happily accepted rather than being
	  rejected up front. The incoming message path would not result in
	  a crash, but the behavior was bad nonetheless. (closes issue
	  ASTERISK-22185) reported by Zhang Lei

2013-08-21 02:11 +0000 [r397205]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_sip.c: Fix Not Storing Current Incoming Recv
	  Address In 1.8, r384779 introduced a regression by retrieving an
	  old dialog and keeping the old recv address since recv was
	  already set. This has caused a problem when a proxy is involved
	  since responses to incoming requests from the proxy server, after
	  an outbound call is established, are never sent to the correct
	  recv address. In 11, r382322 introduced this regression. The fix
	  is to revert that change and always store the recv address on
	  incoming requests. Thank you Walter Doekes for helping to point
	  out this error and Mark Michelson for your input/review of the
	  fix. (closes issue ASTERISK-22071) Reported by: Alex Zarubin
	  Tested by: Alex Zarubin, Karsten Wemheuer Patches:
	  asterisk-22071-store-recvd-address.diff by Michael L. Young
	  (license 5026) ........ Merged revisions 397204 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-20 17:41 +0000 [r397133-397157]  Mark Michelson <mmichelson@digium.com>

	* /, channels/chan_sip.c: Remove REF_DEBUG definition. ........
	  Merged revisions 397156 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c, channels/sip/dialplan_functions.c: Fix
	  refcounting of sip_pvt in test_sip_rtpqos test and unlink it from
	  the list of pvts. (closes issue ASTERISK-22248) reported by Corey
	  Farrell patches: test_sip_rtpqos.patch uploaded by Corey Farrell
	  (license #5909) ........ Merged revisions 397112 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-20 15:27 +0000 [r397034-397107]  Kinsey Moore <kmoore@digium.com>

	* /, main/threadstorage.c, main/astfd.c: Unregister CLI commands on
	  exit This patch ensures that CLI commands enabled by
	  DEBUG_FD_LEAKS and DEBUG_THREADLOCALS are cleaned up properly on
	  exit. (closes issue ASTERISK-22238) Reported by: Corey Farrell
	  Tested by: Corey Farrell Patches: debug_cli_unregister.patch
	  uploaded by Corey Farrell ........ Merged revisions 397106 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/xmldoc.c, /: Fix xmldoc memory leak This fixes a
	  single-attribute memory leak that was occurring when the
	  "required" attribute was not true. (closes issue ASTERISK-22249)
	  Reported by: Corey Farrell Tested by: Corey Farrell Patches:
	  xmldoc-free_attr_required.patch uploaded by Corey Farrell
	  ........ Merged revisions 397064 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/cel.c, /: Protect CEL from an invalid config on reload This
	  patch fixes CEL to properly handle an invalid config on reload.
	  (closes issue ASTERISK-22259) Reported by: Corey Farrell Tested
	  by: Corey Farrell Patches: cel-config.patch uploaded by Corey
	  Farrell ........ Merged revisions 397033 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-20 11:47 +0000 [r396995]  Walter Doekes <walter+asterisk@wjd.nu>

	* configs/h323.conf.sample, /, configs/sip.conf.sample: Add
	  "autoframing" option to sip.conf.sample and h323.conf.sample. The
	  autoframing option was added to chan_sip.c in r43243 (mogorman,
	  2006-09-19 01:32:57), but never made its way into the sample
	  configs. Review: https://reviewboard.asterisk.org/r/2768/
	  ........ Merged revisions 396994 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-20 01:18 +0000 [r396944-396961]  Matthew Jordan <mjordan@digium.com>

	* main/data.c, /: Fix invalid access to disposed memory in
	  main/data unit test It is not safe to iterate over a macro'd list
	  of ao2 objects, deref them such that the item's destructor is
	  called, and leave them in the list. The list macro to iterate
	  over items requires the item to be a valid allocated object in
	  order to proceed to the next item; with MALLOC_DEBUG on the
	  corruption of the linked list is caught in the crash. This patch
	  fixes the invalid access to free'd memory by removing the ao2
	  item from the list before de-refing it. Note that this is a
	  backport of r396915 from Asterisk trunk. ........ Merged
	  revisions 396958 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/app_queue.c: Let Queue wrap up time influence member
	  availability Queue members who happen to be in multiple queues at
	  the same time may not have any wrap up time. This problem
	  occurred due to a code change in Asterisk 11.3.0 that unified
	  device state tracking of Queue members in multiple Queues (which
	  fixed some other problems, but unfortunately caused this one).
	  This patch fixes the behavior by having the is_member_available
	  function check the queue's wrap up time and the time of the
	  member's last call, such that for a particular queue, the member
	  won't be considered available if their last call is within the
	  wrap up time. (closes issue ASTERISK-22189) Reported by: Tony
	  Lewis Tested by: Tony Lewis

	* apps/app_meetme.c: Resolve conflicts between
	  CONFFLAG_DONT_DENOISE and CONFFLAG_INTROUSER_VMREC When r382230
	  added an option to not denoise the MeetMe conference (if a user
	  had a channel whose format's sample rate changed frequently, for
	  example), the value added was the maximum allowed value for the
	  constants that define the options for MeetMe in 1.8. Not so in 11
	  - unfortunately, the option CONFFLAG_DONT_DENOISE conflicts with
	  CONFFLAG_INTROUESR_VMREC. This patch fixes that, and also tweaks
	  one of the way in which the constants was declared for
	  consistency. Thanks to Tony Mountifield for pointing out the
	  problem and solution. (closes issue ASTERISK-22269) Reported by:
	  Tony Mountifield

2013-08-16 22:45 +0000 [r396884]  John Bigelow <jbigelow@digium.com>

	* main/features.c: Add test suite events to indicate when a feature
	  is detected or not These are needed by the bridge test suite
	  tests for them to be able to run against Asterisk 11. Review:
	  https://reviewboard.asterisk.org/r/2751/

2013-08-15 16:29 +0000 [r396746]  Kinsey Moore <kmoore@digium.com>

	* main/asterisk.c, main/cli.c, /: Remove leading spaces from the
	  CLI command before parsing If you've mistakenly put a space
	  before typing in a command, the leading space will be included as
	  part of the command, and the command parser will not find the
	  corresponding command. This patch rectifies that situation by
	  stripping the leading spaces on commands. Review:
	  https://reviewboard.asterisk.org/r/2709/ Patch-by: Tilghman
	  Lesher ........ Merged revisions 396745 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-14 19:06 +0000 [r396620-396657]  Joshua Colp <jcolp@digium.com>

	* tests/test_hashtab_thrash.c, /: Tweak comment for why usleep is
	  used. ........ Merged revisions 396656 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, tests/test_hashtab_thrash.c: Tweak test_hashtab_thrash test to
	  allow the critical threads to execute. Depending on certain
	  conditions it was possible for the hashtab counting thread to
	  starve other threads, preventing them from executing in the
	  expected fashion. This change adds a sleep to allow the others to
	  do what they need to do. While this doesn't thrash the hashtab as
	  much as previously, it at least works. (closes issue
	  ASTERISK-22276) Reported by: Matt Jordan ........ Merged
	  revisions 396619 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-13 18:45 +0000 [r396580-396583]  Walter Doekes <walter+asterisk@wjd.nu>

	* /, channels/chan_sip.c: chan_sip: Convert 'just did sched_add
	  waitid...' from warning to debug message. Patches:
	  reviewboard-2377.patch uploaded by Paul Belanger Review:
	  https://reviewboard.asterisk.org/r/2377/ ........ Merged
	  revisions 396582 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: chan_sip: Fix IP-addr in warning when
	  rejecting a contact ACL. Patches: reviewboard-2155.patch uploaded
	  by Paul Belanger Review: https://reviewboard.asterisk.org/r/2155/
	  ........ Merged revisions 396579 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-08 20:21 +0000 [r396441]  Walter Doekes <walter+asterisk@wjd.nu>

	* include/asterisk/logger.h, /, main/logger.c, main/utils.c,
	  main/astobj2.c: Consistent memory allocation by
	  ast_bt_get_symbols. Always use ast_alloc/ast_free. This is
	  handled differently in trunk (r391012). Review:
	  https://reviewboard.asterisk.org/r/2580/ ........ Merged
	  revisions 396427 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-08 07:03 +0000 [r396377]  Igor Goncharovskiy <igor.goncharovsky@gmail.com>

	* channels/chan_unistim.c: - Fix different issues with call
	  transfer cancel. In case 3rd party busy or congestion call was
	  not returned. - Fix displaying soft button 'Redial' in case of no
	  redial number exists

2013-08-06 08:37 +0000 [r396287-396310]  Walter Doekes <walter+asterisk@wjd.nu>

	* funcs/func_strings.c: Check result of ast_var_assign() calls for
	  memory allocation failure (2). Missed a spot in the previous
	  commit.

	* apps/app_stack.c, apps/app_playback.c, funcs/func_global.c,
	  main/cdr.c, pbx/pbx_loopback.c, main/pbx.c, /,
	  funcs/func_strings.c, pbx/pbx_dundi.c, utils/extconf.c: Check
	  result of ast_var_assign() calls for memory allocation failure.
	  We try to keep the system running even when all available memory
	  is spent. Review: https://reviewboard.asterisk.org/r/2734/
	  ........ Merged revisions 396279 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-08-05 20:19 +0000 [r396197-396248]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_sip.c: Fix Registration Failure When A Peer And
	  TLS Are Used If a peer is used in a register line and TLS is
	  defined as the transport, the registration fails since the
	  transport on the dialog is never set properly resulting in UDP
	  being used instead of TLS. This patch sets the dialog's transport
	  based on the transport that was defined in the register line. If
	  the register line does not specify a transport, the parsing
	  function for the register line always defaults back to UDP.
	  (closes issue ASTERISK-21964) Reported by: Doug Bailey Tested by:
	  Doug Bailey Patches: asterisk-21964-set-reg-dialog-transport.diff
	  by Michael L. Young (license 5026) ........ Merged revisions
	  396240 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* UPGRADE.txt: Change "from" to "From". (related to issue
	  ASTERISK-21903)

	* /, UPGRADE.txt: Adding a note to UPGRADE.txt about a change made
	  to res_agi in order to indicate when streaming an audio file
	  fails like it is done in other parts of the code to indicate an
	  error. Note was requested by Paul Belanger:
	  http://lists.digium.com/pipermail/asterisk-dev/2013-July/061420.html
	  (related to issue ASTERISK-21903) ........ Merged revisions
	  396196 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-07-22 13:50 +0000 [r394890-395033]  Matthew Jordan <mjordan@digium.com>

	* main/asterisk.c, /: Update copyright year to 2013 in asterisk.c;
	  some whitespace fixes (closes issue ASTERISK-22179) Reported by:
	  Malcolm Davenport ........ Merged revisions 395032 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* CHANGES, UPGRADE.txt: Add an upgrade note for libuuid dependency;
	  remove note in CHANGES This patch notes that libuuid is now a
	  dependency for res_rtp_asterisk; this was introduced in between
	  11.4.0 and 11.5.0 to resolve a dependency for pjproject, which
	  res_rtp_asterisk uses for ICE/STUN/TURN support. It also removes
	  a conflicting note from CHANGES. While support for playing
	  prompts to the first participant was added for app_queue, it was
	  disabled by default and an option added to enable it. That was
	  properly noted in the UPGRADE.txt file.

	* /, funcs/func_channel.c: Clean up documentation This patch cleans
	  up documentation in func_channel for the following items: *
	  rtpsource * secure_signaling * secure_media * various OOH323
	  parameters (closes issue ASTERISK-20969) Reported by: snuffy
	  patches: func_chan-update.diff uploaded by snuffy (License 5024)
	  ........ Merged revisions 394980 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, configs/indications.conf.sample: Provide proper ring tone in
	  indications.conf for Malaysia The ring tone provided in the
	  sample indications.conf was incorrect. This patch modifies the
	  sample ring tone to be what it should: ring =
	  425/400,0/200,425/400,0/2000 This brings it in line with the tone
	  definition in DAHDI 2.7.0. (zonedata.c) (closes issue
	  ASTERISK-21997) Reported by: Filip Jenicek patches:
	  malaysia_ring.patch uploaded by phill (License 6277) ........
	  Merged revisions 394940 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/http.c, /: Tolerate presence of RFC2965 Cookie2 header by
	  ignoring it This patch modifies parsing of cookies in Asterisk's
	  http server by doing an explicit comparison of the "Cookie"
	  header instead of looking at the first 6 characters to determine
	  if the header is a cookie header. This avoids parsing "Cookie2"
	  headers and overwriting the previously parsed "Cookie" header.
	  Note that we probably should be appending the cookies in each
	  "Cookie" header to the parsed results; however, while clients can
	  send multiple cookie headers they never really do. While this
	  patch doesn't improve Asterisk's behavior in that regard, it
	  shouldn't make it any worse either. Note that the solution in
	  this patch was pointed out on the issue by the issue reporter,
	  Stuart Henderson. (closes issue ASTERISK-21789) Reported by:
	  Stuart Henderson Tested by: mjordan, Stuart Henderson ........
	  Merged revisions 394899 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* contrib/realtime/postgresql/realtime.sql, /: Update PostgreSQL
	  realtime scripts with schema for queue_log table This patch
	  updates the realtime SQL scripts with an entry that will create
	  the queue_log table. This brings the PostgreSQL scripts inline
	  with the MySQL scripts, with respect to what tables they will
	  create. (closes issue ASTERISK-21021) Reported by: Eugene
	  patches: queue_log.sql uploaded by varnav (license 6360) ........
	  Merged revisions 394896 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* configs/iax.conf.sample, /: Document connectedline parameter for
	  chan_iax2 The connectedline parameter for a chan_iax2 peer was
	  undocumented. This patch documents the options in the sample
	  configuration file. (closes issue ASTERISK-21953) Reported by:
	  Birger "WIMPy" Harzenetter ........ Merged revisions 394886 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-07-18 12:52 +0000 [r394641]  Michael L. Young <elgueromexicano@gmail.com>

	* res/res_agi.c, /: Properly indicate failure to open an audio
	  stream in res_agi If there is an error streaming an audio file,
	  the current return status makes it difficult for an AGI script to
	  determine that there was an error with the audio file. This
	  patches changes the result to return -1 and the function returns
	  RESULT_FAILURE instead of RESULT_SUCCESS. From looking at other
	  parts of res_agi, this would appear to be the proper way to
	  handle an error. (closes issue ASTERISK-21903) Reported by: Ariel
	  Wainer Tested by: Ariel Wainer Patches:
	  asterisk-21903-return-stream-res_1.8.diff by Michael L. Young
	  (license 5026) Review: https://reviewboard.asterisk.org/r/2625/
	  ........ Merged revisions 394640 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-07-14 02:34 +0000 [r394303-394345]  Matthew Jordan <mjordan@digium.com>

	* apps/app_queue.c: Provide error message for QUEUE_MEMBER when
	  member is not in queue When QUEUE_MEMBER is used and the member
	  specified is not in the queue, Asterisk provides an ERROR message
	  that indicates that the option specified is not valid. This patch
	  now properly displays an ERROR message that the member is not in
	  the queue if an interface is specified. (closes issue
	  ASTERISK-21980) Reported by: Avraam David

	* /, funcs/func_strings.c: Clarify documentation for function
	  PASSTHRU It is not apparent to the average user that the PASSTHRU
	  function should not be passed as ${PASSTHRU(string)} but just as
	  PASSTHRU(string) to functions which take a variable name and not
	  its contents. This patch clarifies the behavior in the
	  documentation and provides an example. (closes issue
	  ASTERISK-21717) Reported by: Richard Miller patches:
	  func_strings.diff uploaded by Richard Miller (license 5685)
	  ........ Merged revisions 394302 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-07-11 21:28 +0000 [r394173]  Moises Silva <moises.silva@gmail.com>

	* channels/chan_dahdi.c, /: Fix a longstanding issue with MFC-R2
	  configuration that prevented users from mixing different variants
	  or general MFC-R2 settings within the same E1 line. Most users do
	  not have a problem with this since MFC-R2 lines are usually
	  fractional E1s, or the whole E1 has the same country variant and
	  R2 settings. In Venezuela however is common to have inbound
	  MFC-R2 and outbound DTMF-R2 within the same E1. This fix now
	  properly parses the chan_dahdi.conf file to generate a new openr2
	  context every time a new channel => section is found and the
	  configuration was changed. (closes issue ASTERISK-21117) Reported
	  by: Rafael Angulo Related Elastix issue:
	  http://bugs.elastix.org/view.php?id=1612 ........ Merged
	  revisions 394106 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-07-10 01:49 +0000 [r393929]  Russell Bryant <russell@russellbryant.com>

	* configs/sla.conf.sample, /, apps/app_meetme.c: astobj2-ify the
	  SLA code The SLA code within app_meetme was written before
	  asotbj2 had been merged into Asterisk. Worse, support for reloads
	  did not exist at first and was added later as a bolt-on feature.
	  I knew at the time that reloading was not safe at all while SLA
	  was in use, so the reload would be queued up to execute when the
	  system was idle. Unfortunately, this approach was still prone to
	  errors beyond the fact that this was the only place in Asterisk
	  where configuration was not reloaded instantly when requested.
	  This patch converts various SLA objects to be reference counted
	  objects using astobj2. This allows reloads to be processed while
	  the system is in use. The code ensures that the objects will not
	  disappear while one of the other threads is using them. However,
	  they will be immediately removed from the global trunk and
	  station containers so no new calls will use them if removed from
	  configuration. Review: https://reviewboard.asterisk.org/r/2581/
	  ........ Merged revisions 393928 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-07-03 23:52 +0000 [r393628-393630]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_mixmonitor.c: MixMonitor: Fix refleak in
	  manager_stop_mixmonitor() if could not stop monitoring. ........
	  Merged revisions 393490 from
	  http://svn.asterisk.org/svn/asterisk/trunk

	* channels/chan_dahdi.c, /: chan_dahdi: Fix segfault reloading
	  chan_dahdi when round robin is used. * Clear round_robin[] in
	  dahdi_restart(). (closes issue ASTERISK-21847) Reported by: Ivo
	  Andonov Patches: jira_asterisk_21847_v1.8.patch (license #5621)
	  patch uploaded by rmudgett ........ Merged revisions 393627 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-07-02 10:14 +0000 [r393395]  Igor Goncharovskiy <igor.goncharovsky@gmail.com>

	* channels/chan_unistim.c: Fix issue with inability to cancell call
	  transfer made by on-sceen menus. Reported by: Igor Olhovskiy

2013-06-25 01:07 +0000 [r392810]  Matthew Jordan <mjordan@digium.com>

	* channels/chan_motif.c, main/http.c, main/config_options.c,
	  main/named_acl.c, res/res_calendar.c: Fix memory/ref counting
	  leaks in a variety of locations This patch fixes the following
	  memory leaks: * http.c: The structure containing the addresses to
	  bind to was not being deallocated when no longer used *
	  named_acl.c: The global configuration information was not
	  disposed of * config_options.c: An invalid read was occurring for
	  certain option types. * res_calendar.c: The loaded calendars on
	  module unload were not being properly disposed of. *
	  chan_motif.c: The format capabilities needed to be disposed of on
	  module unload. In addition, this now specifies the default
	  options for the maxpayloads and maxicecandidates in such a way
	  that it doesn't cause the invalid read in config_options.c to
	  occur. (issue ASTERISK-21906) Reported by: John Hardin patches:
	  http.patch uploaded by jhardin (license 6512) named_acl.patch
	  uploaded by jhardin (license 6512) config_options.patch uploaded
	  by jhardin (license 6512) res_calendar.patch uploaded by jhardin
	  (license 6512) chan_motif.patch uploaded by jhardin (license
	  6512)

2013-06-14 16:21 +0000 [r391794]  Jonathan Rose <jrose@digium.com>

	* apps/app_mixmonitor.c, /: app_mixmonitor: Fix crashes caused by
	  unloading app_mixmonitor Unloading app_mixmonitor while active
	  mixmonitors were running would cause a segfault. This patch fixes
	  that by making it impossible to unload app_mixmonitor while
	  mixmonitors are active. Review:
	  https://reviewboard.asterisk.org/r/2624/ ........ Merged
	  revisions 391778 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-06-13 18:47 +0000 [r391700]  Richard Mudgett <rmudgett@digium.com>

	* apps/confbridge/conf_config_parser.c,
	  apps/confbridge/include/confbridge.h, apps/app_confbridge.c:
	  app_confbridge: Fix memory leak on reload. The config framework
	  options should not be registered multiple times. Instead the
	  configuration just needs to be reprocessed by the config
	  framework.

2013-06-12 21:00 +0000 [r391560]  David M. Lee <dlee@digium.com>

	* res/res_http_websocket.c: Fix segfault for certain invalid
	  WebSocket input. The WebSocket code would allocate, on the stack,
	  a string large enough to hold a key provided by the client, and
	  the WEBSOCKET_GUID. If the key is NULL, this causes a segfault.
	  If the key is too large, it could overflow the stack. This patch
	  checks the key for NULL and checks the length of the key to avoid
	  stack smashing nastiness. (closes issue ASTERISK-21825) Reported
	  by: Alfred Farrugia Tested by: Alfred Farrugia, David M. Lee
	  Patches: issueA21825_check_if_key_is_sent.patch uploaded by
	  Walter Doekes (license 5674)

2013-06-12 02:25 +0000 [r391507]  Matthew Jordan <mjordan@digium.com>

	* main/loader.c, main/format.c, /: Fix memory leak while loading
	  priority modules and adding formats This patch fixes two memory
	  leaks: * When we load a module with the LOAD_PRIORITY flag, we
	  remove its entry from the load order list. Unfortunately, we
	  don't free the memory associated with entry in the list. This
	  patch corrects that and properly frees the memory for the module
	  in the list. * When adding a custom format (such as SILK or
	  CELT), the routine for adding the format was leaking a reference.
	  RAII_VAR cleans this up properly. ........ Merged revisions
	  391489 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-06-11 10:22 +0000 [r391379]  Igor Goncharovskiy <igor.goncharovsky@gmail.com>

	* channels/chan_unistim.c: Fix issue with no sound in both way in
	  case of previous call to chan_unistim phone was canceled.
	  (related to ASTERISK-20183)

2013-06-11 08:10 +0000 [r391334]  Alec L Davis <sivad.a@paradise.net.nz>

	* channels/chan_iax2.c, /: IAX2: Transfer Reject: Lock bridgecallno
	  before touching it, refactor 1). When touching the bridgecallno,
	  we need to lock it. 2). Remove magic number '0' and replace with
	  TRANSFER_NONE. 3). Exit early if no bridgecallno. 4). Reduce
	  indentation. Reported by: alecdavis Tested by: alecdavis
	  alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2613/ ........ Merged
	  revisions 391333 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-07-15  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.5.0 Released.

2013-07-12  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.5.0-rc2 Released.

	* Properly lock and safely handle a transfer failure in IAX2

	  When touching the bridgecallno, we need to lock it - otherwise a
	  race condition can occur. This patch does the proper locking
	  of the bridgecallno before modifying its state.

2013-06-10  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.5.0-rc1 Released.

2013-06-10 14:25 +0000 [r391241]  Matthew Jordan <mjordan@digium.com>

	* /, configs/queues.conf.sample, UPGRADE.txt, apps/app_queue.c: Add
	  announce-to-first-user option for app_queue In r386792, the
	  ability to play prompts to the first caller in a call queue was
	  added. While this is arguably a bug fix for those who expect the
	  first caller to continue receiving prompts while the agent is
	  dialed, it has the side effect of preventing the first caller
	  from hearing the agent immediately upon bridging. This may not be
	  a problem for those who really want this option, but for those
	  who didn't care whether or not the first caller in queue heard
	  their position, it was an issue. This patch disables the ability
	  for the first caller in the queue to hear prompts and adds a new
	  option, announce-to-first-user, to queues.conf. Those who the
	  behavior can enable it by setting this value to True. Note that
	  if we ever implement the ability to have the prompts be stopped
	  upon bridging, this option can be removed. (closes issue
	  ASTERISK-21782) Reported by: Remi Quezada ........ Merged
	  revisions 391215 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-06-10 09:32 +0000 [r391063-391148]  Alec L Davis <sivad.a@paradise.net.nz>

	* /, channels/chan_iax2.c: chan_iax2: nativebridge refactor, missed
	  unlock bridgecallno ........ Merged revisions 391143 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_iax2.c: fix bad edit after conflict resolution
	  ........ Merged revisions 391107 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_iax2.c: IAX2: refactor nativebridge transfer
	  remove triple checking of iaxs[fr->callno]->transferring reduce
	  indentation. Reported by: alecdavis Tested by: alecdavis
	  alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2602/ ........ Merged
	  revisions 391065 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_iax2.c: IAX2: fix race condition with
	  nativebridge transfers. 1). When touching the bridgecallno, we
	  need to lock it. 2). stop_stuff() which calls
	  iax2_destroy_helper() Assumes the lock on the pvt is already
	  held, when iax2_destroy_helper() is called. Thus we need to lock
	  the bridgecallno pvt before we call
	  stop_stuff(iaxs[fr->callno]->bridgecallno); 3). When evaluating
	  the state of 'callno->transferring' of the current leg, we can't
	  change it to READY unless the bridgecallno is locked. Why, if we
	  are interrupted by the other call leg before 'transferring =
	  TRANSFER_RELEASED', the interrupt will find that it is READY and
	  that the bridgecallno is also READY so Releases the legs. (closes
	  issue ASTERISK-21409) Reported by: alecdavis Tested by: alecdavis
	  alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2594/ ........ Merged
	  revisions 391062 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-31 10:34 +0000 [r390228-390229]  Alexandr Anikin <may@telecom-service.ru>

	* addons/chan_ooh323.c: remove unnecessary declarations (issue
	  ASTERISK-21800)

	* addons/chan_ooh323.c, /: reject call attempts when gatekeeper is
	  configured but not registered (closes issue ASTERISK-21800)
	  Reported by: Dmitry Melekhov Patches: ASTERISK-21800-1.patch
	  Tested by: Dmitry Melekhov ........ Merged revisions 390181 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 390223 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2013-05-29 20:18 +0000 [r390047]  Richard Mudgett <rmudgett@digium.com>

	* main/channel.c, /: Fix segfault when dealing with chan_agent
	  channels. Check the returned bridged pointer for NULL to avoid a
	  crash. It looks like chan_agent is returning a NULL pointer when
	  it probably should be returning a pointer to the channel the
	  Agent channel is pretending to be. (closes issue ASTERISK-21793)
	  Reported by: Rodrigo P. Telles Patches:
	  jira_asterisk_21793_v1.8.patch (license #5621) patch uploaded by
	  rmudgett Tested by: Rodrigo P. Telles ........ Merged revisions
	  390044 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-28 17:43 +0000 [r389896]  Jonathan Rose <jrose@digium.com>

	* /, main/slinfactory.c: Fix a memory copying bug in slinfactory
	  which was causing mixmonitor issues. Reported by: Michael Walton
	  Tested by: Jonathan Rose Patches:
	  slinfactory.c.ASTERISK-21799.patch uploaded by Michael Walton
	  (license 6502) (closes issue ASTERISK-21799) ........ Merged
	  revisions 389895 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-24 11:49 +0000 [r389677]  Matthew Jordan <mjordan@digium.com>

	* /, main/logger.c: Print all logger messages on shutdown When
	  Asterisk shuts down and shuts down the loggin gsubsystem, any
	  messages currently in flight will not get logged. This patch
	  prevents the loop writing messages from breaking out prematurely,
	  such that all of the messages are logged. (closes issue
	  ASTERISK-21716) Reported by: Corey Farrell patches:
	  logger-process-all-messages.patch uploaded by Corey Farrell
	  (license 5909) ........ Merged revisions 389676 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-24 10:12 +0000 [r389661]  Igor Goncharovskiy <igor.goncharovsky@gmail.com>

	* channels/chan_unistim.c: Fix several problems caused by multiple
	  line usage with i2004 phones. Reported by: Daniel Bohling,
	  MihaiMircea (closes issue ASTERISK-21061) (closes issue
	  ASTERISK-21120)

2013-05-20 17:43 +0000 [r389245]  Jason Parker <jparker@digium.com>

	* /: Add doxygen.log to svn:ignore property. ........ Merged
	  revisions 389244 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-15 15:57 +0000 [r388839]  kharwell <kharwell@localhost>:

	* main/lock.c, /: Fix for segfault in __ast_rwlock_destroy with
	  DEBUG_THREADS If DEBUG_THREADS is enabled __ast_rwlock_destroy
	  causes a segfault while trying to access a possible NULL t->track
	  object. A NULL check has been added before trying to access the
	  memory. (closes issue ASTERISK-21724) Reported by: Corey Farrell
	  Fixed by: Corey Farrell Patches: ast_rwlock_destroy-segv.patch
	  uploaded by Corey Farrell (license 5909) ........ Merged
	  revisions 388838 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-15 14:25 +0000 [r388816]  Jason Parker <jparker@digium.com>

	* apps/app_voicemail.c: Fix VM snapshot handling for combined
	  INBOX. The snapshot API contains an option that allow for
	  combining of new and old messages within a single snapshot. New
	  messages, however, include options beyond just 'INBOX' - it also
	  includes the Urgent folder. A previous patch that combined INBOX
	  and Urgent accidentally impacted snapshots that attempted to gain
	  messages from just the Old folder. This patch fixes the snapshot
	  gathering such that the API returns the appropriate messages for
	  the folder selected, with and without the combine option. This
	  should make it more clear about what's happening. Review:
	  https://reviewboard.asterisk.org/r/2539/

2013-05-15 12:39 +0000 [r388769]  Kinsey Moore <kmoore@digium.com>

	* res/res_srtp.c, /, configure, include/asterisk/autoconfig.h.in,
	  configure.ac: Use srtp_shutdown when available This allows the
	  SRTP library to be shut down properly when the functionality is
	  offered by libsrtp. Review:
	  https://reviewboard.asterisk.org/r/2538/ (closes issue
	  ASTERISK-21719) ........ Merged revisions 388768 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-14 18:55 +0000 [r388700]  Richard Mudgett <rmudgett@digium.com>

	* include/asterisk/astobj2.h, main/astobj2.c: Make ao2 global
	  objects not always use the debug version of the ao2_ref() calls.
	  The debug versions of ao2_ref() should only be used if REF_DEBUG
	  is enabled so nothing is written to /tmp/refs unexpectedly.
	  (closes issue ASTERISK-21785) Reported by: abelbeck Patches:
	  jira_asterisk_21785_v11.patch (license #5621) patch uploaded by
	  rmudgett Tested by: abelbeck

2013-05-13 21:17 +0000 [r388601-388605]  Michael L. Young <elgueromexicano@gmail.com>

	* main/logger.c: Fix Missing CALL-ID When Logging Through Syslog
	  The CALL-ID (ie [C-00000074]) is missing when logging to syslog.
	  This was just an oversight when this feature was added. * Add
	  CALL-IDs when using syslog (closes issue ASTERISK-21430) Reported
	  by: Nikola Ciprich Tested by: Nikola Ciprich, Michael L. Young
	  Patches: asterisk-21430-syslog-callid_trunk.diff by Michael L.
	  Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2526/

	* channels/chan_sip.c: Fix Crash Caused By One-way Audio With
	  auto_* NAT Settings Fix The prior code committed, r385473, failed
	  to take into consideration that not all outgoing calls will be to
	  a peer. My fault. This patch does the following: * Check if there
	  is a related peer involved. If there is, check and set NAT
	  settings according to the peer's settings. * Fix a problem with
	  realtime peers. If the global setting has auto_force_rport set
	  and we issued a "sip reload" while a peer is still registered,
	  the peer's flags for NAT are reset to off. When this happens, we
	  were always setting the contact address of the peer to that of
	  the full contact info that we had. (closes issue ASTERISK-21374)
	  Reported by: jmls Tested by: Michael L. Young Patches:
	  asterisk-21374-fix-crash-and-rt-peers.diff by Michael L. Young
	  (license 5026) Review: https://reviewboard.asterisk.org/r/2524/

2013-05-13 20:35 +0000 [r388597]  Kinsey Moore <kmoore@digium.com>

	* res/res_srtp.c, /: Revert r388529 for now Adding the cleanup
	  function needs some deeper thought since it apparently doesn't
	  exist for all variants of libsrtp. ........ Merged revisions
	  388596 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-13 19:24 +0000 [r388578]  Jonathan Rose <jrose@digium.com>

	* main/pbx.c, /: pbx: Fix lack of cleanup on macrolock and
	  context_table (closes issue ASTERISK-21723) Reported by: Corey
	  Farrell Patches: core-pbx-cleanup.patch uploaded by Correy
	  Farrell (license 5909) ........ Merged revisions 388532 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-13 18:09 +0000 [r388530]  Kinsey Moore <kmoore@digium.com>

	* res/res_srtp.c, /: Close libsrtp properly Ensure that libsrtp is
	  shutdown properly when res_srtp is unloaded. (closes issue
	  ASTERISK-21719) Reported by: Corey Farrell Patches:
	  res_srtp-library-shutdown.patch uploaded by Corey Farrell
	  ........ Merged revisions 388529 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-13 14:26 +0000 [r388478]  Richard Mudgett <rmudgett@digium.com>

	* main/manager.c, /: Fix SendText AMI action to never return
	  non-zero. AMI actions must never return non-zero unless they
	  intend to close the AMI connection. (Which is almost never.)
	  (closes issue ASTERISK-21779) Reported by: Paul Goldbaum ........
	  Merged revisions 388477 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-10 22:11 +0000 [r388424-388426]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/misdn/isdn_msg_parser.c: Allow mISDN to send PROGRESS
	  messsage. * Made isdn_msg_parser.c build a progress message with
	  the mandatory progress indicator IE. (The mISDNuser NT state
	  machine rejected sending the incomplete message.) Note: The
	  associated mISDN and mISDNuser patches respectively are viewable
	  here: http://svnview.digium.com/svn/thirdparty?view=rev&rev=200
	  http://svnview.digium.com/svn/thirdparty?view=rev&rev=201 (closes
	  issue AST-1153) Reported by: Guenther Kelleter Patches:
	  progress-chan_misdn.diff (license #6372) patch uploaded by
	  Guenther Kelleter progress-misdn.diff (license #6372) mISDN patch
	  uploaded by Guenther Kelleter progress-misdnuser.diff (license
	  #6372) mISDNuser patch uploaded by Guenther Kelleter ........
	  Merged revisions 388425 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* utils, /: Add version.c to list of ignored files in the utils
	  directory. ........ Merged revisions 388423 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-10 20:41 +0000 [r388378]  Mark Michelson <mmichelson@digium.com>

	* /, pbx/pbx_dundi.c: Fix memory leak in pbx_dundi pbx_dundi added
	  an io context without removing it. This caused a memory leak when
	  the module was unloaded. (closes ASTERISK-21718) Reported by
	  Corey Farrell Patches: pbx_dundi-ast_io_remove.patch uploaded by
	  Corey Farrell (License #5909) ........ Merged revisions 388376
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-10 11:46 +0000 [r388253]  Sean Bright <sean@malleable.com>

	* channels/chan_sip.c: Fix copy/paste error in one-touch-recording
	  implementation.

2013-05-09 04:10 +0000 [r388108-388112]  Michael L. Young <elgueromexicano@gmail.com>

	* res/res_rtp_asterisk.c, /: Fix The Payload Being Set On CN
	  Packets And Do Not Set Marker Bit When we send out a CN packet
	  (for instance, in the case of using rtpkeepalives), we are not
	  setting the payload code properly. Also, we are setting the
	  marker bit when we shouldn't be according to RFC 3389, section 4.
	  AST_RTP_CN is not defined by AST_FORMAT codes. Therefore, we
	  should be using ast_rtp_codecs_payload_code() rather than
	  ast_rtp_codecs_payload_lookup(). 11 and trunk already use the
	  appropriate function. * In 1.8, use ast_rtp_codecs_payload_code()
	  * Remove the setting of the marker bit * Fix the debug message by
	  incrementing the seqno after the debug message is set in order to
	  display the correct seqno that was sent out (closes issue
	  ASTERISK-21246) Reported by: Peter Katzmann Tested by: Peter
	  Katzmann, Michael L. Young Patches:
	  asterisk-21246-rtp-cng-payload-error_1.8_v2.diff uploaded by
	  Michael L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2500/ ........ Merged
	  revisions 388111 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/app_queue.c: Fix Segfault In app_queue When
	  "persistentmembers" Is Enabled And Using Realtime When the
	  "ignorebusy" setting was deprecated, we added some code to allow
	  us to be compatible with older setups that are still using the
	  "ignorebusy" setting instead of "ringinuse". We set a char
	  *variable with the column name to use, which helps the realtime
	  functions to use the correct column in their SQL queries. When
	  "persistentmembers" is enabled, we are not setting this variable
	  before the realtime functions were called to load members. This
	  results in the variable being NULL and therefore causing a
	  segfault when loading members during the module's process of
	  loading. The solution was to move the code that sets that
	  variable to be before these realtime functions are called during
	  the loading of the module. (closes issue ASTERISK-21738) Reported
	  by: JoshE Tested by: JoshE Patches:
	  asterisk-21738-rt-ringinuse-field-not-set.diff uploaded by
	  Michael L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2499/

2013-05-08 07:19 +0000 [r387880]  Alec L Davis <sivad.a@paradise.net.nz>

	* /, channels/chan_sip.c: chan_sip: NOTIFYs for BLF start queuing
	  up and fail to be sent out after retries fail RFC6665 4.2.2: ...
	  after a failed State NOTIFY transaction remove the subscription
	  The problem is that the State Notify requests rely on the 200OK
	  reponse for pacing control and to not confuse the notify
	  susbsystem. The issue is, the pendinginvite isn't cleared if a
	  response isn't received, thus further notify's are never sent.
	  The solution, follow RFC 6665 4.2.2's 'SHOULD' and remove the
	  subscription after failure. (closes issue ASTERISK-21677)
	  Reported by: Dan Martens Tested by: Dan Martens, David Brillert,
	  alecdavis alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2475/ ........ Merged
	  revisions 387875 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-07 18:29 +0000 [r387823]  David M. Lee <dlee@digium.com>

	* res/res_config_pgsql.c, main/manager.c: Minor fixups to Doxygen
	  comments. The \example tags marks an entire file as an example,
	  not a code snippet.

2013-05-06 15:55 +0000 [r387689]  Russell Bryant <russell@russellbryant.com>

	* /, apps/app_meetme.c: Make SLA reload more paranoid. Reload
	  support was originally not included for SLA. It was added later,
	  but in a fairly non-traditional way. It basically sets a flag
	  indicating that a reload is pending, and then waits for a time
	  where it thinks everything SLA related is idle and unused, and
	  *then* executes the reload. It does this because the reload
	  process is destructive. It starts by throwing everything away and
	  starting over. There are a number of problems with this approach.
	  One of them is that the check to see if anything in use was
	  incomplete. This patch makes it more complete and thus less
	  likely for a crash to occur during reload processing. However,
	  this approach still has problems so some much more significant
	  reworking of this code will need to come in as a next step. Patch
	  credit and testing by CoreDial, LLC. ........ Merged revisions
	  387688 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-02 17:15 +0000 [r387422]  Matthew Jordan <mjordan@digium.com>

	* utils/Makefile, /: Update utils Makefile to handle r387294 Alec's
	  patch that added the Asterisk version to 'core show locks'
	  angered the items in utils, as they exist somewhat outside of the
	  Asterisk build system. Some day, this Makefile should get nuked
	  from high orbit, but for now, include version.c in its list of
	  stuff to pile in. ........ Merged revisions 387421 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-02 08:09 +0000 [r387295-387345]  Alec L Davis <sivad.a@paradise.net.nz>

	* channels/sip/include/sip.h, /, channels/chan_sip.c: chan_sip:
	  Session-Expires: Set timer to correctly expire at (~2/3) of the
	  interval when not the refresher RFC 4028 Section 10 if the side
	  not performing refreshes does not receive a session refresh
	  request before the session expiration, it SHOULD send a BYE to
	  terminate the session, slightly before the session expiration.
	  The minimum of 32 seconds and one third of the session interval
	  is RECOMMENDED. Prior to this asterisk would refresh at 1/2 the
	  Session-Expires interval, or if the remote device was the
	  refresher, asterisk would timeout at interval end. Now, when not
	  refresher, timeout as per RFC noted above. (closes issue
	  ASTERISK-21742) Reported by: alecdavis Tested by: alecdavis
	  alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2488/ ........ Merged
	  revisions 387344 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: chan_sip: Honor Session-Expires in 200OK
	  response when it's a RE-INVITE when asterisk is the refresher.
	  RFC 4028 Section 7.2 "UACs MUST be prepared to receive a
	  Session-Expires header field in a response, even if none were
	  present in the request." What changed After ASTERISK-20787,
	  inbound calls to asterisk with no Session-Expires in the INVITE
	  are now are offered a Session-Expires (1800 asterisk default) in
	  the response, with asterisk as the refresher. Symptom: After 900
	  seconds (asterisk default refresher period 1800), asterisk
	  RE-INVITEs the device, the device may respond with a much lower
	  Session-Expires (180 in our case) value that it is now using.
	  Asterisk ignores this response, as it's deemed both an INBOUND
	  CALL, and a RE-INVITE. After 180 seconds the device times out and
	  sends BYE (hangs up), asterisk is still working with the
	  refresher period of 1800 as it ignored the 'Session Expires: 180'
	  in the previous 200OK response. Fix: handle_response_invite()
	  when 200OK, remove check for outbound and reinvite. (closes issue
	  ASTERISK-21664) Reported by: alecdavis Tested by: alecdavis
	  alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2463/ ........ Merged
	  revisions 387312 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_dahdi.c, /: chan_dahdi: fix lower bound check with
	  -ve integer conversion from a float Lower bound of a 16bit signed
	  int is -32768 not -32767 (closes issue ASTERISK-21744) Reported
	  by: alecdavis Tested by: alecdavis alecdavis (license 585)
	  ........ Merged revisions 387297 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/utils.c: Add Asterisk Version to core show locks Assist
	  with reporting 'core show locks' when submitting bug reports.
	  Example below: =========================== == SVN-branch-1.8-...
	  == Currently Held Locks =========================== (closes issue
	  ASTERISK-21743) Reported by: alecdavis Tested by: alecdavis
	  alecdavis (license 585) ........ Merged revisions 387294 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-01 21:17 +0000 [r387038-387216]  Matthew Jordan <mjordan@digium.com>

	* res/res_rtp_asterisk.c, /: Clear the DTMF sending digit tracking
	  on off nominal paths In certain situations, when the RTP engine
	  goes to send a DTMF end digit it may be in a situation where the
	  remote address is no longer available, or the digit that was
	  supposed to be sent is invalid. In such cases, we need to clear
	  the RTP counters appropriately. Otherwise, when the RTP source is
	  set again, we'll continue to think that we're in the middle of
	  sending a DTMF digit, which can confuse the remote party
	  (signficantly). (closes issue ASTERISK-21522) Reported by: Corey
	  Farrell patches: rtp_dtmf_process_end.patch uploaded by Corey
	  Farrell (License 5909) ........ Merged revisions 387213 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_sip.c: Prevent crash in 'sip show peers' when the
	  number of peers on a system is large When you have lots of SIP
	  peers (according to the issue reporter, around 3500), the 'sip
	  show peers' CLI command or AMI action can crash due to a poorly
	  placed string duplication that occurs on the stack. This patch
	  refactors the command to not allocate the string on the stack,
	  and handles the formatting of a single peer in a separate
	  function call. (closes issue ASTERISK-21466) Reported by:
	  Guillaume Knispel patches:
	  fix_sip_show_peers_stack_overflow_asterisk_11.3.0-v2.patch
	  uploaded by gknispel (License 6492)

	* /, main/features.c: Fix CDR not being created during an
	  externally initiated blind transfer Way back when in the dark
	  days of Asterisk 1.8.9, blind transferring a call in a context
	  that included the 'h' extension would inadvertently execute the
	  hangup code logic on the transferred channel. This was a "bad
	  thing". The fix was to properly check for the softhangup flags on
	  the channel and only execute the 'h' extension logic (and, in
	  later versions, hangup handler logic) if the channel was well and
	  truly dead (Jim). Unfortunately, CDRs are fickle. Setting the
	  softhangup flag when we detected that the channel was leaving the
	  bridge (but not to die) caused some crucial snippet of CDR code,
	  lying in ambush in the middle of the bridging code, to not get
	  executed. This had the effect of blowing away one of the CDRs
	  that is typically created during a blind transfer. While we live
	  and die by the adage "don't touch CDRs in release branches", this
	  was our bad. The attached patch restores the CDR behavior, and
	  still manages to not run the 'h' extension during a blind
	  transfer (at least not when it's supposed to). Thanks to Steve
	  Davies for diagnosing this and providing a fix. Review:
	  https://reviewboard.asterisk.org/r/2476 (closes issue
	  ASTERISK-21394) Reported by: Ishfaq Malik Tested by: Ishfaq
	  Malik, mjordan patches: fix_missing_blindXfer_cdr2 uploaded by
	  one47 (License 5012) ........ Merged revisions 387036 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-30 22:15 +0000 [r387030]  Jonathan Rose <jrose@digium.com>

	* main/event.c: Add forgotten event types to event_names array

2013-04-30 13:46 +0000 [r386930]  Sean Bright <sean@malleable.com>

	* include/asterisk/utils.h, /: Use the proper lower bound when
	  doing saturation arithmetic. 16 bit signed integers have a range
	  of [-32768, 32768). The existing code was using the interval
	  (-32768, 32768) instead. This patch fixes that. Review:
	  https://reviewboard.asterisk.org/r/2479/ ........ Merged
	  revisions 386929 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-29 23:35 +0000 [r386878]  Rusty Newton <rnewton@digium.com>

	* /, sounds/Makefile: Modifying sounds/Makefile to pull down 1.4.24
	  core sounds 1.4.24 core sounds includes a full set of Italian
	  prompts for core sounds and a fix for the missing voicemail
	  prompts in the Russian language. (closes issue ASTERISK-19431)
	  (closes issue ASTERISK-19721) ........ Merged revisions 386877
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-29 08:54 +0000 [r386794]  Olle Johansson <oej@edvina.net>

	* /, CHANGES, apps/app_queue.c: Play periodic prompts for first
	  call in a call queue Review:
	  https://reviewboard.asterisk.org/r/2263/ ........ Merged
	  revisions 386792 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-26 21:27 +0000 [r386642-386677]  Matthew Jordan <mjordan@digium.com>

	* main/config.c, /: Clean up memory leak in config file on off
	  nominal paths when glob is allowed If a system allows for its
	  usage, Asterisk will use glob to help parse Asterisk .conf files.
	  The config file loading routine was leaking the memory allocated
	  by the glob() routine when the config file was in an unmodified
	  or invalid state. This patch properly calls globfree in those off
	  nominal paths. (closes issue ASTERISK-21412) Reported by: Corey
	  Farrell patches: config_glob_leak.patch uploaded by Corey Farrell
	  (license 5909) ........ Merged revisions 386672 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, main/features.c: Clean up resources in features on exit This
	  patch cleans up two things features: * It properly unregisters
	  the CLI commands that features registered * It cancels and
	  performs a pthread_join on the created parking thread. This not
	  only properly joins a non-detached thread, but also prevents
	  disposing of the parking lots prior to the parking thread
	  completely exiting. (closes issue ASTERISK-21407) Reported by:
	  Corey Farrell patches: features_shutdown-r2.patch uploaded by
	  Corey Farrell (License 5909) ........ Merged revisions 386641
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-25 03:02 +0000 [r386484-386486]  Michael L. Young <elgueromexicano@gmail.com>

	* channels/chan_sip.c: Fix Displaying Symmetric RTP Global Setting
	  * Use comedia_string() to display correctly the symmetric rtp
	  setting when running "sip show settings"

	* /, channels/chan_sip.c: Change Case On Forcerport For Consistency
	  * Change "ForcerPort" to "Forcerport" to match everywhere else it
	  is displayed ........ Merged revisions 386483 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-22 16:30 +0000 [r386286]  Richard Mudgett <rmudgett@digium.com>

	* main/channel.c, /: Fix crash when AMI redirect action redirects
	  two channels out of a bridge. The two party bridging loops were
	  changing the bridge peer pointers without the channel locks held.
	  Thus when ast_channel_massquerade() tested and used the pointer
	  there is a small window of opportunity for the pointers to become
	  NULL even though the masquerade code has the channels locked.
	  (closes issue ASTERISK-21356) Reported by: William luke Patches:
	  jira_asterisk_21356_v11.patch (license #5621) patch uploaded by
	  rmudgett Tested by: William luke ........ Merged revisions 386256
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-19 22:25 +0000 [r386159]  Matthew Jordan <mjordan@digium.com>

	* /, res/res_timing_pthread.c: Prevent res_timing_pthread from
	  blocking callers There were several reports of deadlock when
	  using res_timing_pthread. Backtraces indicated that one thread
	  was blocked waiting for the write to the pipe to complete and
	  this thread held the container lock for the timers. Therefore any
	  thread that wanted to create a new timer or read an existing
	  timer would block waiting for either the timer lock or the
	  container lock and deadlock ensued. This patch changes the way
	  the pipe is used to eliminate this source of deadlocks: 1) The
	  pipe is placed in non-blocking mode so that it would never block
	  even if the following changes someone fail... 2) Instead of
	  writing bytes into the pipe for each "tick" that's fired the pipe
	  now has two states--signaled and unsignaled. If signaled, the
	  pipe is hot and any pollers of the read side filedescriptor will
	  be woken up. If unsigned the pipe is idle. This eliminates even
	  the chance of filling up the pipe and reduces the potential
	  overhead of calling unnecessary writes. 3) Since we're tracking
	  the signaled / unsignaled state, we can eliminate the exta poll
	  system call for every firing because we know that there is data
	  to be read. (closes issue ASTERISK-21389) Reported by: Matt
	  Jordan Tested by: Shaun Ruffell, Matt Jordan, Tony Lewis patches:
	  0001-res_timing_pthread-Reduce-probability-of-deadlocking.patch
	  uploaded by sruffell (License 5417) (closes issue ASTERISK-19754)
	  Reported by: Nikola Ciprich (closes issue ASTERISK-20577)
	  Reported by: Kien Kennedy (closes issue ASTERISK-17436) Reported
	  by: Henry Fernandes (closes issue ASTERISK-17467) Reported by:
	  isrl (closes issue ASTERISK-17458) Reported by: isrl Review:
	  https://reviewboard.asterisk.org/r/2441/ ........ Merged
	  revisions 386109 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-19 05:18 +0000 [r386006-386051]  David M. Lee <dlee@digium.com>

	* main/cli.c, /: cli.c: Properly initialize debug_modules and
	  verbose_modules. This avoids some lock errors on the core set
	  {debug,verbose} commands. ........ Merged revisions 386049 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/message.c: Fix lock errors on startup. In messages.c, there
	  are several places in the code where we create a tmp_tech_holder
	  and pass that into an ao2_find call. Unfortunately, we weren't
	  initializing the rwlock on the tmp_tech_holder, which the hash
	  function was locking. It's apparently harmless, but still not the
	  best code. This patch extracts all that copy/pasted code into two
	  functions, msg_find_by_tech and msg_find_by_tech_name, which
	  properly initialize and destroy the rwlock on the
	  tmp_tech_holder. Review: https://reviewboard.asterisk.org/r/2454/

2013-04-16 23:27 +0000 [r385917-385938]  Alec L Davis <sivad.a@paradise.net.nz>

	* res/res_xmpp.c: Distributed Device State broken at sites using
	  res_xmpp or res_jabber where Secuity Advisory AST-2012-015 is
	  inplace res_xmpp was not adding AST_EVENT_IE_CACHABLE to the
	  event as each message came in, then
	  devstate_change_collector_cb() was unable to find
	  AST_EVENT_IE_CACHABLE in the event, so defaulted incorrectly to
	  AST_DEVSTATE_NOT_CACHABLE. (issue ASTERISK-20175) (closes issue
	  ASTERISK-21429) (closes issue ASTERISK-21069) (closes issue
	  ASTERISK-21164) Reported by: alecdavis Tested by: alecdavis
	  alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2452/

	* /, main/devicestate.c, res/res_jabber.c: Distributed Device State
	  broken at sites using res_xmpp or res_jabber where Secuity
	  Advisory AST-2012-015 is inplace res_jabber/res_xmpp were not
	  adding AST_EVENT_IE_CACHABLE to the event as each message came
	  in, then devstate_change_collector_cb() was unable to find
	  AST_EVENT_IE_CACHABLE in the event, so defaulted incorrectly to
	  AST_DEVSTATE_NOT_CACHABLE. (issue ASTERISK-20175) (closes issue
	  ASTERISK-21429) (closes issue ASTERISK-21069) (closes issue
	  ASTERISK-21164) Reported by: alecdavis Tested by: alecdavis
	  alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2452/ ........ Merged
	  revisions 385916 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-15 17:23 +0000 [r385768]  Jason Parker <jparker@digium.com>

	* Makefile, /: Don't unnecessarily rebuild things on every run of
	  'make'. Review: https://reviewboard.asterisk.org/r/2449/ ........
	  Merged revisions 385745 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-15 15:18 +0000 [r385689]  David M. Lee <dlee@digium.com>

	* channels/sig_ss7.c, channels/sip/include/security_events.h,
	  contrib/realtime/mysql/queue_log.sql,
	  channels/chan_multicast_rtp.c, channels/sig_ss7.h, /,
	  tests/test_expr.c, apps/app_saycounted.c,
	  channels/sip/security_events.c,
	  contrib/realtime/mysql/voicemail_messages.sql, BSDmakefile,
	  contrib/realtime/mysql/voicemail_data.sql,
	  build_tools/sha1sum-sh, res/res_mutestream.c,
	  configs/res_curl.conf.sample, tests/test_func_file.c,
	  include/asterisk/select.h, res/res_rtp_multicast.c,
	  include/asterisk/bridging_technology.h,
	  include/asterisk/bridging_features.h, tests/test_locale.c,
	  doc/Makefile, tests/test_poll.c,
	  contrib/realtime/mysql/musiconhold.sql, res/res_timing_kqueue.c:
	  Fix the svn:keywords property on several files. Normally I think
	  keyword expansion is silly, but the one time it would have been
	  good, it didn't work because the property had quotes in it. This
	  patch fixes obviously busted svn:keywords properties. ........
	  Merged revisions 385683 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-14 03:00 +0000 [r385634-385637]  Matthew Jordan <mjordan@digium.com>

	* res/res_rtp_multicast.c, /: Calculate the timestamp for outbound
	  RTP if we don't have timing information This patch calculates the
	  timestamp for outbound RTP when we don't have timing information.
	  This uses the same approach in res_rtp_asterisk. Thanks to both
	  Pietro and Tzafrir for providing patches. (closes issue
	  ASTERISK-19883) Reported by: Giacomo Trovato Tested by: Pietro
	  Bertera, Tzafrir Cohen patches: rtp-timestamp-1.8.patch uploaded
	  by tzafrir (License 5035) rtp-timestamp.patch uploaded by
	  pbertera (License 5943) ........ Merged revisions 385636 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_alsa.c: Don't attempt to create a voice frame on
	  a read error Prior to this patch, a read error in snd_pcm_readi
	  would still be treated as a nominal result when constructing a
	  voice frame from the expected data. Since the value returned is
	  negative, as opposed to the number of samples read, this could
	  result in a crash. With this patch, we now return a null frame
	  when a read error is detected. Note that the patch on
	  ASTERISK-21329 was modified slightly for this commit, in that we
	  bail immediately on detecting the read error, rather than
	  bypassing the construction of the voice frame. (closes issue
	  ASTERISK-21329) Reported by: Keiichiro Kawasaki patches:
	  chan_alsa.diff uploaded by kawasaki (License 6489) ........
	  Merged revisions 385633 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-12 22:37 +0000 [r385594]  Michael L. Young <elgueromexicano@gmail.com>

	* /, apps/app_queue.c: Fix Manager Segfault When app_queue Is
	  Unloaded When app_queue is unloaded, some manager commands are
	  not being unregistered which result in a segfault. This patch
	  corrects this. (closes issue ASTERISK-21397) Reported by: Peter
	  Katzmann, Corey Farrell Tested by: Corey Farrell Patches:
	  asterisk-21397-missing-unreg-manager-cmd_1.8.diff Michael L.
	  Young (license 5026)
	  asterisk-21397-missing-unreg-manager-cmd_11.diff Michael L. Young
	  (license 5026) Review: https://reviewboard.asterisk.org/r/2444/
	  ........ Merged revisions 385593 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-12 22:25 +0000 [r385582]  Kinsey Moore <kmoore@digium.com>

	* codecs/codec_resample.c: Allow codec_resample to be unloaded
	  Ensure that trans_size is correct to prevent uninitialized
	  entries from preventing reload. (closes issue ASTERISK-21401)
	  Reported by: Corey Farrell Tested by: Corey Farrell Patches:
	  codec_resample-unload.patch uploaded by Corey Farrell

2013-04-12 22:18 +0000 [r385473-385557]  Michael L. Young <elgueromexicano@gmail.com>

	* apps/app_voicemail.c, /: Fix app_voicemail Segfault And A Few
	  Memory Leaks The original report was that app_voicemail would
	  crash. This was caused by ast_config_load() returning
	  CONFIG_STATUS_FILEINVALID but no checks being performed for that
	  return status. After adding the initial patch to fix this issue,
	  Jaco Kroon (jkroon) added some fixes to memory leaks he had
	  discovered. During review, Walter Doekes (wdoekes) suggested
	  adding a helper function in order to determine if we had a valid
	  configuration or not. This patch does the following: * Creates a
	  helper function to check if the configuration is valid * Adds
	  calls to the new helper function where appropiate * Fixes memory
	  leaks where the code returned without running
	  ast_config_destroy() on the configuration that was loaded (closes
	  issue ASTERISK-21302) Reported by: Jaco Kroon Tested by: Jaco
	  Kroon, Michael L. Young Patches:
	  asterisk-11.3.0-app_voicemail-ast_config-fixes.patch Jaco Kroon
	  (license 5671) asterisk-21302-valid_cfg_and_mem_leaks_v3-1.8.diff
	  Michael L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2443/ ........ Merged
	  revisions 385551 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_sip.c: Fix One-Way Audio With auto_* NAT Settings
	  When SIP Calls Initiated By PBX When we reload Asterisk or
	  chan_sip, the flags force_rport and comedia that are turned on
	  and off when using the auto_force_rport and auto_comedia nat
	  settings go back to the default setting off. These flags are
	  turned on when needed or off when not needed at the time that a
	  peer registers, re-registers or initiates a call. This would
	  apply even when only the default global setting
	  "nat=auto_force_rport" is being used, which in this case would
	  only affect the force_rport flag. Everything is good except for
	  the following: The nat setting is set to auto_force_rport and
	  auto_comedia. We reload Asterisk and the peer's registration has
	  not expired. We load in the settings for the peer which turns
	  force_rport and comedia back to off. Since the peer has not
	  re-registered or placed a call yet, those flags remain off. We
	  then initiate a call to the peer from the PBX. The force_rport
	  and comedia flags stay off. If NAT is involved, we end up with
	  one-way audio since we never checked to see if the peer is behind
	  NAT or not. This patch does the following: * Moves the checking
	  of whether a peer is behind NAT into its own function * Create a
	  function to set the peer's NAT flags if they are using the auto_*
	  NAT settings * Adds calls in sip_request_call() to these new
	  functions in order to setup the dialog according to the peer's
	  settings (closes issue ASTERISK-21374) Reported by: Michael L.
	  Young Tested by: Michael L. Young Patches:
	  asterisk-21374-auto-nat-outgoing-fix_v2.diff Michael L. Young
	  (license 5026) Review: https://reviewboard.asterisk.org/r/2421/

2013-04-12 08:50 +0000 [r385403-385430]  Alec L Davis <sivad.a@paradise.net.nz>

	* /, channels/chan_iax2.c: IAX2 defer_full_frames fail to get sent
	  Ensure iax2_process_thread is signalled when a deferred frame is
	  queued to it. (issue ASTERISK-18827) Reported by: alecdavis
	  Tested by: alecdavis alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2426/ ........ Merged
	  revisions 385429 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_iax2.c: IAX2, prevent network thread starting
	  before all helper threads are ready On startup, it's possible for
	  a frame to arrive before the processing threads were ready. In
	  iax2_process_thread() the first pass through falls into
	  ast_cond_wait, should a frame arrive before we are at
	  ast_cond_wait, the signal will be ignored. The result
	  iax2_process_thread stays at ast_cond_wait forever, with deferred
	  frames being queued. Fix: When creating initial idle
	  iax2_process_threads, wait for init_cond to be signalled after
	  each thread is started. (issue ASTERISK-18827) Reported by:
	  alecdavis Tested by: alecdavis alecdavis (license 585) Review
	  https://reviewboard.asterisk.org/r/2427/ ........ Merged
	  revisions 385402 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-11 19:59 +0000 [r385356]  Jason Parker <jparker@digium.com>

	* res/res_rtp_asterisk.c, build_tools/menuselect-deps.in,
	  configure, include/asterisk/autoconfig.h.in, configure.ac,
	  makeopts.in: Add dependency on libuuid, for res_rtp_asterisk
	  pjproject is what actually requires libuuid. (closes issue
	  ASTERISK-21125) reported by Private Name (Ed. note: Really?
	  Private Name? I am rolling my eyes so hard right now.)

2013-04-11 16:52 +0000 [r385313]  Richard Mudgett <rmudgett@digium.com>

	* configs/cli_aliases.conf.sample: Fix 'pri intense debug span'
	  alias.

2013-04-10 14:25 +0000 [r385173-385199]  Matthew Jordan <mjordan@digium.com>

	* /, res/res_config_ldap.c: Use LDAP memory management functions
	  instead of Asterisk's When MALLOC_DEBUG is enabled with
	  res_config_ldap, issues (munmap_chunk: invalid pointer errors)
	  can occur as the memory is being allocated with Asterisk's
	  wrappers around malloc/calloc/free/strdup, as opposed to the LDAP
	  library's wrappers. This patch uses the LDAP library's wrappers
	  where appropriate, so that compiling with MALLOC_DEBUG doesn't
	  cause more problems than it solves. Note that the patch listed
	  below was modified slightly for this commit to account for some
	  additional memory allocation/deallocations. (closes issue
	  ASTERISK-17386) Reported by: John Covert Tested by: Andrew Latham
	  patches: issue18789-1.8-r316873.patch uploaded by seanbright
	  (License 5060) ........ Merged revisions 385190 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_sip.c: Fix crash in chan_sip when a core
	  initiated op occurs at the same time as a BYE When a BYE request
	  is processed in chan_sip, the current SIP dialog is detached from
	  its associated Asterisk channel structure. The tech_pvt pointer
	  in the channel object is set to NULL, and the dialog persists for
	  an RFC mandated period of time to handle re-transmits. While this
	  process occurs, the channel is locked (which is good).
	  Unfortunately, operations that are initiated externally have no
	  way of knowing that the channel they've just obtained (which is
	  still valid) and that they are attempting to lock is about to
	  have its tech_pvt pointer removed. By the time they obtain the
	  channel lock and call the channel technology callback, the
	  tech_pvt is NULL. This patch adds a few checks to some channel
	  callbacks that make sure the tech_pvt isn't NULL before using it.
	  Prime offenders were the DTMF digit callbacks, which would crash
	  if AMI initiated a DTMF on the channel at the same time as a BYE
	  was received from the UA. This patch also adds checks on
	  sip_transfer (as AMI can also cause a callback into this
	  function), as well as sip_indicate (as lots of things can queue
	  an indication onto a channel). Review:
	  https://reviewboard.asterisk.org/r/2434/ (closes issue
	  ASTERISK-20225) Reported by: Jeff Hoppe ........ Merged revisions
	  385170 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-08 23:36 +0000 [r385048]  Rusty Newton <rnewton@digium.com>

	* /, configs/extconfig.conf.sample: Modified the list of keys for
	  the driver backends for sake of sample clarity Added a line
	  showing the mapping of "mysql" to res_config_mysql available in
	  add-ons. We used "mysql" as an example driver key in the sample,
	  but didn't show what module it mapped too. Also added a subtitle
	  above the list of keys for driver backends. ........ Merged
	  revisions 385047 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-05 20:34 +0000 [r384827]  Michael L. Young <elgueromexicano@gmail.com>

	* channels/chan_sip.c, UPGRADE.txt: Fix For Not Overriding The
	  Default Settings In chan_sip The initial report was that the
	  "nat" setting in the [general] section was not having any effect
	  in overriding the default setting. Upon confirming that this was
	  happening and looking into what was causing this, it was
	  discovered that other default settings would not be overriden as
	  well. This patch works similar to what occurs in build_peer(). We
	  create a temporary ast_flags structure and using a mask, we
	  override the default settings with whatever is set in the
	  [general] section. In the bug report, the reporter who helped to
	  test this patch noted that the directmedia settings were being
	  overriden properly as well as the nat settings. This issue is
	  also present in Asterisk 1.8 and a separate patch will be applied
	  to it. (issue ASTERISK-21225) Reported by: Alexandre Vezina
	  Tested by: Alexandre Vezina, Michael L. Young Patches:
	  asterisk-21225-handle-options-default-prob_v4.diff Michael L.
	  Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2385/

2013-04-03 20:18 +0000 [r384689]  Richard Mudgett <rmudgett@digium.com>

	* channels/sig_pri.h, channels/chan_dahdi.c,
	  configs/chan_dahdi.conf.sample, /, channels/sig_pri.c:
	  chan_dahdi: Add inband_on_proceeding compatibility option. The
	  new inband_on_proceeding option causes Asterisk to assume inband
	  audio may be present when a PROCEEDING message is received. Q.931
	  Section 5.1.2 says the network cannot assume that the CPE side
	  has attached to the B channel at this time without explicitly
	  sending the progress indicator ie informing the CPE side to
	  attach to the B channel for audio. However, some non-compliant
	  ISDN switches send a PROCEEDING without the progress indicator ie
	  indicating inband audio is available and assume that the CPE
	  device has connected the media path for listening to ringback and
	  other messages. ASTERISK-17834 which causes this issue was
	  dealing with a non-compliant network switch. (closes issue
	  ASTERISK-21151) Reported by: Gianluca Merlo Tested by: rmudgett
	  ........ Merged revisions 384685 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-03 17:10 +0000 [r384641]  Matthew Jordan <mjordan@digium.com>

	* /, funcs/func_channel.c: Update documentation for CHANNEL
	  function Document that you can read/write the 'accountcode' and
	  'amaflags' on a channel. ........ Merged revisions 384640 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-02 17:34 +0000 [r384545]  David M. Lee <dlee@digium.com>

	* Makefile, /: Fixed spurious rebuilds of func_version.
	  func_version.so was being rebuilt every time, because build.h was
	  changing every build, because of the cleantest dependency that
	  was added in r384410 to fix parallel make bugs. Now build.h will
	  only be created if it does not exist, which was the original
	  behavior of the Makefile. ........ Merged revisions 384544 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-04-01 14:07 +0000 [r384414]  Joshua Colp <jcolp@digium.com>

	* apps/app_voicemail.c: Remove silly use of strncmp.

2013-04-01 13:28 +0000 [r384411]  David M. Lee <dlee@digium.com>

	* Makefile, /: Fix parallel make problems. Occasionally, make -j
	  would fail due to missing includes, or other unusual errors. This
	  was due to the 'cleantest' target, which was designed to force a
	  make clean when some change in the code would cause the typical
	  depedency checking to fail. Several targets in the main Makefile
	  did not depend upon cleantest, hence would run in parallel to it.
	  By adding the dependency, make -j runs happily now. Review:
	  https://reviewboard.asterisk.org/r/2418/ ........ Merged
	  revisions 384410 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-29 16:31 +0000 [r384326]  Jonathan Rose <jrose@digium.com>

	* apps/app_voicemail.c, /: app_voicemail: Add blank argument to
	  externnotify if no context argument At least one call to
	  run_externnotify provides a NULL context parameter and because
	  the snprintf statement doesn't account for a NULL context
	  parameter, it simply writes '(null)' to the arguments string
	  instead. This patch makes it write two quotes back to back for
	  that argument instead in the event of a NULL context. (closes
	  issue ASTERISK-18207) Reported by: Barry L. Kline Patches:
	  modified from patch-20130306 uploaded by Karsten Wemheuer
	  (License 5930) ........ Merged revisions 384325 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-05-17  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.4.0 Released.

2013-05-15  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.4.0-rc3 Released.

	* Fix VM snapshot handling for combined INBOX.

	  The snapshot API contains an option that allow for combining of new
	  and old messages within a single snapshot. New messages, however,
	  include options beyond just 'INBOX' - it also includes the Urgent
	  folder. A previous patch that combined INBOX and Urgent accidentally
	  impacted snapshots that attempted to gain messages from just the Old
	  folder. This patch fixes the snapshot gathering such that the API
	  returns the appropriate messages for the folder selected, with and
	  without the combine option.

2013-05-09  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.4.0-rc2 Released.

	* Fix Segfault In app_queue When "persistentmembers" Is Enabled And
	  Using Realtime

	  When the "ignorebusy" setting was deprecated, we added some code to
	  allow us to be compatible with older setups that are still using the
	  "ignorebusy" setting instead of "ringinuse".  We set a char *variable
	  with the column name to use, which helps the realtime functions to
	  use the correct column in their SQL queries.  When "persistentmembers"
	  is enabled, we are not setting this variable before the realtime
	  functions were called to load members.  This results in the variable
	  being NULL and therefore causing a segfault when loading members
	  during the module's process of loading.

	  The solution was to move the code that sets that variable to be
	  before these realtime functions are called during the loading of the
	  module.

	* Distributed Device State broken at sites using res_xmpp or res_jabber
	  where Secuity Advisory AST-2012-015 is inplace

	  res_jabber/res_xmpp were not adding AST_EVENT_IE_CACHABLE to the
	  event as each message came in, then devstate_change_collector_cb()
	  was unable to find AST_EVENT_IE_CACHABLE in the event, so defaulted
	  incorrectly to AST_DEVSTATE_NOT_CACHABLE.

	* Fix CDR not being created during an externally initiated blind
	  transfer

	  Way back when in the dark days of Asterisk 1.8.9, blind transferring
	  a call in a context that included the 'h' extension would
	  inadvertently execute the hangup code logic on the transferred
	  channel. This was a "bad thing". The fix was to properly check for
	  the softhangup flags on the channel and only execute the 'h'
	  extension logic (and, in later versions, hangup handler logic) if
	  the channel was well and truly dead (Jim).

	  Unfortunately, CDRs are fickle. Setting the softhangup flag when we
	  detected that the channel was leaving the bridge (but not to die)
	  caused some crucial snippet of CDR code, lying in ambush in the
	  middle of the bridging code, to not get executed. This had the
	  effect of blowing away one of the CDRs that is typically created
	  during a blind transfer.

	  While we live and die by the adage "don't touch CDRs in release
	  branches", this was our bad. The attached patch restores the CDR
	  behavior, and still manages to not run the 'h' extension during a
	  blind transfer (at least not when it's supposed to).

	  Thanks to Steve Davies for diagnosing this and providing a fix.

	* Prevent res_timing_pthread from blocking callers

	  There were several reports of deadlock when using res_timing_pthread.
	  Backtraces indicated that one thread was blocked waiting for the
	  write to the pipe to complete and this thread held the container lock
	  for the timers.  Therefore any thread that wanted to create a new
	  timer or read an existing timer would block waiting for either the
	  timer lock or the container lock and deadlock ensued.

	  This patch changes the way the pipe is used to eliminate this source
	  of deadlocks:

	  1) The pipe is placed in non-blocking mode so that it would never
	     block even if the following changes someone fail...

	  2) Instead of writing bytes into the pipe for each "tick" that's
	     fired the pipe now has two states--signaled and unsignaled. If
	     signaled, the pipe is hot and any pollers of the read side
	     filedescriptor will be woken up. If unsigned the pipe is idle.
	     This eliminates even the chance of filling up the pipe and reduces
	     the potential overhead of calling unnecessary writes.

	  3) Since we're tracking the signaled / unsignaled state, we can
	  eliminate the exta poll system call for every firing because we know
	  that there is data to be read.

	* Fix crash when AMI redirect action redirects two channels out of a
	  bridge.

	  The two party bridging loops were changing the bridge peer pointers
	  without the channel locks held.  Thus when ast_channel_massquerade()
	  tested and used the pointer there is a small window of opportunity
	  for the pointers to become NULL even though the masquerade code has
	  the channels locked.

2013-03-28  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.4.0-rc1 Released.

2013-03-27 19:51 +0000 [r384163]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_sip.c, main/format_pref.c: Address uninitialized
	  conditional that valgrind found ........ Merged revisions 384162
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-27 18:51 +0000 [r384119]  Matthew Jordan <mjordan@digium.com>

	* /, main/http.c: Fix a file descriptor leak in off nominal path
	  While looking at the security vulnerability in ASTERISK-20967,
	  Walter noticed a file descriptor leak and some other issues in
	  off nominal code paths. This patch corrects them. Note that this
	  patch is not related to the vulnerability in ASTERISK-20967, but
	  the patch was placed on that issue. (closes issue ASTERISK-20967)
	  Reported by: wdoekes patches:
	  issueA20967_file_leak_and_unused_wkspace.patch uploaded by
	  wdoekes (License 5674) ........ Merged revisions 384118 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-27 17:06 +0000 [r384049]  Kinsey Moore <kmoore@digium.com>

	* res/res_rtp_asterisk.c, /: Fix white noise on SRTP decryption
	  When res_rtp_asterisk.c was altered to avoid attempting to apply
	  unprotect algorithms to non-audio RTP packets, the test used was
	  incorrect. This caused the audio packets to not be decrypted and
	  resulted in loud white noise on the other endpoint (or both
	  endpoints depending on the call legs involved). The test now
	  properly checks the version field in the RTP header to ensure
	  that RTP and RTCP are decrypted while other types of packets are
	  not. (closes issue ASTERISK-21323) Reported by: andrea Tested by:
	  Kinsey Moore, andrea, John Bigelow Patches: whitenoise_fix.diff
	  uploaded by Kinsey Moore ........ Merged revisions 384048 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-27 15:23 +0000 [r383973-384003]  Matthew Jordan <mjordan@digium.com>

	* channels/sip/include/sip.h, channels/chan_sip.c,
	  channels/sip/security_events.c: AST-2013-003: Prevent username
	  disclosure in SIP channel driver When authenticating a SIP
	  request with alwaysauthreject enabled, allowguest disabled, and
	  autocreatepeer disabled, Asterisk discloses whether a user exists
	  for INVITE, SUBSCRIBE, and REGISTER transactions in multiple
	  ways. The information is disclosed when: * A "407 Proxy
	  Authentication Required" response is sent instead of a "401
	  Unauthorized" response * The presence or absence of additional
	  tags occurs at the end of "403 Forbidden" (such as "(Bad Auth)")
	  * A "401 Unauthorized" response is sent instead of "403
	  Forbidden" response after a retransmission * Retransmission are
	  sent when a matching peer did not exist, but not when a matching
	  peer did exist. This patch resolves these various vectors by
	  ensuring that the responses sent in all scenarios is the same,
	  regardless of the presence of a matching peer. This issue was
	  reported by Walter Doekes, OSSO B.V. A substantial portion of the
	  testing and the solution to this problem was done by Walter as
	  well - a huge thanks to his tireless efforts in finding all the
	  ways in which this setting didn't work, providing automated
	  tests, and working with Kinsey on getting this fixed. (closes
	  issue ASTERISK-21013) Reported by: wdoekes Tested by: wdoekes,
	  kmoore patches: AST-2013-003-1.8 uploaded by kmoore, wdoekes
	  (License 6273, 5674) AST-2013-003-10 uploaded by kmoore, wdoekes
	  (License 6273, 5674) AST-2013-003-11 uploaded by kmoore, wdoekes
	  (License 6273, 5674)

	* main/http.c: AST-2013-002: Prevent denial of service in HTTP
	  server AST-2012-014, fixed in January of this year, contained a
	  fix for Asterisk's HTTP server for a remotely-triggered crash.
	  While the fix put in place fixed the possibility for the crash to
	  be triggered, a denial of service vector still exists with that
	  solution if an attacker sends one or more HTTP POST requests with
	  very large Content-Length values. This patch resolves this by
	  capping the Content-Length at 1024 bytes. Any attempt to send an
	  HTTP POST with Content-Length greater than this cap will not
	  result in any memory allocation. The POST will be responded to
	  with an HTTP 413 "Request Entity Too Large" response. This issue
	  was reported by Christoph Hebeisen of TELUS Security Labs (closes
	  issue ASTERISK-20967) Reported by: Christoph Hebeisen patches:
	  AST-2013-002-1.8.diff uploaded by mmichelson (License 5049)
	  AST-2013-002-10.diff uploaded by mmichelson (License 5049)
	  AST-2013-002-11.diff uploaded by mmichelson (License 5049)

	* res/res_format_attr_h264.c: AST-2013-001: Prevent buffer overflow
	  through H.264 format negotiation The format attribute resource
	  for H.264 video performs an unsafe read against a media attribute
	  when parsing the SDP. The value passed in with the format
	  attribute is not checked for its length when parsed into a fixed
	  length buffer. This patch resolves the vulnerability by only
	  reading as many characters from the SDP value as will fit into
	  the buffer. (closes issue ASTERISK-20901) Reported by: Ulf
	  Harnhammar patches: h264_overflow_security_patch.diff uploaded by
	  jrose (License 6182)

2013-03-26 02:28 +0000 [r383840-383878]  Matthew Jordan <mjordan@digium.com>

	* /, channels/chan_sip.c: Resolve deadlock between SIP registration
	  and channel based functions In r373424, several reentrancy
	  problems in chan_sip were addressed. As a result, the SIP channel
	  driver is now properly locking the channel driver private
	  information in certain operations that it wasn't previously. This
	  exposed two latent problems either in register_verify or by
	  functions called by register_verify. This includes: * Holding the
	  private lock while calling sip_send_mwi_to_peer. This can create
	  a new sip_pvt via sip_alloc, which will obtain the channel
	  container lock. This is a locking inversion, as any channel
	  related lock must be obtained prior to obtaining the SIP channel
	  technology private lock. Note that this issue was already fixed
	  in Asterisk 11. * Holding the private lock while calling
	  sip_poke_peer. In the same vein as sip_send_mwi_to_peer,
	  sip_poke_peer can create a new SIP private, causing the same
	  locking inversion. Note that this locking inversion typically
	  occured when CLI commands were run while a SIP REGISTER request
	  was being processed, as many CLI commands (such as 'sip show
	  channels', 'core show channels', etc.) have to obtain the channel
	  container lock. (issue ASTERISK-21068) Reported by: Nicolas
	  Bouliane (issue ASTERISK-20550) Reported by: David Brillert
	  (issue ASTERISK-21314) Reported by: Badalian Vyacheslav (issue
	  ASTERISK-21296) Reported by: Gabriel Birke ........ Merged
	  revisions 383863 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/cdr.c, /: Resolve deadlock between pending CDR and batch CDR
	  locks r375757 attempted to resolve a race condition between
	  multiple submissions of CDRs while in batch mode from attempting
	  to destroy the scheduled batch submission by extending the batch
	  CDR lock. Unfortunately, this causes a deadlock between the
	  pending CDR lock and the batch CDR lock. This patch resolves the
	  intent of r375757 by simply providing a new lock that protects
	  the scheduling of the batches. The original batch CDR lock is
	  kept to protect manipulation of the batch CDR settings, but has
	  been placed such that it is not held when the pending lock is
	  held. Thanks to Chase Venters for providing lock analysis on the
	  issue. (issue ASTERISK-21162) Reported by: Chase Venters ........
	  Merged revisions 383839 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-26 01:36 +0000 [r383836]  Russell Bryant <russell@russellbryant.com>

	* /, apps/app_meetme.c: Fix multi-station answer race condition.
	  When an SLA trunk is ringing (inbound call on the trunk) Asterisk
	  will make outbound calls to the stations that have that trunk. If
	  more than one station answers the call at the same time, all
	  channels other than the first one to answer are left in a bad
	  state. The channel gets leaked, is not connected to anything, and
	  there's no way to get rid of it. We now properly clean up these
	  losing channels by hanging up on them. Since they lost the race,
	  as we process their answer, there is no ringing trunk for them to
	  answer. ........ Merged revisions 383835 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-25 23:24 +0000 [r383798]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/sig_pri.c: Set the CALLERID(dnid-num-plan) for
	  incoming ISDN calls. The CALLEDTON channel variable is set for
	  incoming ISDN calls to the lower 7 bits of the Q.931
	  type-of-number/numbering-plan octet. The CALLERID(dnid-num-plan)
	  should have the same value. (closes issue ASTERISK-21248)
	  Reported by: rmudgett ........ Merged revisions 383796 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-25 12:36 +0000 [r383668]  Sean Bright <sean@malleable.com>

	* res/res_config_curl.c, /: Properly delimit post data in
	  res_config_curl. ........ Merged revisions 383667 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-22 20:41 +0000 [r383631]  Michael L. Young <elgueromexicano@gmail.com>

	* apps/app_mixmonitor.c: Fix StopMixMonitor Hanging Up When Unable
	  To Stop MixMonitor On A Channel A regression was accidentally
	  introduced when allowing an optional ID to be used when calling
	  StopMixMonitor. When we are unable to stop MixMonitor on a
	  channel, -1 is being returned which triggers the hangup of the
	  channel. This patch restores the prior behavior by returning 0
	  whether we were successful or not. It also allows the call from
	  the manager to use the return code when the action fails. (closes
	  issue ASTERISK-21294) Reported by: daroz Tested by: daroz
	  Patches: asterisk-21294-stop_mixmonitor_hangingup.diff Michael L.
	  Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2404/

2013-03-20 20:25 +0000 [r383457-383461]  Walter Doekes <walter+asterisk@wjd.nu>

	* funcs/func_curl.c, /: Have func_curl log a warning when a curl
	  request fails. Review: https://reviewboard.asterisk.org/r/2403/
	  ........ Merged revisions 383460 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* funcs/func_curl.c: Minor cleanup in func_curl near hashcompat
	  code. Review: https://reviewboard.asterisk.org/r/2402/

2013-03-19 15:58 +0000 [r383341-383342]  David M. Lee <dlee@digium.com>

	* codecs/Makefile: Remove codecs/speex/*.i on make clean

	* codecs/Makefile, /: Removed codecs/g722/*.i on make clean
	  ........ Merged revisions 383340 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-16 15:14 +0000 [r383266]  Joshua Colp <jcolp@digium.com>

	* res/res_xmpp.c: Fix a bug where resources were not found due to
	  hashing on the priority itself.

2013-03-15 12:51 +0000 [r383166]  Kinsey Moore <kmoore@digium.com>

	* main/tcptls.c, main/manager.c, /, channels/chan_sip.c,
	  main/http.c: tcptls: Prevent unsupported options from being set
	  AMI, HTTP, and chan_sip all support TLS in some way, but none of
	  them support all the options that Asterisk's TLS core is capable
	  of interpreting. This prevents consumers of the TLS/SSL layer
	  from setting TLS/SSL options that they do not support. This also
	  gets tlsverifyclient closer to a working state by requesting the
	  client certificate when tlsverifyclient is set. Currently, there
	  is no consumer of main/tcptls.c in Asterisk that supports this
	  feature and so it can not be properly tested. Review:
	  https://reviewboard.asterisk.org/r/2370/ Reported-by: John
	  Bigelow Patch-by: Kinsey Moore (closes issue AST-1093) ........
	  Merged revisions 383165 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-15 01:34 +0000 [r383121-383125]  Matthew Jordan <mjordan@digium.com>

	* /, channels/chan_sip.c: When a session timer expires during a
	  T.38 call, re-invite with correct SDP When a session timer
	  expires during a dialog that has re-negotiated to T.38 and
	  Asterisk is the refresher, Asterisk will send a re-INVITE with an
	  SDP containing audio media only. This causes some hilarity with
	  the poor fax session under weigh. This patch corrects that by
	  sending T.38 parameters if we are in the middle of a T.38
	  session. (closes issue ASTERISK-21232) Reported by: Nitesh Bansal
	  patches:
	  dont-send-audio-reinvite-for-sess-timer-in-t38-call.patch
	  uploaded by nbansal (License 6418) ........ Merged revisions
	  383124 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* pbx/pbx_spool.c, /: Fix processing of call files when using
	  KQueue on OS X In certain situations, call files are not
	  processed when using KQueue with pbx_spool. Asterisk was sending
	  an invalid timeout value when the spool directory is empty,
	  causing the call to kevent to error immediately. This can create
	  a tight loop, increasing the CPU load on the system. (closes
	  issue ASTERISK-21176) Reported by: Carlton O'Riley patches:
	  kqueue_osx.patch uploaded by coriley (License 6473) ........
	  Merged revisions 383120 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-14 16:57 +0000 [r383062]  Jason Parker <jparker@digium.com>

	* autoconf/ast_ext_lib.m4, /: Fix whitespace in AST_EXT_LIB_CHECK
	  macro. ........ Merged revisions 383061 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-12 21:17 +0000 [r382940-382943]  Michael L. Young <elgueromexicano@gmail.com>

	* addons/res_config_mysql.c, /: Fix Sorting Order For Parking Lots
	  Stored In Static Realtime When retrieving the parking lots from a
	  MySQL database table, the current order is "filename, cat_metric
	  desc, var_metric asc, category". If there are multiple parking
	  lots with the same cat_metric but different categories,
	  everything is being sorted on cat_metric first resulting in
	  errors when loading the parking lots. This patch fixes the
	  problem by sorting on the category field first, then the
	  cat_metric field. (closes issue ASTERISK-21035) Reported by: Alex
	  Epshteyn Patches: asterisk-21035-orderby.diff Michael L. Young
	  (license 5026) ........ Merged revisions 382942 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* contrib/realtime/mysql/sippeers.sql, /,
	  contrib/realtime/postgresql/realtime.sql: Update Contributed
	  Realtime Schema Files - IPv6 Addresses This commit updates some
	  fields in the contributed realtime schema files to handle IPv6
	  addresses. (closes issue ASTERISK-21173) Reported by: Torrey
	  Searle Patches: realtime_sql.patch Torrey Searle (license 5334)
	  asterisk-21173-update-ip-fields.diff Michael L. Young (license
	  5026) ........ Merged revisions 382939 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-12 20:06 +0000 [r382923]  Joshua Colp <jcolp@digium.com>

	* res/res_xmpp.c: Fix a crash when res_xmpp is configured using a
	  username without a domain. (closes issue ASTERISK-21156) Reported
	  by: amsoft2001

2013-03-12 16:23 +0000 [r382848]  Matthew Jordan <mjordan@digium.com>

	* /, channels/chan_sip.c, UPGRADE.txt: Include the Username field
	  in SIP Registry events when Status is registered In
	  ASTERISK-17888, the AMI Registry event during SIP registrations
	  was supposed to include the Username field. Somehow, one of the
	  events was missed. This patch corrects that - the Username field
	  should be included in all AMI Registry events involving SIP
	  registrations. (issue ASTERISK-17888) (closes issue
	  ASTERISK-21201) Reported by: Dmitriy Serov patches:
	  chan_sip.c.diff uploaded by Dmitriy Serov (license 6479) ........
	  Merged revisions 382847 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-12 08:53 +0000 [r382827]  Igor Goncharovskiy <igor.goncharovsky@gmail.com>

	* channels/chan_unistim.c: Fix core dump on CLI usage Fix issue
	  with 'unistim show info' CLI command when device connected not
	  configured

2013-03-08 20:16 +0000 [r382739]  Jonathan Rose <jrose@digium.com>

	* channels/chan_sip.c: chan_sip: Update the via header when
	  relaying SMS MESSAGE Prior to this change, certain conditions for
	  sending the message would result in an address of '(null)' being
	  used in the via header of the SIP message because a NULl value of
	  pvt->ourip was used when initially generating the via header.
	  This is fixed by adding a call to build_via when the address is
	  set before sending the message. (closes issue ASTERISK-21148)
	  Reported by: Zhi Cheng Patches: 700-sip_msg_send_via_fix.patch
	  uploaded by Zhi Cheng (license 6475)

2013-03-07 17:57 +0000 [r382617]  Matthew Jordan <mjordan@digium.com>

	* apps/app_voicemail.c: Let vm_mailbox_snapshot combine "Urgent"
	  when no folder is specified r381835 fixed a bug in
	  vm_mailbox_snapshot where combining INBOX and Old forgot that
	  Urgent also "counts" as new messages. This fixed the problem when
	  any of the three folders was specified and the combine option was
	  used. It missed the case where the folder isn't specified and we
	  build a snapshot of all folders. This patch corrects that.

2013-03-07 15:08 +0000 [r382574]  Kinsey Moore <kmoore@digium.com>

	* main/logger.c: Ensure that logmsgs are freed properly Messages
	  sent while the logger thread is shutting down will now have their
	  associated callid freed properly.

2013-03-07 14:58 +0000 [r382573]  Matthew Jordan <mjordan@digium.com>

	* res/res_rtp_asterisk.c: Add a 'secret' probation strictrtp mode
	  to handle delayed changes in RTP source Often, Asterisk may
	  realize that a change in the source of an RTP stream is about to
	  occur and ask that the RTP engine reset it's lock on the current
	  RTP source. In certain scenarios, it may take awhile for the new
	  remote system to send RTP packets, while the old remote system
	  may continue providing RTP during that time period. This causes
	  Asterisk to re-lock onto the old source, thereby rejecting the
	  new source when the old source stops sending RTP and the new
	  source begins. This patch prevents that by having a constant
	  secondary, 'secret' probation mode enabled when an RTP source has
	  been chosen. RTP packets from other sources are always
	  considered, but never chosen unless the current RTP source stops
	  sending RTP. Review: https://reviewboard.asterisk.org/r/2364
	  (closes issue AST-1124) Reported by: John Bigelow Tested by: John
	  Bigelow (closes issue AST-1125) Reported by: John Bigelow Tested
	  by: John Bigelow

2013-03-06 18:28 +0000 [r382514]  Kinsey Moore <kmoore@digium.com>

	* /: Recorded merge of revisions 382513 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........
	  Correct app_page documentation The 'A' and 'n' options for Page()
	  mention that the announcement will be played simultaneously. This
	  is not necessarily the case.

2013-03-05 03:51 +0000 [r382410]  Igor Goncharovskiy <igor.goncharovsky@gmail.com>

	* channels/chan_unistim.c, /: Fix several unreleased mutex locks
	  that cause problem with processing calls Reported by: Daniel
	  Bohling Tested by: Daniel Bohling (Closes issue ASTERISK-21119)
	  ........ Merged revisions 382409 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-04 21:12 +0000 [r382390]  Jason Parker <jparker@digium.com>

	* /, main/event.c: Fix comparison of presence state in event
	  subsystem. Several new IEs were not given types (or names),
	  causing the comparison function to improperly succeed. This adds
	  those. (closes issue AST-1128)

2013-03-04 20:03 +0000 [r382385]  kharwell <kharwell@localhost>:

	* apps/app_confbridge.c: Confbridge CLI new record file name check.
	  This fix checks to make sure that if a confbridge record start
	  command is issued from the CLI it will always use the file name
	  given on the CLI even if it changes between start/stop records
	  for a conference. Previously it had been reusing the same file
	  between start/stops even if a new filename was given. (issue
	  AST-1088) Reported by: John Bigelow

2013-03-01 04:28 +0000 [r382322]  Michael L. Young <elgueromexicano@gmail.com>

	* contrib/realtime/mysql/sippeers.sql, channels/chan_sip.c,
	  contrib/realtime/postgresql/realtime.sql, CHANGES: Fix / Clean Up
	  Some Items To Handle The New auto_* NAT Options The original
	  report had to do with a realtime peer behind NAT being pruned and
	  the peer's private address being used instead of its external
	  address. Upon debugging, it was discovered that this was being
	  caused by the addition of the auto_force_rport and auto_comedia
	  settings. This patch does the following: * Adds a missing note to
	  the CHANGES file indicating that the default global nat setting
	  is auto_force_rport * Constify the 'req' parameter for
	  check_via() * Add calls to check_via() in a couple of places in
	  order for the auto_* settings to do their job in attempting to
	  determine if NAT is involved * Set the flags SIP_NAT_FORCE_RPORT
	  and SIP_PAGE2_SYMMETRICRTP if the auto_* settings are in use
	  where it was needed * Moves the copying of peer flags up in
	  build_peer() to before they are used; this fixes the realtime
	  prune issue * Update the contrib/realtime schemas to allow the
	  nat column to handle the different nat setting combinations we
	  have This patch received a review and "Ship It!" on the issue
	  itself. (closes issue ASTERISK-20904) Reported by: JoshE Tested
	  by: JoshE, Michael L. Young Patches:
	  asterisk-20904-nat-auto-and-rt-peersv2.diff Michael L. Young
	  (license 5026)

2013-02-28 21:58 +0000 [r382296-382298]  Joshua Colp <jcolp@digium.com>

	* res/res_rtp_asterisk.c: While the ICE negotiation is occurring
	  leave strictrtp in an open state, media can and will come from
	  different places.

	* res/res_rtp_asterisk.c: Fix a bug with ICE and strictrtp where
	  media could get dropped. If the end result of the ICE negotiation
	  resulted in the path for media changing it was possible for the
	  strictrtp code to discard the RTP packets. This change causes
	  strictrtp to enter learning mode once again when the ICE
	  negotiation has completed successfully.

2013-02-28 17:16 +0000 [r382230-382234]  Matthew Jordan <mjordan@digium.com>

	* /, channels/chan_iax2.c: Prevent deadlock in chan_iax2 when
	  attempting to set caller ID A deadlock can occur in chan_iax2
	  when it attempts to set the caller ID, as it already holds the
	  iax2 private lock and improperly fails to obtain the channel lock
	  before calling ast_set_callerid. By not safely obtaining the
	  channel lock, a locking inversion can take place, causing a
	  deadlock. This patch solves this by calling the required deadlock
	  avoidance functions that obtain the channel lock before setting
	  the caller ID. Thanks to Pavel for fixing my syntax errors and
	  testing this patch out. (closes issue ASTERISK-21128) Reported
	  by: Pavel Troller Tested by: Pavel Troller patches:
	  ASTERISK-21128-1.8.diff uploaded by mjordan (license 6283)
	  ASTERISK-21128-modified-1.8.diff uploaded by Pavel Troller
	  (license 6302) ........ Merged revisions 382233 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, apps/app_meetme.c, UPGRADE.txt: Let channels joining a MeetMe
	  conference opt out of the denoiser For some channel drivers,
	  specifically those that have a varying rate in the number of
	  audio samples, the audio quality for a MeetMe conference can be
	  exceedingly poor. This is due to a unilateral application of the
	  DENOISE function in func_speex to channels joining the
	  conference. The denoiser function in the speex library is
	  initialized with the number of audio samples in each sample that
	  will be provided to it. If the number of audio samples changes,
	  the denoiser has to be thrown away and re-initialized. While this
	  could be worked around by removing func_speex, that doesn't help
	  if you actually use the denoiser with other channels on the
	  system. This patches does the following: * Checks for the
	  presence of func_speex as opposed to codec_speex when determining
	  if the DENOISE function is present (which is where the function
	  is actually implemented) * Adds an option to MeetMe 'n' that
	  causes the denoiser to not be applied to a channel when it joins.
	  This keeps the current behavior the default, but let's users
	  disable the denoiser if it causes problems on their system.
	  Review: https://reviewboard.asterisk.org/r/2358 (closes issue
	  AST-1062) Reported by: Thomas Arimont ........ Merged revisions
	  382227 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-27 16:17 +0000 [r382151-382174]  Joshua Colp <jcolp@digium.com>

	* /, channels/chan_sip.c: Relax dialog checking in
	  get_sip_pvt_byid_locked so it works when the dialog is forked.
	  (closes issue ASTERISK-20638) Reported by: eelcob Patches:
	  pedantic-call-pickup-from-tag.patch uploaded by eelcob (license
	  6442) ........ Merged revisions 382171 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* configure, include/asterisk/autoconfig.h.in: Regenerate the
	  configure script. The one in the tree was not working for me at
	  all.

2013-02-26 19:45 +0000 [r382111]  Tzafrir Cohen <tzafrir.cohen@xorcom.com>

	* /, configure, configure.ac: Consider linux-gnuspe as linux-gnu *
	  The powerpcspe Linux port uses linux-gnuspe as the OS string. *
	  Our build system shouldn't really care for that, so just call it
	  linux-gnu. * Original report: Roland Stigge ,
	  http://bugs.debian.org/701505 Review:
	  https://reviewboard.asterisk.org/r/2357/ ........ Merged
	  revisions 382110 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-26 19:34 +0000 [r382108]  Walter Doekes <walter+asterisk@wjd.nu>

	* /, channels/chan_sip.c: Correct RPID parsing for unquoted
	  display-name. Parsing Remote-Party-ID will now succeed if
	  display-name is of the *(token LWS) kind and not just the
	  quoted-string kind. Review:
	  https://reviewboard.asterisk.org/r/2341/ ........ Merged
	  revisions 382107 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-26 19:19 +0000 [r382096]  Tzafrir Cohen <tzafrir.cohen@xorcom.com>

	* /, main/Makefile: Remove unneeded linux-gnueabi* As of r380521
	  the configure scripts converts the value of linux-gnueabi* of
	  OSARCH to "linux-gnu". So no point in testing for those values.
	  ........ Merged revisions 382087 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-26 15:38 +0000 [r382066-382069]  Matthew Jordan <mjordan@digium.com>

	* apps/app_confbridge.c: Fix typo in r382068 Well, that was
	  embarrassing. Removed an '-l' that somehow got in there.

	* apps/app_confbridge.c: Clean up ConfBridge commands to account
	  for wait_marked users When ConfBridge was refactored to better
	  handle the concept of marked, wait_marked, and normal users
	  co-existing in a conference (thereby implementing a state machine
	  for the conference), the wait_marked users were put into their
	  own list of conference participants, separate from the active
	  users. This list is used for wait_marked users when they are
	  waiting in a conference but no marked user has joined; normal
	  users may have joined at this point however. There are several
	  AMI/CLI commands that affect conference users that were not
	  checking the wait_marked users list: * CLI/AMI commands that
	  mute/unmute a participant. In this case, wait_marked users have
	  to remain in their particular state and should not be affected -
	  however, the commands would return "Channel not found" as opposed
	  to the appropriate error condition. * CLI/AMI commands that kick
	  a participant. An admin should always be able to kick a
	  participant out of the conference. This patch fixes both sets of
	  commands, and cleans up the CLI commands slightly by allowing
	  them to complete a participant name (this was supposed to have
	  been added, but the function call was commented out and wasn't
	  implemented). Review: https://reviewboard.asterisk.org/r/2346/
	  (closes issue AST-1114) Reported by: John Bigelow Tested by: John
	  Bigelow

	* apps/confbridge/conf_config_parser.c,
	  configs/confbridge.conf.sample: Ensure that the default
	  bridge/user profiles are always available ConfBridge and Page
	  require that there always be a default bridge and user profile
	  available. While properties of the default profiles can be
	  overriden in the configuration file, removing them can create
	  situations where neither application can function properly. This
	  patch ensures that if an administrator removes the profiles from
	  the confbridge.conf configuration file, the profiles are added
	  upon load. Documentation clarifying this has been added to the
	  confbridge.conf.sample file. Review:
	  https://reviewboard.asterisk.org/r/2356/ (closes issue AST-1115)
	  Reported by: John Bigelow Tested by: John Bigelow

2013-02-25 12:50 +0000 [r381917-382022]  Matthew Jordan <mjordan@digium.com>

	* addons/res_config_mysql.c, /: Clean up use of va_end/va_args in
	  res_config_mysql There were several problems using variadic
	  argument macros in res_config_mysql. * Improper use of va_end.
	  Multiple calls to va_end were possible resulting in an unbalanced
	  matching of va_start/va_end. * Calls to va_arg after a possible
	  encounter of a SENTINEL value. This patch corrects those errors.
	  (closes issue ASTERISK-19451) Reported by: wdoekes patches:
	  ASTERISK-19451-1.8--2.diff uploaded by wdoekes (License 5674)
	  ........ Merged revisions 382021 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_jingle.c, /: Set the sin_family on the bind address
	  socket during initialization Somehow, chan_jingle has managed to
	  operate for years without setting the sin_family on its bindaddr
	  socket. This patch properly sets the field during initial module
	  load to AF_INET. Note that the patch on the issue was modified
	  slightly to change the initialization of the socket from
	  allocation of a chan_jingle private to the module initialization,
	  as the bindaddr object (which is static) only needs to have the
	  address set once. (closes issue ASTERISK-19341) Reported by:
	  andre valentin patches: 0105-chan_jingle.patch uploaded by
	  avalentin (License 6064) ........ Merged revisions 381975 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* main/manager.c, /: Don't display the AMI ALL class authorization
	  for users if they don't have it When converting AMI class
	  authorizations to a string representation, the method always
	  appends the ALL class authorization. This is especially important
	  for events, as they should always communicate that class
	  authorization - even if the event itself does not specify ALL as
	  a class authorization for itself. (Events have always assumed
	  that the ALL class authorization is implied when they are raised)
	  Unfortunately, this did mean that specifying a user with
	  restricted class authorizations would show up in the 'manager
	  show user' CLI command as having the ALL class authorization.
	  Rather then modifying the existing string manipulation function,
	  this patch adds a function that will only return a string if the
	  field being compared explicitly matches class authorization field
	  it is being compared against. This prevents ALL from being
	  returned unless it is actually specified for the user. (closes
	  issue ASTERISK-20397) Reported by: Johan Wilfer ........ Merged
	  revisions 381939 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/app_parkandannounce.c, /: Make ParkAndAnnounce return to
	  priority + 1 when return context is not defined The
	  ParkAndAnnounce application documentation for the optional
	  return_context parameter states the following: return_context The
	  goto-style label to jump the call back into after timeout.
	  Default 'priority+1'. Unfortunately, the application was sending
	  the channel back into the dialplan at 'priority', which is the
	  ParkAndAnnounce application call. This causes an infinite loop of
	  the channel constantly being parked, announced, timed out,
	  parked, announced, timed out... while fun, especially for those
	  callers you wish to drive to the end of madness, this was not the
	  intent of the application. (closes issue ASTERISK-20113) Reported
	  by: serginuez patches: app_parkandannounce.diff uploaded by
	  serginuez (License 6405) ........ Merged revisions 381916 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-22 19:38 +0000 [r381893]  Michael L. Young <elgueromexicano@gmail.com>

	* res/res_agi.c: Fix FastAGI To Properly Check For A Connection
	  When IPv6 support was added to FastAGI, the intent was to have
	  the ability to check all addresses resolved for a host since we
	  might receive an IPv4 address and an IPv6 address. The problem
	  with the current code, is that, since we are doing O_NONBLOCK, we
	  get EINPROGRESS when calling ast_connect() but are ignoring this
	  instead of handling it. We break out of the loop and continue on.
	  When we later call ast_poll(), it succeeds but we never check if
	  we have a connection or not on the socket level. We then attempt
	  to send data to the host address that we think is setup and it
	  fails. We then check the errno and see that we have "connection
	  refused" and then return with agi failed. This patch does the
	  following: * Handles EINPROGRESS by creating the function
	  handle_connection() - ast_poll() was moved into this function -
	  This function checks the results of the connection on the socket
	  level after calling ast_poll() * Continues to the next address if
	  the above fails to create a connection * Once all addresses
	  resolved are tried and we still are unable to establish a
	  connection, then we return that the FastAGI call failed (closes
	  issue ASTERISK-21065) Reported by: Jeremy Kister Tested by:
	  Jeremy Kister, Michael L. Young Patches:
	  asterisk-21065_poll_correctly_v4.diff Michael L. Young (license
	  5026) Review: https://reviewboard.asterisk.org/r/2330/

2013-02-22 15:41 +0000 [r381880]  Jonathan Rose <jrose@digium.com>

	* apps/app_dial.c: app_dial: Honor the 'c' flag when the calling
	  party hangs up Apparently this feature became broken in 11,
	  probably as a result of the Hangup Cause project. (closes issue
	  ASTERISK-21113) Reprted by: Heiko Wundram Patches: app_dial.patch
	  uploaded by Heiko Wundram (license 5822)

2013-02-21 22:48 +0000 [r381848]  Matthew Jordan <mjordan@digium.com>

	* /, configure, configure.ac: Properly detect launchd Asterisk was
	  a little too pro-active in claiming that it found launchd. On
	  systems without launchd - such as FreeBSD - this resulted in
	  certain items in Asterisk that conflict with launchd to not be
	  selectable, such as res_timing_kqueue. (closes issue
	  ASTERISK-20749) Reported by: Oleg Baranov ........ Merged
	  revisions 381847 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-20 19:14 +0000 [r381835]  Matthew Jordan <mjordan@digium.com>

	* apps/app_voicemail.c: Let vm_mailbox_snapshot_create's combine
	  option apply to "Urgent" as well The vm_mailbox_snapshot_create
	  function has an option that combines the contents of INBOX and
	  Old into a single snapshot. The intent of this is that both 'new'
	  messages and 'deleted' messages are given in a single snapshot,
	  as some applications prefer this view of the voicemail world.
	  Unfortunately, the initial implementation ignored the "Urgent"
	  folder. The "Urgent" folder is a pseudo-INBOX, in that new
	  messages left with the 'U' flag will be placed in that folder as
	  opposed to INBOX. Thus, the option failed the intent with which
	  it was added. This patch makes it so that the "Urgent" folder is
	  included in the snapshot when that option is used.

2013-02-19 19:44 +0000 [r381702-381791]  kharwell <kharwell@localhost>:

	* /, main/features.c: Write the correct callid to the data1 field
	  in queue_log for transfer events. The incorrect callid was being
	  written to the "data1" field in queue_log table for transfer
	  events. The callid of the queue was being written instead of the
	  transfer target's callid. This now gets the correct "transfer to"
	  number and places that in the "data1" field of the queue_log
	  table when a transfer event is triggered. (closes issue
	  ASTERISK-19960) Reported by: vladimir shmagin ........ Merged
	  revisions 381770 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* apps/app_confbridge.c: Confbridge channels staying active when
	  all participants leave. If you started/stopped recording of a
	  conference multiple times channels would remain active even when
	  all participants left the conference. This was due to the fact
	  that a reference to the confbridge was being added every time a
	  start record command was issued, but when the recording was
	  stopped there was no matching de-reference thus keeping the
	  conference alive. Made sure only a single reference is added for
	  the record thread no matter how many times recording is
	  started/stopped. A de-reference is issued upon thread ending.
	  Note, this issue is being fixed under AST-1088 since it relates
	  to it and should have been corrected along with those
	  modifications. (issue AST-1088) Reported by: John Bigelow

	* apps/app_confbridge.c: Fixed Confbridge file recording deadlock
	  and appending. A deadlock occurred after starting/stopping and
	  then restarting a confbridge recording. Upon starting a recording
	  a record thread is created that holds a lock until just before
	  exiting. Stopping the recording does not stop/exit the thread or
	  release the lock. The thread waits until recording begins again.
	  Starting a stopped recording signals the thread to continue and
	  start recording again. However restarting the recording also
	  created another record thread resulting in a deadlock. The fix
	  was to make sure the record thread was only created once. Also it
	  was noted that filenames for the recordings were being
	  concatenated for each start/stop. This was fixed by creating a
	  new file for each conference session and appending the actual
	  recorded data within the file (e.g. passing the 'a' option to
	  MixMonitor). (issue AST-1088) Reported by: John Bigelow Review:
	  http://reviewboard.digium.internal/r/374/

2013-02-18 20:30 +0000 [r381669]  Walter Doekes <walter+asterisk@wjd.nu>

	* /, configs/sip.conf.sample: Remove "registertrying" and add
	  "rtp_engine" from/to sip.conf.sample The "registertrying" option
	  was removed in r343220. The "rtp_engine" option was added in
	  r186078 but erroneously named "engine" in the sample. Note that
	  there is no global sip setting for a different engine. ........
	  Merged revisions 381668 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-18 19:43 +0000 [r381655]  Jonathan Rose <jrose@digium.com>

	* funcs/func_presencestate.c: PRESENCE_STATE: Provide better
	  documentation for the 'e' option. Notes that the 'e' option
	  actually decodes data when used as a write function such as with
	  the SET application while it encodes data when used to read.
	  Review: https://reviewboard.asterisk.org/r/2335/

2013-02-16 16:22 +0000 [r381594-381613]  Matthew Jordan <mjordan@digium.com>

	* channels/chan_sip.c: Don't send presencestate information if the
	  state is invalid Previously, presencestate information was sent
	  whenever the state was not NOT_SET. When r381594 actually
	  returned INVALID presence state in all the places it was supposed
	  to, it caused chan_sip to start adding presence state information
	  to NOTIFY requests that it previously would not have added.
	  chan_sip shouldn't be adding presence state information when the
	  provider is in an invalid state; users can't set the state to
	  invalid and an invalid state always implies that the provider is
	  in an error condition. (issue AST-1084)

	* main/presencestate.c, funcs/func_presencestate.c, main/manager.c:
	  Fix crash in PresenceState AMI action when specifying an invalid
	  provider This patch fixes a crash in Asterisk that could be
	  caused by using the PresenceState AMI action while providing an
	  invalid provider. This patch also adds some additional warnings
	  when a user attempts to provide the PresenceState action with
	  invalid data, and removes some NOTICE statements that were still
	  lurking in the code from testing. (closes issue AST-1084)
	  Reported by: John Bigelow Tested by: John Bigelow

2013-02-15 18:42 +0000 [r381566]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Fix a crash that occurred when a BYE was
	  received on a replaced dialog. Reference counting for the channel
	  and its tech_pvt got messed up at some point between 1.8 and 11.
	  The result was that if a BYE for a dialog that had been replaced
	  (via an INVITE with Replaces) was received, Asterisk would crash
	  due to trying to access data on a channel that was no longer
	  there. The fix I introduced is to remove code that both unrefs
	  the sip_pvt and sets the channel's tech_pvt to NULL when an
	  INVITE with Replaces is handled. This way when a BYE is received,
	  the tech_pvt will be non-NULL and so the BYE can be processed and
	  not cause a crash. (closes issue ASTERISK-20929) reported by
	  Kristopher Lalletti patches: ASTERISK-20929.patch uploaded by
	  Mark Michelson (License #5049)

2013-02-15 17:17 +0000 [r381554]  kharwell <kharwell@localhost>:

	* include/asterisk/logger.h, main/autoservice.c, main/logger.c:
	  Stopped spamming of debug messages during attended transfer.
	  While autoservice is running and servicing a channel the callid
	  is being stored and removed in the thread's local storage for
	  each iteration of the thread loop. If debug was set to a
	  sufficient level the log file would be spammed with callid thread
	  local storage debug messages. Added a new function that checks to
	  see if the callid to be stored is different than what is already
	  contained (if anything). If it is different then store/replace
	  and log, otherwise just leave as is. Also made it so all logging
	  of debug messages pertaining to the callid thread storage outputs
	  only when TEST_FRAMEWORK is defined. (issue ASTERISK-21014)
	  (closes issue ASTERISK-21014) Report by: Rusty Newton Review:
	  https://reviewboard.asterisk.org/r/2324/

2013-02-15 17:12 +0000 [r381553]  Jonathan Rose <jrose@digium.com>

	* channels/chan_sip.c: chan_sip: Use video and text crypto
	  attributes to append RTP profiles to SDP Some bad copy/pasting
	  resulted in using the audio crypto attribute for both text and
	  video RTP. Also the audio crypto isn't set until after these, so
	  it was really just bad all around. (closes ASTERISK-20905)
	  Reported by: Kristopher Lalletti patches:
	  rtp_crypto_video_text.diff uploaded by Jonathan Rose (license
	  6182)

2013-02-14 19:44 +0000 [r381467]  Richard Mudgett <rmudgett@digium.com>

	* /, main/features.c: End stuck DTMF if AST_SOFTHANGUP_ASYNCGOTO
	  because it isn't a real hangup. It doesn't hurt to check
	  AST_SOFTHANGUP_UNBRIDGE either, but it should not be set outside
	  of a bridge. (issue ASTERISK-20492) ........ Merged revisions
	  381466 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-14 03:48 +0000 [r381365]  Matthew Jordan <mjordan@digium.com>

	* /, apps/app_db.c: Don't throw a spurious error when using
	  DBdeltree The function call ast_db_deltree returns the number of
	  row deleted, or a negative number if it failed. DBdeltree was
	  treating any non-zero return as an error, causing a spurious
	  verbose error message to be displayed. This patch handles the
	  return code of ast_db_deltree correctly. (closes issue
	  ASTERISK-21070) Reported by: ianc patches: dbdeltree.diff
	  uploaded by ianc (License #5955) ........ Merged revisions 381364
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-12 20:31 +0000 [r381306]  Mark Michelson <mmichelson@digium.com>

	* main/rtp_engine.c, /: Do not allow native RTP bridging if
	  packetization of media streams differs. The RTP engine will no
	  longer allow for local and remote native RTP bridges if
	  packetization of streams differs. Allowing native bridging in
	  this scenario has been known to cause FAX failures. (closes
	  ASTERISK-20650) Reported by: Maciej Krajewski Patches:
	  ASTERISK-20659.patch uploaded by Mark Michelson (License #5049)
	  Review: https://reviewboard.asterisk.org/r/2319 ........ Merged
	  revisions 381281 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-12 20:16 +0000 [r381282]  Kinsey Moore <kmoore@digium.com>

	* channels/sip/include/sip.h, channels/chan_sip.c,
	  channels/sip/security_events.c: Fix some more REF_DEBUG-related
	  build errors When sip_ref_peer and sip_unref_peer were exported
	  to be usable in channels/sip/security_events.c, modifications to
	  those functions when building under REF_DEBUG were not taken into
	  account. This change moves the necessary defines into sip.h to
	  make them accessible to other parts of chan_sip that need them.

2013-02-11 20:55 +0000 [r381217]  kharwell <kharwell@localhost>:

	* apps/app_playback.c, /: Properly load say.conf upon reload of
	  module app_playback. If say.conf did not exists prior to
	  originally loading module app_playback it would not load on
	  subsequent reloads of the module once it had been created. This
	  occurred because upon reload of the app_playback module it would
	  only load a new configuration if an old one had previously
	  existed. This fix simply removed the association between checking
	  if an old configuration existed and the loading of the new one.
	  (closes issue ASTERISK-20800) Reported by: pgoergler ........
	  Merged revisions 381216 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-11 15:03 +0000 [r381159]  Matthew Jordan <mjordan@digium.com>

	* res/res_xmpp.c: Fix crash in res_xmpp when deleting pubsub node
	  from CLI An error existed in res_xmpp where it would attempt to
	  delete attributes from a node that itself was also deleted. Per
	  the iksemel documentation, attributes added using iks_insert are
	  copied to the parent node's stack, and will be reclaimed when
	  that node is itself destroyed. (closes issue ASTERISK-20982)
	  Reported by: marcelloceschia patches: delete-node-fix.diff
	  uploaded by marcelloceschia (License 6036)

2013-02-08 17:29 +0000 [r381067]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_confbridge.c: app_confbridge: Fix crash from receiving
	  an AMI action after ConfBridge unloaded. Unloading ConfBridge
	  caused the next AMI action received to crash Asterisk. * Add the
	  missing unregister of AMI action ConfbridgeSetSingleVideoSrc when
	  ConfBridge is unloaded. (closes issue ASTERISK-20994) Reported
	  by: Jeremy Kister Patches: jira_asterisk_20994_v11.patch (license
	  #5621) patch uploaded by rmudgett Tested by: Rusty Newton, Jeremy
	  Kister

2013-02-06 20:14 +0000 [r380974]  David M. Lee <dlee@digium.com>

	* /, channels/chan_sip.c: Fixed failing test from r380696. When I
	  added my extensive suite of session timer unit tests, apparently
	  one of them was failing and I never noticed. If neither Min-SE
	  nor Session-Expires is set in the header, it was responding with
	  a Session-Expires of the global maxmimum instead of the
	  configured max for the endpoint. (issue ASTERISK-20787) ........
	  Merged revisions 380973 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-06 08:42 +0000 [r380926-380942]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Fix reload skinny with active devices.
	  Patch ensures that d->activeline and l->activesub are moved over
	  to the new device and line so that on callend the appropriate
	  subs can be found to complete hangup before device resets.
	  (closes issue ASTERISK-16610) Reported by: wedhorn Tested by:
	  snuffy, myself Patches: skinny-reloadactive01.diff uploaded by
	  wedhorn (license 5019)

	* channels/chan_skinny.c: Reset skinny vmexten on reload. Make
	  skinny reset vmexten '\0' on reload to ensure that it is set to
	  '\0' if the appropriate item is removed/commented in skinny.conf.
	  part of ASTERISK-21037 Reported by: snuffy Tested by: snuffy,
	  myself Patches: part of immed_dial_fix.diff uploaded by snuffy
	  (license 5024)

2013-02-05 19:09 +0000 [r380854-380894]  Richard Mudgett <rmudgett@digium.com>

	* apps/app_page.c, apps/app_confbridge.c: app_page and
	  app_confbridge: Fix custom announcement on entering conference.
	  The Page and ConfBridge custom announcement did not play when
	  users entered the conference. * Fix the
	  CONFBRIDGE(user,announcement) file not getting played. The code
	  to do this got removed accidentally when the ConfBridge code was
	  restructured to be more state machine like. * Fixed
	  play_prompt_to_user() doxygen comments. * Fixed the Page A(x) and
	  n options for the caller. The caller never played the
	  announcement file and totally ignored the n option. The code to
	  do this was lost when the application was converted to use
	  ConfBridge. * Factored out setup_profile_bridge(),
	  setup_profile_paged(), and setup_profile_caller() routines to
	  setup ConfBridge profiles. Made each profile setup routine use
	  the default template if one has not already been setup by
	  dialplan. (closes issue ASTERISK-20990) Reported by: Jeremy
	  Kister Tested by: rmudgett

	* apps/confbridge/conf_state_multi_marked.c: app_confbridge: Fix
	  error messages on exiting conference. A marked user ending a
	  conference with only end_marked users generates error messages:
	  ERROR[0000][C-00000000]: confbridge/conf_state.c:47
	  conf_invalid_event_fn: Invalid event for confbridge user '' * The
	  MULTI_MARKED state was doing too much when it was kicking out the
	  end_marked users from the conference. The kicked out users will
	  clean up after themselves when they exit the conference. (closes
	  issue ASTERISK-20991) Reported by: Jeremy Kister Tested by:
	  rmudgett

	* apps/app_page.c: app_page: Fixup application XML documentation
	  typos and inaccuracies.

	* apps/confbridge/conf_config_parser.c: Because the compiler can
	  check types with a struct copy and memcpy() cannot.

	* main/dial.c, /: Separate option_types[] from the struct
	  definition. Updated the option_types[] doxygen comment. ........
	  Merged revisions 380853 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-02-04 19:50 +0000 [r380816]  Jason Parker <jparker@digium.com>

	* res/pjproject/aconfigure, res/pjproject/build/os-auto.mak.in,
	  Makefile, res/pjproject/aconfigure.ac, res/Makefile,
	  res/pjproject/build/common.mak: Fix how we build pjproject. Allow
	  parallel builds, better tolerate failures, build faster. This
	  also stops running dependencies before top-level configure has
	  been run. (closes issue ASTERISK-20815) Review:
	  https://reviewboard.asterisk.org/r/2292/

2013-01-31 21:42 +0000 [r380735-380736]  Jason Parker <jparker@digium.com>

	* res/pjproject/pjlib/include/pj/config_site.h: Ignore warnings
	  caused by PJ_TODO()s in pjproject.

	* res/pjproject/pjlib/src/pj/ssl_sock_ossl.c,
	  res/pjproject/pjlib/src/pj/log.c,
	  res/pjproject/pjlib/src/pj/pool_buf.c,
	  res/pjproject/pjsip-apps/src/samples/icedemo.c,
	  res/pjproject/pjmedia/src/test/test.c: Fix a few compiler
	  warnings.

2013-01-31 20:10 +0000 [r380698]  David M. Lee <dlee@digium.com>

	* /, channels/chan_sip.c: Process session timers, even if
	  Session-Expires header is missing Previously, Asterisk only
	  processed session timer information if both the 'Supported:
	  timer' and 'Session-Expires' headers were present. However, the
	  Session-Expires header is optional. If we were to receive a
	  request with a Min-SE greater than our configured
	  session-expires, we would respond with a 'Session-Expires' header
	  that was too small. This patch cleans the situation up a bit,
	  always processing timer information if the 'Supported: timer'
	  header is present. (closes issue ASTERISK-20787) Reported by:
	  Mark Michelson Review: https://reviewboard.asterisk.org/r/2299/
	  ........ Merged revisions 380696 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-31 19:03 +0000 [r380671-380673]  Jason Parker <jparker@digium.com>

	* res/pjproject/pjsip/build/Makefile,
	  res/pjproject/pjsip-apps/build/Makefile,
	  res/pjproject/pjmedia/build/Makefile,
	  res/pjproject/pjlib-util/build/Makefile,
	  res/pjproject/pjlib/build/Makefile,
	  res/pjproject/pjnath/build/Makefile: Add support for parallel
	  builds of pjproject. Also adds proper dependency checking, and
	  direct .a file targets. We don't take advantage of this
	  currently, but we will soon. (issue ASTERISK-20815)

	* res/pjproject/aconfigure, res/pjproject/aconfigure.ac: Always
	  check for libm, regardless of configure options.

	* res/pjproject/aconfigure, res/pjproject/aconfigure.ac,
	  res/pjproject/build/cc-auto.mak.in,
	  res/pjproject/build/rules.mak: Remove a cross-compile workaround.
	  ar and ranlib can be easily detected with autoconf.

2013-01-31 00:30 +0000 [r380575-380612]  Richard Mudgett <rmudgett@digium.com>

	* /, include/asterisk/channel.h: Make CHECK_BLOCKING() debug
	  message more useful. Change the displayed pthread value to hex
	  format so it can be easily matched with CLI core show threads or
	  gdb. ........ Merged revisions 380611 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_dahdi.c, /: chan_dahdi: Fix "dahdi show channels
	  group" for groups greater than 31. The variable type used was not
	  large enough to hold a group bit field. ........ Merged revisions
	  380572 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-03-27  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.3.0-rc2 Released.

	* app_confbridge: Fix error messages on exiting conference.
	
	  A marked user ending a conference with only end_marked users
	  generates error messages:
	  ERROR[0000][C-00000000]: confbridge/conf_state.c:47
	  conf_invalid_event_fn: Invalid event for confbridge user ''

	  The MULTI_MARKED state was doing too much when it was kicking out
	  the end_marked users from the conference.  The kicked out users
	  will clean up after themselves when they exit the conference.

	* app_page and app_confbridge: Fix custom announcement on entering
	conference.

	  The Page and ConfBridge custom announcement did not play when users
	  entered the conference.

	  Fix the CONFBRIDGE(user,announcement) file not getting played. The
	  code to do this got removed accidentally when the ConfBridge code
	  was restructured to be more state machine like.

	  Fixed play_prompt_to_user() doxygen comments.

	  Fixed the Page A(x) and n options for the caller.  The caller never
	  played the announcement file and totally ignored the n option.  The
	  code to do this was lost when the application was converted to use
	  ConfBridge.

	  Factored out setup_profile_bridge(), setup_profile_paged(), and
	  setup_profile_caller() routines to setup ConfBridge profiles. Made
	  each profile setup routine use the default template if one has not
	  already been setup by dialplan.

	* app_confbridge: Fix crash from receiving an AMI action after
	ConfBridge unloaded.

	  Unloading ConfBridge caused the next AMI action received to crash
	  Asterisk. Add the missing unregister of AMI action
	  ConfbridgeSetSingleVideoSrc when ConfBridge is unloaded.

	* Fixed Confbridge file recording deadlock and appending.

	  A deadlock occurred after starting/stopping and then restarting a
	  confbridge recording.  Upon starting a recording a record thread is
	  created that holds a lock until just before exiting.  Stopping the
	  recording does not stop/exit the thread or release the lock.  The
	  thread waits until recording begins again. Starting a stopped
	  recording signals the thread to continue and start recording
	  again.  However restarting the recording also created another
	  record thread resulting in a deadlock.  The fix was to make sure
	  the record thread was only created once.

	* Confbridge channels staying active when all participants leave.

	  If you started/stopped recording of a conference multiple times
	  channels would remain active even when all participants left the
	  conference.  This was due to the fact that a reference to the
	  confbridge was being added every time a start record command was
	  issued, but when the recording was stopped there was no matching
	  de-reference thus keeping the conference alive. Made sure only a
	  single reference is added for the record thread no matter how
	  many times recording is started/stopped.  A de-reference is
	  issued upon thread ending.

	* Let vm_mailbox_snapshot_create's combine option apply to "Urgent"
	as well

	  The vm_mailbox_snapshot_create function has an option that combines
	  the contents of INBOX and Old into a single snapshot. The intent
	  of this is that both 'new' messages and 'deleted' messages are given
	  in a single snapshot, as some applications prefer this view of the
	  voicemail world. Unfortunately, the initial implementation ignored the
	  "Urgent" folder. The "Urgent" folder is a pseudo-INBOX, in that new
	  messages left with the 'U' flag will be placed in that folder as
	  opposed to INBOX. Thus, the option failed the intent with which it
	  was added.

	* Fix comparison of presence state in event subsystem.

	  Several new IEs were not given types (or names), causing the
	  comparison function to improperly succeed.  This adds those.

	* Let vm_mailbox_snapshot combine "Urgent" when no folder is specified

	  r381835 fixed a bug in vm_mailbox_snapshot where combining INBOX and
	  Old forgot that Urgent also "counts" as new messages. This fixed the
	  problem when any of the three folders was specified and the combine
	  option was used. It missed the case where the folder isn't specified
	  and we build a snapshot of all folders. This patch corrects that.

	* Do not allow native RTP bridging if packetization of media streams
	differs.

	The RTP engine will no longer allow for local and remote native RTP
	bridges	if packetization of streams differs. Allowing native bridging
	in this	scenario has been known to cause FAX failures.

	* Resolve deadlock between pending CDR and batch CDR locks

	r375757 attempted to resolve a race condition between multiple
	submissions of CDRs while in batch mode from attempting to destroy the
	scheduled batch	submission by extending the batch CDR lock. Unfortunately,
	this causes a deadlock between the pending CDR lock and the batch CDR lock.
	This patch resolves the intent of r375757 by simply providing a new lock
	that protects the scheduling of the batches. The original batch CDR lock
	is kept to protect manipulation of the batch CDR settings, but has been
	placed such that it is not held when the pending lock is held.

	Thanks to Chase Venters for providing lock analysis on the issue.

	* Resolve deadlock between SIP registration and channel based
	functions

	In r373424, several reentrancy problems in chan_sip were addressed. As
	a result, the SIP channel driver is now properly locking the channel
	driver private information in certain operations that it wasn't previously.
	This exposed two latent problems either in register_verify or by functions
	called by register_verify. This includes:
	 * Holding the private lock while calling sip_send_mwi_to_peer. This
	 can create a new sip_pvt via sip_alloc, which will obtain the channel
	 container lock. This is a locking inversion, as any channel related lock
	 must be obtained prior to obtaining the SIP channel technology private
	 lock.
	 * Holding the private lock while calling sip_poke_peer. In the same vein as
         sip_send_mwi_to_peer, sip_poke_peer can create a new SIP private, causing
         the same locking inversion.

	Note that this locking inversion typically occured when CLI commands were run
	while a SIP REGISTER request was being processed, as many CLI commands (such
	as 'sip show channels', 'core show channels', etc.) have to obtain the channel
	container lock.

	* AST-2013-001: Prevent buffer overflow through H.264 format negotiation

	  The format attribute resource for H.264 video performs an unsafe read
	  against a media attribute when parsing the SDP. The value passed in with
	  the format attribute is not checked for its length when parsed into a fixed
	  length buffer. This patch resolves the vulnerability by only reading
	  as many characters from the SDP value as will fit into the buffer.

	* AST-2013-002: Prevent denial of service in HTTP server

	AST-2012-014, fixed in January of this year, contained a fix for
	Asterisk's HTTP server for a remotely-triggered crash. While the fix put in
	place fixed the possibility for the crash to be triggered, a denial of
	service vector still exists with that solution if an attacker sends one or
	more HTTP POST requests with very large Content-Length values. This patch
	resolves this by capping the Content-Length at 1024 bytes. Any attempt to send
	an HTTP POST with Content-Length greater than this cap will not result in any
	memory allocation. The POST will be responded to with an HTTP 413 "Request
	Entity Too Large" response.

	This issue was reported by Christoph Hebeisen of TELUS Security Labs

	* AST-2013-003: Prevent username disclosure in SIP channel driver

	When authenticating a SIP request with alwaysauthreject enabled,
	allowguest disabled, and autocreatepeer disabled, Asterisk discloses whether
	a user exists for INVITE, SUBSCRIBE, and REGISTER transactions in
	multiple ways. The information is disclosed when:
	 * A "407 Proxy Authentication Required" response is sent instead of a
	   "401 Unauthorized" response
	 * The presence or absence of additional tags occurs at the end of
	   "403 Forbidden" (such as "(Bad Auth)")
	 * A "401 Unauthorized" response is sent instead of "403 Forbidden"
	   response after a retransmission
	 * Retransmission are sent when a matching peer did not exist, but not
	   when a matching peer did exist.
	This patch resolves these various vectors by ensuring that the responses sent
	in all scenarios is the same, regardless of the presence of a matching peer.

	This issue was reported by Walter Doekes, OSSO B.V. A substantial portion of
	the testing and the solution to this problem was done by Walter as well - a
	huge thanks to his tireless efforts in finding all the ways in which this
	setting didn't work, providing automated tests, and working with Kinsey on
	getting this fixed.

	* Fix white noise on SRTP decryption

	When res_rtp_asterisk.c was altered to avoid attempting to apply
	unprotect algorithms to non-audio RTP packets, the test used was
	incorrect. This caused the audio packets to not be decrypted and
	resulted in loud white noise on the other endpoint (or both endpoints
	depending on the call legs involved). The test now properly checks the
	version field in the RTP header to ensure that RTP and RTCP are
	decrypted while other types of packets are not.

2013-01-30  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.3.0-rc1 Released.

2013-01-30 17:46 +0000 [r380452-380521]  Matthew Jordan <mjordan@digium.com>

	* /, configure, include/asterisk/autoconfig.h.in, configure.ac:
	  Support building Asterisk for Raspberry Pi/Raspbian with
	  hard-float support Building Asterisk on Raspbian with hard-float
	  support fails as it uses the string 'linux-gnueabihf' for host
	  os, as opposed to 'linux-gnueabi'. This patch modifies the
	  configure script for Asterisk such that it will match on any
	  string beginning with 'linux-gnueabi', as opposed to requiring an
	  explicit match. (closes issue ASTERISK-21006) Reported by:
	  Christian Hesse Tested by: Christian Hesse patches:
	  linux-gnueabihf.patch uploaded by Christian Hesse (license 6459)
	  linux-gnueabihf-autoconf.patch uploaded by Christian Hesse
	  (license 6459) ........ Merged revisions 380520 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_sip.c: Unregister SIP provider API if module load
	  is declined A user in #asterisk ran into a problem where a
	  configuration error prevented the chan_sip module from being
	  loaded. Upon fixing their configuratione error, they could no
	  longer load the chan_sip module. This was because the
	  configuration checking happened after the SIP provider was
	  registered with the Asterisk core, and subsequent attempts to
	  load the SIP module failed as the provider was already
	  registered. Since we want to detect any failure in registering
	  chan_sip as early as possible (as that could be emblematic of a
	  deeper mismatch between module and Asterisk core), this patch
	  does not change the registration location, but does ensure that
	  if a module load is declined, we unregister the module as the SIP
	  api provider.

	* /, channels/chan_sip.c: Perform case insensitive comparisons for
	  T.38 attributes RFC5347 section 2.5.2 states the following: ...
	  The attribute "T38MaxBitRate" was once incorrectly registered
	  with IANA as "T38maxBitRate" (lower-case "m"). In accordance with
	  T.38 examples and common implementation practice, the form
	  "T38MaxBitRate" SHOULD be generated by implementations conforming
	  to this package. In general, it is RECOMMENDED that
	  implementations of this package accept lowercase, uppercase, and
	  mixed upper/lowercase encodings of all the T.38 attributes. ...
	  Asterisk currently does not perform case insensitive matching on
	  the T.38 attributes. This causes the T38MaxBitRate attribute to
	  be negotiated at 2400 baud instead of 14400 (or whatever value
	  you actually wanted). This patch makes it so that when we compare
	  T.38 attributes, we do so in a case insensitive fashion. Note
	  that while the issue reporter did not directly write the patch,
	  they contributed to it (and would have provided one themselves if
	  the license had gone through a tad faster), and hence get
	  attribution for it. Review:
	  https://reviewboard.asterisk.org/r/2298/ (closes issue
	  ASTERISK-20897) Reported by: Eric Hill Tested by: Eric Hill
	  patches: -- uploaded by Eric Hill ........ Merged revisions
	  380458 from http://svn.asterisk.org/svn/asterisk/branches/1.8

	* res/res_calendar_icalendar.c, /: Fix memory leak in
	  res_calendar_icalendar The ICalendar module had a systemic memory
	  leak on each fetch of data from the ICalendar source. The
	  previous fetched data was not being properly disposed. This patch
	  makes it so that before each fetch of data, we dispose of the
	  previously fetched data. (closes issue ASTERISK-21012) Reported
	  by: Joel Vandal Tested by: Joel Vandal ........ Merged revisions
	  380451 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-29 17:54 +0000 [r380384]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/chan_agent.c: chan_agent: Prevent multiple channels
	  from logging in as the same agent. Multiple channels logging in
	  as the same agent can result in dead channels waiting for a
	  condition signal that will never come because another channel
	  thread stole it. A symptom is chan_sip repeatedly generating
	  warning messages about rescheduling autodestruction of dialogs
	  with an agent channel owner. * Made only login_exec() (the app
	  AgentLogin) clear the agent_pvt->chan pointer to prevent multiple
	  channels from logging in as the same agent. agent_read(),
	  agent_call(), and agent_set_base_channel() no longer disconnect
	  the agent channel from the agent_pvt. This also eliminates the
	  need to keep checking for agent_pvt->chan being NULL. * Made
	  agent_hangup() not wake up the AgentLogin agent thread until it
	  is done. * Made agent_request() not able to get the agent until
	  he has logged in and any wrapup time has expired. * Made
	  agent_request() use ast_hangup() instead of agent_hangup() to
	  correctly dispose of a channel. * Removed
	  agent_set_base_channel(). Nobody calls it and it is a bad thing
	  in general. * Made only agent_devicestate() determine the current
	  device state of an agent. Note: Agent group device states have
	  never been supported. Review:
	  https://reviewboard.asterisk.org/r/2260/ ........ Merged
	  revisions 380364 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-29 17:14 +0000 [r380350]  David M. Lee <dlee@digium.com>

	* channels/sip/sdp_crypto.c, /: Corrected crypto tag in SDP ANSWER
	  for SRTP. (again) The original fix (r380043) for getting Asterisk
	  to respond with the correct tag overlooked some corner cases, and
	  the fact that the same code is in 1.8. This patch moves the
	  building of the crypto line out of sdp_crypto_process(). Instead,
	  it merely copies the accepted tag. The call to sdp_crypto_offer()
	  will build the crypto line in all cases now, using a tag of "1"
	  in the case of sending offers. (closes issue ASTERISK-20849)
	  Reported by: José Luis Millán Review:
	  https://reviewboard.asterisk.org/r/2295/ ........ Merged
	  revisions 380347 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-29 17:05 +0000 [r380348]  Jonathan Rose <jrose@digium.com>

	* main/features.c: call_parking: Make sure fallbacks are used when
	  lacking a flat channel exten A regression was introduced which
	  removed automatic fallback behavior from the PBX. This behavior
	  was used by call parking (or at least documented as how the
	  feature works) in order to select an extension when the flat
	  channel extension wasn't available from the comebackcontext.
	  Parking now handles the fallbacks internally in order to keep
	  behavior matching with how it is documented. (closes issue
	  ASTERISK-20716) Reported by: Chris Gentle Review:
	  https://reviewboard.asterisk.org/r/2296/

2013-01-29 14:45 +0000 [r380298-380331]  Matthew Jordan <mjordan@digium.com>

	* channels/chan_sip.c: Ensure that a declined media stream is
	  terminated with a '\r\n' In r369028, chan_sip's processing of
	  media streams in an SDP was modified to better handle multiple
	  offered media streams. Part of that change modified how streams
	  were declined. Previously, declined media streams were not
	  handled in an RFC compliant manner; now, we set the port number
	  to 0 in the media stream definition and proceed on with the next
	  media stream. Unfortunately, the formatting of the declined media
	  stream forgot to append a '\r\n' to the end of the media stream.
	  This is normally added to the accepted media streams later on in
	  the processing of the SDP. Since the declined media stream uses a
	  different buffer than the accepted media streams (and is a
	  malloc'd buffer as opposed to a struct ast_str), it's easier to
	  just slap the '\r\n' on the declined media stream buffer rather
	  than attempt to append it later on. So, that's what we do. And
	  now some devices (and probably some providers) will be a bit
	  happier (but probably not terribly happy, since we just rejected
	  something they offered). Review:
	  https://reviewboard.asterisk.org/r/2297/ (closes issue
	  ASTERISK-20908) Reported by: Dennis DeDonatis Tested by: Dennis
	  DeDonatis

	* autoconf/ast_check_pwlib.m4, /, configure: Update configure
	  script to be compatible with ptlib 2.10.9 With ptlib 2.10.9, the
	  configure script fails due to grep returning multiple matches for
	  the pattern it searches for. This patch updates the pattern
	  matching to return only the actual version for the symbol
	  searched for, PTLIB_VERSION. (closes issue ASTERISK-20980)
	  Reported by: Stefan Reuter patches: ASTERISK-20980-1.patch
	  uploaded by Stefan Reuter (license 5339) ........ Merged
	  revisions 380297 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-28 21:08 +0000 [r380255]  Sean Bright <sean@malleable.com>

	* /, channels/iax2.h, channels/chan_iax2.c: Correct the number of
	  available call numbers in IAX2. There is currently an edge case
	  where call number 32768 might be allocated for a call, even
	  though the IAX2 protocol requires call numbers be only 15 bits.
	  This resulted in some unpredictable behavior when call number
	  32678 is chosen. This patch was mostly written by Richard Mudgett
	  via ReviewBoard. I'm just committing it. Review:
	  https://reviewboard.asterisk.org/r/2293/ ........ Merged
	  revisions 380254 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-28 01:57 +0000 [r380211]  Russell Bryant <russell@russellbryant.com>

	* /, main/file.c: Change cleanup ordering in filestream destructor.
	  This patch came about due to a problem observed where wav files
	  had an empty header. The header is supposed to be updated in
	  wav_close(). It turns out that this was broken when the
	  cache_record_files option from asterisk.conf was enabled. The
	  cleanup code was moving the file to its final destination
	  *before* running the close() method of the file destructor, so
	  the header didn't get updated. Another problem here is that the
	  move was being done before actually closing the FILE *. Finally,
	  the last bug fixed here is that I noticed that wav_close() checks
	  for stream->filename to be non-NULL. In the previous cleanup
	  order, it's checking a pointer to freed memory. This doesn't
	  actually cause anything to break, but it's treading on dangerous
	  waters. Now the free() of stream->filename is happening after the
	  format module's close() method gets called, so it's safer.
	  Review: https://reviewboard.asterisk.org/r/2286/ ........ Merged
	  revisions 380210 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-27 20:31 +0000 [r380193]  Michael L. Young <elgueromexicano@gmail.com>

	* apps/confbridge/conf_config_parser.c: Fix Some Configured
	  Conference Bridge Sounds Not Being Set The "sound_only_one" sound
	  was not being set even though it was configured. In looking into
	  this, I found that the "join" and "leave" prompts were not being
	  set either. (closes issue ASTERISK-20898) Reported by: Stephan
	  Tested by: Stephan Patches:
	  asterisk-20898-custom-sounds-ignored.diff uploaded by Michael L.
	  Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2289/

2013-01-24 16:39 +0000 [r380043]  David M. Lee <dlee@digium.com>

	* channels/sip/sdp_crypto.c: Corrected crypto tag in SDP ANSWER for
	  SRTP. When Asterisk responds with an SDP ANSWER for SRTP, it had
	  the code to correctly fill in the crypto data, which was
	  overwritten by a call to sdp_crypto_offer. Corrected the
	  situation by changing sdp_crypto_offer to not replacing crypto
	  data if it already exists. (closes issue ASTERISK-20849) Reported
	  by: José Luis Millán Tested by: Iñaki Baz Castillo Patches:
	  fix_sdp_crypto_tags.diff uploaded by Pedro Kiefer (license 6407)

2013-01-24 04:01 +0000 [r380028]  Matthew Jordan <mjordan@digium.com>

	* apps/app_confbridge.c: Correct documentation for ConfbridgeList
	  AMI action The documentation for ConfbridgeList states that the
	  Conference field is optional. That's not really the case: if you
	  fail to provide a Conference number, the command will kick back
	  an error. (closes issue AST-1090) Reported by: John Bigelow

2013-01-23 00:23 +0000 [r379964]  Richard Mudgett <rmudgett@digium.com>

	* /, main/astobj2.c: Attempt to be more helpful when using a bad
	  ao2 object pointer. Put the external obj pointer in the message
	  instead of the internal version. ........ Merged revisions 379963
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-22 22:05 +0000 [r379892-379949]  Jonathan Rose <jrose@digium.com>

	* res/res_fax_spandsp.c: res_fax_spandsp: fix t38 transmission bug
	  caused by not returning success This patch fixes the problem, but
	  the issue includes a test which is still being considered for the
	  automated test suite. (issue ASTERISK-20919) Reported by: NITESH
	  BANSAL Patches: patch_ast_fax_spandsp.patch uploaded by NITESH
	  BANSAL (license 6418)

	* /, apps/app_meetme.c, sounds/Makefile: app_meetme: Use new
	  prompts for administrator menu The old prompts for the
	  administrator menu were inadequate. They didn't mention that the
	  menu had additional options through the 8 key and pressing the 8
	  key wouldn't reveal what those options were. This patch fixes all
	  of that while also organizing code pertaining to each individual
	  menu type which was previously all stored in one gigantic
	  function along with many of the basic conference functions.
	  (closes issue AST-996) Reported by: John Bigelow Review:
	  http://reviewboard.digium.internal/r/360/ ........ Merged
	  revisions 379885 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-22 14:51 +0000 [r379826]  Matthew Jordan <mjordan@digium.com>

	* /, apps/app_meetme.c: Fix station ringback; trunk hangup issues
	  in SLA This patch fixes two bugs: * If an outbound call is made
	  from a SLA phone using SLAStation, then there is no ringtone
	  audible to the phone that originates the call. The indication of
	  the ringing was not being passed to the SLA station; this patch
	  fixes that by passing through the progress indications. * If an
	  SLA station hangs up before the called party answers, then the
	  channel to the called party continues to ring until a timeout
	  occurs. If the called party manages to answer, Asterisk attempts
	  to connect the called party to a non-existant MeetMe room. This
	  patch corrects the behavior by abandoning the call attempt if it
	  detects that the SLA station is no longer in use while attempting
	  to call the called party. Review:
	  https://reviewboard.asterisk.org/r/2275/ (closes issue
	  ASTERISK-20462) Reported by: dkerr patches:
	  asterisk-11-bugid20440+20462.patch uploaded by dkerr (license
	  5558) asterisk-11-bugid20462.patch uploaded by dkerr (license
	  5558) (closes issue ASTERISK-20440) Reported by: dkerr patches:
	  asterisk-11-bugid20440.patch uploaded by dkerr (license 5558)
	  asterisk-11-bugid20440+20462.patch uploaded by dkerr (license
	  5558) ........ Merged revisions 379825 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-22 00:35 +0000 [r379808]  Richard Mudgett <rmudgett@digium.com>

	* channels/chan_bridge.c, apps/app_confbridge.c: confbridge: Minor
	  fixes playing user counts to the conference. * Generate a warning
	  message if sound files do not exist when trying to play the user
	  count to the conference. Use the new helper routine
	  sound_file_exists() for consistency. * Put the new user into
	  autoservice when playing user counts to the conference. * Check
	  the return value of ast_bridge_impart().

2013-01-21 20:40 +0000 [r379790]  Matthew Jordan <mjordan@digium.com>

	* contrib/scripts/safe_asterisk, main/asterisk.c,
	  contrib/init.d/rc.suse.asterisk,
	  contrib/init.d/rc.mandriva.asterisk,
	  contrib/init.d/rc.debian.asterisk, /,
	  contrib/init.d/rc.redhat.asterisk, UPGRADE.txt,
	  contrib/init.d/rc.gentoo.asterisk,
	  contrib/init.d/rc.slackware.asterisk,
	  contrib/init.d/rc.archlinux.asterisk: Update init.d scripts to
	  handle stderr; readd splash screen for remote consoles When
	  r376428 was commited to re-order start up sequences to be more
	  tolerant of forking with thread primitives, a few items were
	  changed that caused changes in behavior on some distros. This
	  includes: * Not displaying the splash screen on a remote console.
	  * Displaying an error message on stderr when a remote console
	  cannot connect to a running instance of Asterisk. In the first
	  case, the splash screen was re-added (thanks to Michael L.
	  Young). In the second case, the various init.d scripts were
	  modified to pipe stderr to /dev/null, as the error message is
	  useful - if you execute a remote console or a remote console
	  command execution and it fail, it should tell you. Note that the
	  error message was always present, it just failed to be printed
	  prior to r376428. Much thanks to the folks who quickly reported
	  this problem, provided solutions, and promptly tested the various
	  init.d scripts on a variety of distros. (closes issue
	  ASTERISK-20945) Reported by: Warren Selby Tested by: Michael L.
	  Young, Jamuel Starkey, kaldemar, Danny Nicholas, mjordan patches:
	  asterisk-20945-remote-intro-msg.diff uploaded by elguero (license
	  5026) ASTERISK-20945-1.8-mjordan.diff uploaded by mjordan
	  (license 6283) ........ Merged revisions 379760 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 379777 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2013-01-21 18:33 +0000 [r379719]  Kinsey Moore <kmoore@digium.com>

	* /, codecs/codec_ilbc.c: Prevent segfault for interpolated iLBC
	  frames When iLBC is being used with a jitter buffer and the jb
	  has to interpolate frames, it generates frames with a null
	  pointer and a non-zero datalen. This is now handled properly.
	  (closes issue ASTERISK-20914) Reported By: John McEleney Patches:
	  ASTERISK-20914-1.8.diff uploaded by Matt Jordan (license 6283)
	  ........ Merged revisions 379718 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-21 06:27 +0000 [r379677]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Fix device call logging issues in skinny
	  Skinny device call logging (ie missed, place and received calls)
	  has issues because the incorrect sequence of callstates is/can be
	  sent to the device. This patch removes some extra callstate
	  updates driven by forces external to skinny and ensures the
	  needed intermediary callstate messages are sent. (closes issue
	  ASTERISK-20964) Reported by: wedhorn Tested by: snuffy, myself
	  Patches: ast11-skinny-calllog01.diff uploaded by wedhorn (license
	  5019)

2013-01-21 04:39 +0000 [r379643]  Andrew Latham <lathama@gmail.com>

	* contrib/scripts/install_prereq: Add LDAP libraries to install
	  script Add LDAP dev package to Debian/Ubuntu install list.
	  Existed in Redhat already. (issue ASTERISK-20886)

2013-01-21 04:07 +0000 [r379609]  Matthew Jordan <mjordan@digium.com>

	* /, apps/app_minivm.c: Fix crash in app_minivm when mime encoding
	  string An incorrect string initializations was left in
	  ast_str_encode_mime from the patch that converted string
	  manipulations to use ast_str strings (r191140). The string
	  initialization causes a crash when ast_str_set is called on the
	  string later on in the function. (closes issue ASTERISK-18697)
	  Reported by: Chris Boot patches:
	  minivm-null-pointer-dereference-fix.patch uploaded by bootc
	  (license 6309) (issue ASTERISK-20854) Reported by: Chris Warr
	  Tested by: Chris Warr ........ Merged revisions 379608 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-20 02:53 +0000 [r379582]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Fix issues with skinny sessions Fixes a
	  couple of issues with the way skinny handles sessions by ensuring
	  sessions aren't used after being freed. Some other minor changes.
	  Review: https://reviewboard.asterisk.org/r/2272/

2013-01-19 20:49 +0000 [r379548]  Walter Doekes <walter+asterisk@wjd.nu>

	* /, configure, include/asterisk/autoconfig.h.in,
	  include/asterisk/compat.h, main/strcompat.c, configure.ac: Add
	  builtin roundf() for systems lacking it. (closes issue
	  ASTERISK-16854) Review: https://reviewboard.asterisk.org/r/2276
	  Reported-by: Ovidiu Sas ........ Merged revisions 379547 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-19 00:17 +0000 [r379513]  Matthew Jordan <mjordan@digium.com>

	* main/asterisk.c, /: Fix astcanary startup problem due to wrong
	  pid value from before daemon call When Asterisk forks itself into
	  the background via a call to daemon, it must re-set the pid value
	  of the new process. Otherwise, astcanary gets the pid value of
	  the process before the fork, which prevents it from running.
	  Asterisk eventually starts lowering its priority, as it can no
	  longer communicate with the proverbial canary in the coal mine.
	  This patch ensures that the correct process identifier is used by
	  astcanary. Note that this is getting committed to 10 as a
	  regression fix. (closes issue ASTERISK-20947) Reported by: Jakob
	  Hirsch Tested by: mjordan patches:
	  asterisk-10.12.0.astcanary_ppid.diff uploaded by Jakob Hirsch
	  (license 6113) ........ Merged revisions 379509 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 379510 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2013-01-18 21:46 +0000 [r379478]  Kinsey Moore <kmoore@digium.com>

	* apps/app_confbridge.c: Fix regression in Confbridge user count
	  When the restructuring work got committed to Confbridge in
	  r375470 to fix many open issues, it caused a regression in the
	  reported count of users when conference information was requested
	  via CLI or manager. This corrects the user count and user
	  information displayed when listing conference information from
	  the CLI and manager. (closes issue ASTERISK-20938) Reported By:
	  Timo Teras Patches: confbridge-list.patch uploaded by Timo Teras
	  (license 5409)

2013-01-18 21:10 +0000 [r379475]  David M. Lee <dlee@digium.com>

	* Makefile, configure, include/asterisk/autoconfig.h.in,
	  main/Makefile, configure.ac, UPGRADE.txt, makeopts.in: Specify
	  the -rpath linker flag when prefix != /usr. This allows Asterisk
	  to start without having to specify the LD_LIBRARY_PATH. This can
	  be disabled by passing --disable-rpath to configure. (closes
	  issue ASTERISK-20407) Reported by: David M. Lee Review:
	  https://reviewboard.asterisk.org/r/2132/

2013-01-18 18:13 +0000 [r379460]  Jonathan Rose <jrose@digium.com>

	* apps/app_voicemail.c: app_voicemail: Improve msg_id handling
	  app_voicemail will no longer issue error messages when it
	  retrieves an msg_id with a NULL value from realtime and will
	  instead simply populate the msg_id field with a newly generated
	  msg_id. In addition, this patch changes the way msg_ids are
	  generated to eliminate certain causes of duplicate IDs appearing
	  within a single system. In addition, when messages are copied,
	  they will now receive a new msg_id. (closes issue ASTERISK-20717)
	  Reported by: Alec Davis Review:
	  https://reviewboard.asterisk.org/r/2220/

2013-01-18 05:26 +0000 [r379393]  David M. Lee <dlee@digium.com>

	* channels/sip/include/reqresp_parser.h, /, channels/chan_sip.c,
	  channels/sip/reqresp_parser.c: Fix Record-Route parsing for large
	  headers. Record-Route parsing copied the header into a char[256]
	  array, which can be a problem if the header is longer than that.
	  This patch parses the header in place, without the copy, avoiding
	  the issue. In addition to the original patch, I added a unit test
	  for the new get_in_brackets_const function. (closes issue
	  ASTERISK-20837) Reported by: Corey Farrell Patches:
	  chan_sip-build_route-optimized-rev1.patch uploaded by Corey
	  Farrell (license 5909) (with minor changes by dlee) ........
	  Merged revisions 379392 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-17 02:30 +0000 [r379343]  Matthew Jordan <mjordan@digium.com>

	* /, addons/chan_mobile.c: Fix issue where chan_mobile fails to
	  bind to first available port Per the bluez API, in order to bind
	  to the first available port, the rc_channel field of the socket
	  addressing structure used to bind the socket should be set to 0.
	  Previously, Asterisk had set the rc_channel field set to 1,
	  causing it to connect to whatever happens to be on port 1. We
	  could probably not explicitly set rc_channel to 0 since we memset
	  the struct earlier, but explicitly setting it will hopefully
	  prevent someone from coming in and setting it to some explicit
	  port in the future. (closes issue ASTERISK-16357) Reported by:
	  challado Tested by: Alexander Heinz, Nikolay Ilduganov, benjamin,
	  eliafino, David van Geyn patches: ASTERISK-16357.diff uploaded by
	  Nikolay Ilduganov (license 6253) ........ Merged revisions 379342
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-16 22:49 +0000 [r379311]  Mark Michelson <mmichelson@digium.com>

	* main/manager.c, /: Further fix misinformation in the description
	  of manager MailboxStatus command. The description still claimed
	  that it returned the number of messages rather than whether there
	  were messages waiting. ........ Merged revisions 379310 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-16 21:13 +0000 [r379277]  Jason Parker <jparker@digium.com>

	* contrib/scripts/install_prereq, /: Reduce number of packages
	  install_prereq installs on Debian systems. 'search' will look for
	  any package containing the name provided, so we need to force a
	  more exact search. ........ Merged revisions 379276 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-16 18:08 +0000 [r379230-379232]  Richard Mudgett <rmudgett@digium.com>

	* main/logger.c: Reduce call-id logging resource usage. Since there
	  is no need for the call-id logging ao2 object to have a lock,
	  don't create it with one.

	* channels/chan_misdn.c, /: chan_misdn: Fix compile error. (issue
	  ASTERISK-15456) ........ Merged revisions 379226 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-16 17:45 +0000 [r379146-379228]  Matthew Jordan <mjordan@digium.com>

	* res/res_xmpp.c, res/res_jabber.c, doc/appdocsxml.dtd: Let
	  documentation reference links specify which module they're
	  linking to Again, since res_jabber/res_xmpp have duplicate APIs,
	  their documentation ref links have to specify which reference
	  they're referring to. The various documentation parsers can
	  interpret the module attribute however they want in order to
	  construct the appropriate links.

	* doc/appdocsxml.dtd: Update the dtd to actually *support* the
	  module attribute in all elements Mea culpa.

	* res/res_xmpp.c, res/res_jabber.c: Add module tags to
	  documentation for res_jabber/res_xmpp Since res_jabber/res_xmpp
	  provide the same APIs (app/func/manager/etc.), the XML
	  documentation for each needs to call out which module is
	  providing the documentation. The module attribute has been added
	  to the various XML fragments for this purpose.

	* /, addons/chan_mobile.c: Fix parsing SMSSRC for SMS messages The
	  parser for SMS messages would incorrectly parse out the from
	  number. The parsing would incorrectly start scanning for the from
	  number at the same index as the first double quote ("); this
	  would inadvertently cause it to treat the first double quote as
	  the terminating double quote for the from number as well. The
	  SMSSRC should now populate correctly. (closes issue
	  ASTERISK-16822) Reported by: menschentier Tested by: Jonas Falck
	  patches: fixSMSSRC.patch uploaded by jonax (license 6320) (closes
	  issue ASTERISK-19153) Reported by: Panos Gkikakis patches:
	  sms-sender-fix.diff uploaded by roeften (license 5884) ........
	  Merged revisions 379178 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* channels/chan_misdn.c, /: Set the INVALID_EXTEN channel variable
	  when chan_misdn forces the 'i' extension The chan_misdn channel
	  driver will send a channel with an invalid destination to the 'i'
	  extension itself if said extension can be reached. It forgot,
	  however, to set the INVALID_EXTEN channel variable when it
	  bounces the channel to this extension. Dialplan writers
	  everywhere moaned at yet another inconsistency. This is yet
	  another example of why duplicating logic in multiple places
	  results in bugs that stick around in Jira for just under three
	  years. Yes: ASTERISK-15456 was created on January 18th, 2010.
	  Patch committed on January 15th, 2013. Ouch. (closes issue
	  ASTERISK-15456) Reported by: Thomas Omerzu patches:
	  chan_misdn_invalid.patch2 uploaded by Thomas Omerzu (license
	  5927) ........ Merged revisions 379145 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-14 15:27 +0000 [r379020]  David M. Lee <dlee@digium.com>

	* /, channels/chan_sip.c: Fix XML encoding of 'identity display' in
	  NOTIFY messages, continued. When r378933 was merged into 1.8, it
	  should have also escaped remote_display, since it will have the
	  same XML encoding problem when the caller/callee roles are
	  reversed. (closes issue ABE-2902) Reported by: Guenther Kelleter
	  ........ Merged revisions 379001 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-13 21:44 +0000 [r378984]  Matthew Jordan <mjordan@digium.com>

	* res/res_rtp_asterisk.c, /: Reset RTP timestamp; sequence number
	  on SSRC change In r370252 for ASTERISK-18404, Asterisk's handling
	  of RTP was modified to better account for out of order RTP
	  packets. This was accomplished by using the RTP timestamp and
	  sequence number to check for out of order packets. However, when
	  a SSRC change occurs, the timestamp and sequence number will no
	  longer have any relation to the previously received packets. The
	  variables tracking the timestamp and sequence number therefore
	  have to be reset. (closes issue ASTERISK-20906) Reported by:
	  Eelco Brolman patches: dtmf_on_hold.patch uploaded by Eelco
	  Brolman (license #6442) ........ Merged revisions 378967 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-12 06:36 +0000 [r378934]  David M. Lee <dlee@digium.com>

	* include/asterisk/utils.h, /, channels/chan_sip.c,
	  tests/test_xml_escape.c (added), main/utils.c: Fix XML encoding
	  of 'identity display' in NOTIFY messages. XML encoding in
	  chan_sip is accomplished by naively building the XML directly
	  from strings. While this usually works, it fails to take into
	  account escaping the reserved characters in XML. This patch adds
	  an 'ast_xml_escape' function, which works similarly to
	  'ast_uri_encode'. This is used to properly escape the
	  local_display attribute in XML formatted NOTIFY messages. Several
	  things to note: * The Right Thing(TM) to do would probably be to
	  replace the ast_build_string stuff with building an ast_xml_doc.
	  That's a much bigger change, and out of scope for the original
	  ticket, so I refrained myself. * It is with great sadness that I
	  wrote my own ast_xml_escape function. There's one in libxml2, but
	  it's knee-deep in libxml2-ness, and not easily used to one-off
	  escape a string. * I only escaped the string we know is causing
	  problems (local_display). At least some of the other strings are
	  URI-encoded, which should be XML safe. Rather than figuring out
	  what's safe and escaping what's not, it would be much cleaner to
	  simply build an ast_xml_doc for the messages and let the XML
	  library do the XML escaping. Like I said, that's out of scope.
	  (closes issue ABE-2902) Reported by: Guenther Kelleter Tested by:
	  Guenther Kelleter Review:
	  http://reviewboard.digium.internal/r/365/ ........ Merged
	  revision 378919 from
	  https://origsvn.digium.com/svn/asterisk/be/branches/C.3-bier
	  ........ Merged revisions 378933 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-11 23:04 +0000 [r378917]  Joshua Colp <jcolp@digium.com>

	* res/res_xmpp.c: Retain XMPP filters across reconnections so
	  external modules continue to function as expected. Previously if
	  an XMPP client reconnected any filters added by an external
	  module were lost. This issue exhibited itself with chan_motif not
	  receiving and reacting to Jingle signaling. (closes issue
	  ASTERISK-20916) Reported by: kuj

2013-01-09 20:29 +0000 [r378734-378780]  David M. Lee <dlee@digium.com>

	* main/rtp_engine.c, /: Fix end condition in
	  ast_rtp_lookup_mime_multiple2. The erroneous end condition would
	  never include the AST_RTP_CISCO_DTMF flag in the debug output.
	  (closes issue ASTERISK-20772) Reported by: Xavier Hienne ........
	  Merged revisions 378776 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* include/asterisk/strings.h: Move declaration of
	  ast_regex_string_to_regex_pattern futher down strings.h. The
	  prior location is before the declaration of struct ast_str, which
	  causes compiler warnings. (closes issue ASTERISK-20852) Reported
	  by: Pavel Troller Patches: strings.diff uploaded by Pavel Troller
	  (license 6302)

	* /, include/asterisk/causes.h: Replace errant tabs with spaces in
	  causes.h. (closes issue ASTERISK-20826) Reported by: snuffy
	  Patches: notabs.dif uploaded by snuffy (license 5024) ........
	  Merged revisions 378733 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-09 00:03 +0000 [r378687-378690]  Richard Mudgett <rmudgett@digium.com>

	* /, apps/app_queue.c: app_queue: Fix incorrect assertion. (issue
	  ASTERISK-16115) ........ Merged revisions 378689 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* /, configs/queues.conf.sample, UPGRADE.txt, CHANGES,
	  apps/app_queue.c: app_queue: Fix multiple calls to a queue member
	  that is in only one queue. When ringinuse=no queue members can
	  receive more than one call if these calls happen at nearly the
	  same time. * Fix so a queue member does not receive more than one
	  call from a queue. NOTE: This fix does not prevent multiple calls
	  to a member if the member is in more than one queue. * Did some
	  refactoring to eliminate some code redundancy. (issue
	  ASTERISK-16115) Reported by: nik600 Patches:
	  jira_asterisk_16115_single_q_v1.8.patch (license #5621) patch
	  uploaded by rmudgett Modified * Revert the -r341580 and -r341599
	  changes adding the queues.conf check_state_unknown option as it
	  was added in an attempt to fix this problem. The fix did not need
	  to be optional. The fix should not have tried to explicitly set
	  the device state. Setting the device state by something other
	  than the device introduces a race condition. I also could not see
	  how the change would be effective other than delaying the
	  app_queue code long enough for the device state to propagate to
	  app_queue. ........ Merged revisions 378663 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 378683 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2013-01-06 20:40 +0000 [r378622]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Rewrite skinny dialing to remove threaded
	  simpleswitch This rewrite changes skinny dialing from the
	  threaded simpleswitch to a scheduled timeout approach. There were
	  some underlying issues with the threaded simple switch with
	  occasional corruption and possible segfaults. Review:
	  https://reviewboard.asterisk.org/r/2240/

2013-01-04 23:04 +0000 [r378592]  Jonathan Rose <jrose@digium.com>

	* res/res_srtp.c, /: res_srtp: Prevent a crash from occurring due
	  to srtp_create failures in srtp_create Under some circumstances,
	  libsrtp's srtp_create function deallocates memory that it wasn't
	  initially responsible for allocating. Because we weren't
	  initially aware of this behavior, this memory was still used in
	  spite of being unallocated during the course of the
	  srtp_unprotect function. A while back I made a patch which would
	  set this value to NULL, but that exposed a possible condition
	  where we would then try to check a member of the struct which
	  would cause a segfault. In order to address these problems,
	  ast_srtp_unprotect will now set an error value when it ends
	  without a valid SRTP session which will result in the caller of
	  srtp_unprotect observing this error and hanging up the relevant
	  channel instead of trying to keep using the invalid session
	  address. (closes issue ASTERISK-20499) Reported by: Tootai
	  Review:
	  https://reviewboard.asterisk.org/r/2228/diff/#index_header
	  ........ Merged revisions 378591 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-04 22:18 +0000 [r378582]  Kinsey Moore <kmoore@digium.com>

	* res/pjproject/aconfigure, res/pjproject/aconfigure.ac,
	  res/pjproject/build/common.mak: Fix pjproject compilation in
	  certain circumstances On a fresh checkout of Asterisk 11, running
	  make before ./configure could cause the pjproject subdirectory to
	  get in an odd state that would prevent compilation. This patch by
	  Tilghman prevents that from occurring. (closes issue
	  ASTERISK-20681) Reported by: Dinesh Ramjuttun Tested by: danilo
	  borges, Steve Lang patches: 20121208__ccar_solved.diff.txt
	  uploaded by Tilghman Lesher (license 5003)

2013-01-04 21:18 +0000 [r378559]  Michael L. Young <elgueromexicano@gmail.com>

	* /, channels/chan_sip.c: Fix SIP Notify Messages To Have The
	  Proper IP Address In The FROM Field On a multihomed server when
	  sending a NOTIFY message, we were not figuring out which network
	  should be used to contact the peer. This patch fixes the problem
	  by calling ast_sip_ouraddrfor() and then build_via() so that our
	  NOTIFY message contains the correct IP address. Also, a debug
	  message is being added to help follow the call-id changes that
	  occur. This was helpful for confirming that the IP address was
	  set properly since the call-id contains the IP address. It also
	  will be helpful for troubleshooting purposes when following a
	  call in the debug logs. (closes issue ASTERISK-20805) Reported
	  by: Bryan Hunt Tested by: Bryan Hunt, Michael L. Young Patches:
	  asterisk-20805-notify-ip-v2.diff uploaded by Michael L. Young
	  (license 5026) Review: https://reviewboard.asterisk.org/r/2255/
	  ........ Merged revisions 378554 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-04 21:16 +0000 [r378555]  Joshua Colp <jcolp@digium.com>

	* res/res_rtp_asterisk.c, /: Don't pass STUN packets through the
	  SRTP unprotect function. (closes issue AST-1036) Reported by:
	  jbigelow ........ Merged revisions 378553 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-03 22:12 +0000 [r378515]  Michael L. Young <elgueromexicano@gmail.com>

	* /, apps/app_queue.c: Fix Queue Log Reporting Every Call
	  COMPLETECALLER With "h" Extension Present When the "h" extension
	  is present within the context of the queue, all calls are being
	  reported COMPLETECALLER even when the agent is hanging up the
	  call. This patch checks to see if the agent hung-up or not
	  instead of only relying on checking if the queue (caller) channel
	  hung-up or not. It would appear that having the h extension in
	  the mix, the pbx goes to the h extension, "hanging-up" the queue
	  channel and triggering the reporting of COMPLETECALLER. (closes
	  issue ASTERISK-20743) Reported by: call Tested by: call, Michael
	  L. Young Patches: asterisk-20743-q-cmplt-caller.diff uploaded by
	  Michael L. Young (license 5026) Review:
	  https://reviewboard.asterisk.org/r/2256/ ........ Merged
	  revisions 378514 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-03 19:41 +0000 [r378487]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/chan_agent.c: chan_agent: Fix wrapup time wait
	  response. * Made agent_cont_sleep() and agent_ack_sleep() stop
	  waiting if the wrapup time expires. agent_cont_sleep() had tried
	  but returned the wrong value to stop waiting. * Made
	  agent_ack_sleep() take a struct agent_pvt pointer instead of a
	  void pointer for better type safety. ........ Merged revisions
	  378486 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-03 18:48 +0000 [r378459]  Kinsey Moore <kmoore@digium.com>

	* main/channel.c, /: Add missing test event This test event was
	  missing from channel.c causing the dial_LS_options test to fail
	  intermittently because of a race condition where most code paths
	  emitted the test event but this one did not. The dial_LS_options
	  test should stop bouncing now. ........ Merged revisions 378455
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-03 18:44 +0000 [r378428-378457]  Richard Mudgett <rmudgett@digium.com>

	* /, channels/chan_agent.c: chan_agent: Misc code cleanup. * Fix
	  off-nominal path resource cleanup in agent_request(). * Create
	  agent_pvt_destroy() to eliminate inlined versions in many places.
	  * Pull invariant code out of loop in add_agent(). * Remove
	  redundant module user references in login_exec(). * Remove unused
	  struct agent_pvt logincallerid[] member. * Remove some redundant
	  code in agent_request(). ........ Merged revisions 378456 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /, channels/chan_agent.c: chan_agent: Fix agent_indicate()
	  locking. Avoid deadlock potential with local channels and
	  simplify the locking. ........ Merged revisions 378427 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-03 15:38 +0000 [r378411]  Joshua Colp <jcolp@digium.com>

	* res/res_xmpp.c: Prevent exhaustion of system resources through
	  exploitation of event cache This patch changes res_xmpp to no
	  longer cache events under certain circumstances. (issue
	  ASTERISK-20175) Reported by: Russell Bryant, Leif Madsen, Joshua
	  Colp Tested by: kmoore

2013-01-03 15:36 +0000 [r378376-378409]  Matthew Jordan <mjordan@digium.com>

	* res/res_xmpp.c: Prevent crashes in res_xmpp when receiving large
	  messages Similar to r378287, res_xmpp was marshaling data read
	  from an external source onto the stack. For a sufficiently large
	  message, this could cause a stack overflow. This patch modifies
	  res_xmpp in a similar fashion to res_jabber by removing the stack
	  allocation, as it was unnecessary. (issue ASTERISK-20658)
	  Reported by: wdoekes

	* main/config.c, funcs/func_realtime.c, /: Prevent crashes from
	  occurring when reading from data sources with large values When
	  reading configuration data from an Asterisk .conf file or when
	  pulling data from an Asterisk RealTime backend, Asterisk was
	  copying the data on the stack for manipulation. Unfortunately, it
	  is possible to read configuration data or realtime data from some
	  data source that provides a large blob of characters. This could
	  potentially cause a crash via a stack overflow. This patch
	  prevents large sets of data from being read from an ARA backend
	  or from an Asterisk conf file. (issue ASTERISK-20658) Reported
	  by: wdoekes Tested by: wdoekes, mmichelson patches: *
	  issueA20658_dont_process_overlong_config_lines.patch uploaded by
	  wdoekes (license 5674) * issueA20658_func_realtime_limit.patch
	  uploaded by wdoekes (license 5674) ........ Merged revisions
	  378375 from http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-02 21:17 +0000 [r378358]  Richard Mudgett <rmudgett@digium.com>

	* main/manager.c, /, main/features.c, include/asterisk/channel.h:
	  Fix AMI redirect action with two channels failing to redirect
	  both channels. The AMI redirect action can fail to redirect two
	  channels that are bridged together. There is a race between the
	  AMI thread redirecting the two channels and the bridge thread
	  noticing that a channel is hungup from the redirects. * Made the
	  bridge wait for both channels to be redirected before exiting. *
	  Made the AMI redirect check that all required headers are present
	  before proceeding with the redirection. * Made the AMI redirect
	  require that any supplied ExtraChannel exist before proceeding.
	  Previously the code fell back to a single channel redirect
	  operation. (closes issue ASTERISK-18975) Reported by: Ben Klang
	  (closes issue ASTERISK-19948) Reported by: Brent Dalgleish
	  Patches: jira_asterisk_19948_v11.patch (license #5621) patch
	  uploaded by rmudgett Tested by: rmudgett, Thomas Sevestre, Deepak
	  Lohani, Kayode Review: https://reviewboard.asterisk.org/r/2243/
	  ........ Merged revisions 378356 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

2013-01-02 18:30 +0000 [r378337]  Kinsey Moore <kmoore@digium.com>

	* /: Restore branch-1.8-merged on 11 This was accidentally deleted
	  during a merge.

2013-01-02 18:09 +0000 [r378287-378321]  Matthew Jordan <mjordan@digium.com>

	* res/res_calendar.c, include/asterisk/devicestate.h,
	  channels/chan_local.c, /, main/ccss.c, channels/chan_sip.c,
	  apps/app_meetme.c, main/channel_internal_api.c,
	  channels/chan_agent.c, main/devicestate.c,
	  include/asterisk/channel.h, res/res_jabber.c, apps/app_queue.c,
	  channels/chan_iax2.c, main/channel.c, channels/chan_dahdi.c,
	  channels/chan_skinny.c, include/asterisk/event_defs.h,
	  main/features.c, main/event.c, apps/app_confbridge.c,
	  apps/confbridge/conf_state_empty.c, funcs/func_devstate.c:
	  Prevent exhaustion of system resources through exploitation of
	  event cache Asterisk maintains an internal cache for devices in
	  the event subsystem. The device state cache holds the state of
	  each device known to Asterisk, such that consumers of device
	  state information can query for the last known state for a
	  particular device, even if it is not part of an active call. The
	  concept of a device in Asterisk can include entities that do not
	  have a physical representation. One way that this occurred was
	  when anonymous calls are allowed in Asterisk. A device was
	  automatically created and stored in the cache for each anonymous
	  call that occurred; this was possible in the SIP and IAX2 channel
	  drivers and through channel drivers that utilized the
	  res_jabber/res_xmpp resource modules (Gtalk, Jingle, and Motif).
	  These devices are never removed from the system, allowing
	  anonymous calls to potentially exhaust a system's resources. This
	  patch changes the event cache subsystem and device state
	  management to no longer cache devices that are not associated
	  with a physical entity. (issue ASTERISK-20175) Reported by:
	  Russell Bryant, Leif Madsen, Joshua Colp Tested by: kmoore
	  patches: event-cachability-3.diff uploaded by jcolp (license
	  5000) ........ Merged revisions 378303 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 378320 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* channels/sip/include/sip.h, /, channels/chan_sip.c, main/http.c,
	  res/res_jabber.c: Resolve crashes due to large stack allocations
	  when using TCP Asterisk had several places where messages
	  received over various network transports may be copied in a
	  single stack allocation. In the case of TCP, since multiple
	  packets in a stream may be concatenated together, this can lead
	  to large allocations that overflow the stack. This patch modifies
	  those portions of Asterisk using TCP to either favor heap
	  allocations or use an upper bound to ensure that the stack will
	  not overflow: * For SIP, the allocation now has an upper limit *
	  For HTTP, the allocation is now a heap allocation instead of a
	  stack allocation * For XMPP (in res_jabber), the allocation has
	  been eliminated since it was unnecesary. Note that the HTTP
	  portion of this issue was independently found by Brandon Edwards
	  of Exodus Intelligence. (issue ASTERISK-20658) Reported by:
	  wdoekes, Brandon Edwards Tested by: mmichelson, wdoekes patches:
	  ASTERISK-20658_res_jabber.c.patch uploaded by mmichelson (license
	  5049) issueA20658_http_postvars_use_malloc2.patch uploaded by
	  wdoekes (license 5674) issueA20658_limit_sip_packet_size3.patch
	  uploaded by wdoekes (license 5674) ........ Merged revisions
	  378269 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 378286 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-31 14:44 +0000 [r378219]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_sip.c: Ensure chan_sip rejects encrypted streams
	  without crypto info This ensures that Asterisk rejects encrypted
	  media streams (RTP/SAVP audio and video) that are missing
	  cryptographic keys and ensures that the incoming SDP is
	  consistent with RFC4568 as far as having a crypto attribute
	  present for any SAVP streams. Review:
	  https://reviewboard.asterisk.org/r/2204/ ........ Merged
	  revisions 378217 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 378218 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-20 21:44 +0000 [r378163-378165]  Richard Mudgett <rmudgett@digium.com>

	* main/channel.c, /: Give the causes[] a struct name. ........
	  Merged revisions 378164 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8

	* /: Add branch-1.8-merged property to allow direct merging from
	  v1.8

2012-12-18 17:41 +0000 [r378121]  Kinsey Moore <kmoore@digium.com>

	* main/channel.c, /: Add test events for time limit-related hangups
	  This patch adds hangup-related test events in order to support
	  testing of time-limited bridges. This aids in testing the S() and
	  L() bridge options. (issue SWP-4713) ........ Merged revisions
	  378119 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 378120 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-17 23:09 +0000 [r378090-378094]  Richard Mudgett <rmudgett@digium.com>

	* main/loader.c, /: Fix potential double free when unloading a
	  module. ........ Merged revisions 378092 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 378093 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* channels/chan_local.c, /: Make chan_local module references tied
	  to local_pvt lifetime. The chan_local module references were
	  manually tied to the existence of the ;1 and ;2 channel links. *
	  Made chan_local module references tied to the existence of the
	  local_pvt structure as well as automatically take care of the
	  module references. * Tweaked the wording of the local_fixup()
	  failure warning message to make sense. Review:
	  https://reviewboard.asterisk.org/r/2181/ ........ Merged
	  revisions 378088 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 378089 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-17 20:58 +0000 [r378073]  Jason Parker <jparker@digium.com>

	* main/Makefile: Make libasteriskssl.so symlink use a relative
	  path. This was causing issues when using DESTDIR, since the path
	  to which the link pointed is not likely to exist (and not useful
	  to exist) on the target system. (issue ASTNOW-284)

2012-12-14 21:32 +0000 [r378038]  Richard Mudgett <rmudgett@digium.com>

	* /, apps/app_queue.c: app_queue: Revert bad ringinuse=no patch.
	  With the option ringinuse=no set, the patch committed for
	  ASTERISK-16115 causes non-SIP queue members to never be called
	  because the device state is checked after a channel is created to
	  determine if the member is busy. These queue members always get
	  the "Member %s is busy, cannot dial" message. Most channel
	  drivers other than chan_sip use the default device state
	  handling. The default device-state state is considered in use or
	  unknown if the channel exists or not respectively. (closes issue
	  ASTERISK-20801) Reported by: rmudgett Patches:
	  jira_asterisk_16115_revert_r370418_v1.8.patch (license #5621)
	  patch uploaded by rmudgett ........ Merged revisions 378036 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 378037 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-14 01:49 +0000 [r378010]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Fix skinny to recognise vmexten in
	  general section of conf Fixup the vmexten so if globally set in
	  general section will be honored by chan_skinny. Also get rid of
	  the 'global_' part of variable name to match regexten. (closes
	  issue ASTERISK-20790) Reported by: snuffy Tested by: snuffy,
	  myself Patches: skinny-vm.diff uploaded by snuffy (license 5024)

2012-12-13 21:04 +0000 [r377993]  Richard Mudgett <rmudgett@digium.com>

	* apps/confbridge/conf_state.c, /,
	  apps/confbridge/include/confbridge.h,
	  include/asterisk/bridging.h, apps/app_confbridge.c,
	  apps/confbridge/conf_state_multi_marked.c: confbridge: Fix MOH on
	  simultaneous user entry to a new conference. When two users
	  entered a new conference simultaneously, one of the callers hears
	  MOH. This happened if two unmarked users entered simultaneously
	  and also if a waitmarked and a marked user entered
	  simultaneously. * Created a confbridge internal MOH API to
	  eliminate the inlined MOH handling code. Note that the conference
	  mixing bridge needs to be locked when actually starting/stopping
	  MOH because there is a small window between the conference join
	  unsuspend MOH and actually joining the mixing bridge. * Created
	  the concept of suspended MOH so it can be interrupted while
	  conference join announcements to the user and DTMF features can
	  operate. * Suspend any MOH until the user is about to actually
	  join the mixing bridge of the conference. This way any pre-join
	  file playback does not need to worry about MOH. * Made post-join
	  actions only play deferred entry announcement files. Changing the
	  user/conference state during that time is not protected or
	  controlled by the state machine. (closes issue ASTERISK-20606)
	  Reported by: Eugenia Belova Tested by: rmudgett Review:
	  https://reviewboard.asterisk.org/r/2232/ ........ Merged
	  revisions 377992 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-13 20:03 +0000 [r377985-377991]  Damien Wedhorn <voip@facts.com.au>

	* channels/chan_skinny.c: Minor fixes for chan_skinny Whitespace,
	  change SUBSTATE_ONHOOK to correct SKINNY_ONHOOK and correct len
	  of 2 strcmp in skinny_setdebug(). (see opticron's review on
	  https://reviewboard.asterisk.org/r/2240/)

	* channels/chan_skinny.c: Fix skinny debug tab completion Review
	  the syntax of the 'skinny debug' command to show more than just
	  'show' for options to 'skinny debug' command. (closes issue
	  ASTERISK-20789) Reported by: snuffy Tested by: snuffy, myself
	  Patches: skinny-debug.diff uploaded by snuffy (license 5024)

2012-12-13 13:51 +0000 [r377948]  Kinsey Moore <kmoore@digium.com>

	* /, channels/chan_sip.c: Ensure Min-SE is included in outbound
	  INVITEs Asterisk now includes Min-SE in outbound INVITEs when the
	  value is not 90 (the default) and session timers are not
	  disabled. This has the effect of Asterisk following RFC4028 more
	  closely with regard to 422 responses and preventing situations in
	  which Asterisk would be forced to temporarily accept a call to
	  tear it down based on a Session-Expires below the locally
	  configured Min-SE. (issue SWP-5051) Review:
	  https://reviewboard.asterisk.org/r/2222/ Reported-by: Kinsey
	  Moore Patch-by: Kinsey Moore ........ Merged revisions 377946
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8 ........
	  Merged revisions 377947 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-12 22:42 +0000 [r377924]  Rusty Newton <rnewton@digium.com>

	* /, sounds/Makefile: Incremented EXTRA_SOUNDS_VERSION in
	  sounds/Makefile to 1.4.12 for new Extra Sounds releases See
	  CHANGES-* files in English extra 1.4.12 tarballs for new sound
	  prompts added. (closes ASTERISK-20328) Reported by: Matt Jordan
	  (closes AST-755) Reported by: John Bigelow ........ Merged
	  revisions 377922 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 377923 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-11 23:59 +0000 [r377910]  Mark Michelson <mmichelson@digium.com>

	* channels/chan_sip.c: Fix a potential deadlock in chan_sip during
	  transfers. The issue comes from the fact that transfers may
	  perform a redirecting update on a channel. The issue is that lock
	  inversion between the channel and its tech_pvt occurs since the
	  channel lock is released during the transfer process. The fix is
	  to move when the redirecting update occurs to a place where
	  neither the tech_pvt or the channel is locked so that the two can
	  be locked in the proper order. (closes issue ASTERISK-20708)
	  reported by Mark Michelson patches: ASTERISK-20708-3.patch
	  uploaded by Mark Michelson (License #5049) Tested by: Tim
	  Ringenbach at Asteria Solutions Group

2012-12-11 22:01 +0000 [r377849-377883]  Richard Mudgett <rmudgett@digium.com>

	* main/timing.c, main/channel.c, main/data.c, main/stun.c, /,
	  main/file.c, main/http.c, main/aoc.c, main/image.c, main/cel.c:
	  Cleanup CLI commands on exit for several files. (issue
	  ASTERISK-20649) Reported by: Corey Farrell Patches:
	  unregister-cli-multiple-all.patch (license #5909) patch uploaded
	  by Corey Farrell ........ Merged revisions 377881 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 377882 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* main/udptl.c, /: Cleanup udptl on exit. * Cleanup CLI commands on
	  exit. (issue ASTERISK-20649) Reported by: Corey Farrell Patches:
	  udptl-shutdown-1_8-10.patch (license #5909) patch uploaded by
	  Corey Farrell udptl-shutdown-11-trunk.patch (license #5909) patch
	  uploaded by Corey Farrell Modified ........ Merged revisions
	  377847 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 377848 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-11 20:51 +0000 [r377843]  Mark Michelson <mmichelson@digium.com>

	* res/res_clialiases.c, /: Fix crash that can occur if CLI
	  registration fails for an aliased command. A recent memory leak
	  fix in main/cli.c causes an ast_cli_entry's command field to be
	  freed and NULLed if ast_cli_register() fails. res_clialiases was
	  ignoring the return value of ast_cli_register() and was then
	  passing the NULL command off to a a hash function. This resulted
	  in a crash. The fix is not to ignore the erroneous return value.
	  If ast_cli_register() fails, then we do not continue trying to
	  process the current alias. ........ Merged revisions 377840 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 377842 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-11 20:45 +0000 [r377706-377839]  Richard Mudgett <rmudgett@digium.com>

	* /, main/taskprocessor.c: Cleanup taskprocessor on exit. * Cleanup
	  CLI commands on exit. (issue ASTERISK-20649) Reported by: Corey
	  Farrell Patches: taskprocessor-cleanup-1_8-11-trunk.patch
	  (license #5909) patch uploaded by Corey Farrell
	  taskprocessor-cleanup-10-only.patch (license #5909) patch
	  uploaded by Corey Farrell Modified ........ Merged revisions
	  377837 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 377838 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* main/pbx.c, /: Cleanup pbx on exit. * Cleanup CLI commands on
	  exit. * Unreference hints and statecbs containers on exit. (issue
	  ASTERISK-20649) Reported by: Corey Farrell Patches:
	  pbx-cleanup-1_8.patch (license #5909) patch uploaded by Corey
	  Farrell pbx-cleanup-10.patch (license #5909) patch uploaded by
	  Corey Farrell pbx-cleanup-11-trunk.patch (license #5909) patch
	  uploaded by Corey Farrell Modified ........ Merged revisions
	  377806 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 377807 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* /, main/logger.c: Cleanup logger on exit. * Cleanup CLI commands,
	  destroy verbosers and logchannels lists on exit. (issue
	  ASTERISK-20649) Reported by: Corey Farrell Patches:
	  logger-cleanup-all.patch (license #5909) patch uploaded by Corey
	  Farrell Modified ........ Merged revisions 377771 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 377772 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* /, main/indications.c: Cleanup indications on exit. * Made
	  ast_unregister_indication_country() unlink the found tone zone
	  before selecting a new default_tone_zone to make it impossible to
	  select the tone zone being unregistered again. * Ringcadence is
	  no longer parsed twice in store_config_tone_zone(). * Cleanup CLI
	  commands and destroy default_tone_zone on exit. (issue
	  ASTERISK-20649) Reported by: Corey Farrell Patches:
	  indications-cleanup-all.patch (license #5909) patch uploaded by
	  Corey Farrell Modified ........ Merged revisions 377740 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 377741 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* /, main/event.c: Cleanup event on exit. * Cleanup CLI commands on
	  exit. (issue ASTERISK-20649) Reported by: Corey Farrell Patches:
	  event_shutdown-10-only.patch (license #5909) patch uploaded by
	  Corey Farrell event_shutdown-1_8-11-trunk.patch (license #5909)
	  patch uploaded by Corey Farrell ........ Merged revisions 377708
	  from http://svn.asterisk.org/svn/asterisk/branches/1.8 ........
	  Merged revisions 377709 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* main/dnsmgr.c, /: Cleanup dnsmgr on exit. * Cleanup dnsmgr thread
	  and CLI commands on exit. (issue ASTERISK-20649) Reported by:
	  Corey Farrell Patches: dnsmgr-cleanup-1_8.patch (license #5909)
	  patch uploaded by Corey Farrell dnsmgr-cleanup-10-11-trunk.patch
	  (license #5909) patch uploaded by Corey Farrell Modified ........
	  Merged revisions 377704 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 377705 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-10 16:55 +0000 [r377625-377657]  Kinsey Moore <kmoore@digium.com>

	* /, res/res_fax.c: Ensure ReceiveFax provides a CED tone via T.38
	  When using res_fax_digium, the T.38 CED tone was not being
	  provided properly which would cause some incoming faxes to fail.
	  This was not an issue with res_fax_spandsp since it does not
	  strictly honor the send_ced flag and sends the CED tone whenever
	  receiving a T.38 fax. (closes issue FAX-343) Reported-by:
	  Benjamin Tietz Patch-by: Kinsey Moore ........ Merged revisions
	  377655 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 377656 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* /, channels/chan_sip.c: Handle Session-Expires less than local
	  Min-SE in 200 OK Ensure that a call is immediately torn down if a
	  Session-Expires value received in a 200 OK is less than the local
	  Min-SE. This also prevents Asterisk from allowing calls with
	  Session-Expires below the RFC4028-mandated minimum (90s). (closes
	  issue ASTERISK-20653) Review:
	  https://reviewboard.asterisk.org/r/2237/ Patch-by: Kinsey Moore
	  ........ Merged revisions 377623 from
	  http://svn.asterisk.org/svn/asterisk/branches/1.8 ........ Merged
	  revisions 377624 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-10 06:49 +0000 [r377577-377593]  Igor Goncharovskiy <igor.goncharovsky@gmail.com>

	* channels/chan_unistim.c, /: Fix codec mismatch Fix code to send
	  in both rx and tx open stream messages correct codecs. Found that
	  on phase 0/1 phones wrong codecs cause to no audio in some
	  situations. (issue ASTERISK-20183) ........ Merged revisions
	  377591 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 377592 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* channels/chan_unistim.c: Remove trailing whitespaces in number
	  from incoming redial list. Reported by: Igor Olhovskiy

2013-01-14  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.2.0 Released.

2013-01-09  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.2.0-rc2 Released.

	* Fix pjproject compilation in certain circumstances.

	  On a fresh checkout of Asterisk 11, running make before ./configure
	  could cause the pjproject subdirectory to get in an odd state that
	  would prevent compilation. This patch by Tilghman prevents that from
	  occurring.

	  (closes issue ASTERISK-20681)
	  Patch-by: Tilghman Lesher

	* AST-2012-014: Resolve crashes due to large stack allocations when
	  using TCP

	  Asterisk had several places where messages received over various
	  network transports may be copied in a single stack allocation. In
	  the case of TCP, since multiple packets in a stream may be
	  concatenated together, this can lead to large allocations that
	  overflow the stack.

	  This patch modifies those portions of Asterisk using TCP to either
	  favor heap allocations or use an upper bound to ensure that the
	  stack will not overflow:
	  * For SIP, the allocation now has an upper limit
	  * For HTTP, the allocation is now a heap allocation instead of a
	    stack allocation
	  * For XMPP, the allocation has been eliminated since it was
	    unnecessary.

	  This patch contains the fix for both res_jabber and res_xmpp.

	* AST-2012-015: Prevent exhaustion of system resources through
	  exploitation of event cache 

	  Asterisk maintains an internal cache for devices in the event
	  subsystem. The device state cache holds the state of each device
	  known to Asterisk, such that consumers of device state information
	  can query for the last known state for a particular device, even if
	  it is not part of an active call. The concept of a device in
	  Asterisk can include entities that do not have a physical
	  representation. One way that this occurred was when anonymous calls
	  are allowed in Asterisk. A device was automatically created and
	  stored in the cache for each anonymous call that occurred; this was
	  possible in the SIP and IAX2 channel drivers and through channel
	  drivers that utilized the res_jabber/res_xmpp resource modules (Gtalk,
	  Jingle, and Motif). These devices are never removed from the system,
	  allowing anonymous call to potentially exhaust a system's resources.

	  This patch changes the event cache subsystem and device state
	  management to no longer cache devices that are not associated with a
	  physical entity.

	* Revert bad ringinuse=no patch.

	  With the option ringinuse=no set, the patch committed previous for
	  ASTERISK-16115 causes non-SIP queue members to never be called
	  because the device state is checked after a channel is created to
	  determine if the member is busy. These queue members always get the
	  "Member %s is busy, cannot dial" message.

	  Most channel drivers other than chan_sip use the default device
	  state handling. The default device state is considered in use or
	  unknown if the channel exists or not, respectively.

	* Fix multiple calls to a queue member that is only in queue.

	  When ringinuse=no queue members can receive more than one call if
	  these calls happen at nearly the same time. This patch fixes it so a
	  queu member does not receive more than one call from a queue. note
	  that this fix does not prevent multiple calls to a member if hte
	  member is in more than one queue (see ASTERISK-16115).

2012-12-10  Asterisk Development Team <asteriskteam@digium.com>

	* Asterisk 11.2.0-rc1 Released.

2012-12-10 01:41 +0000 [r377505-377511]  Tilghman Lesher <tilghman@meg.abyt.es>

	* main/xmldoc.c, /: Improve documentation by making all of the
	  colors used readable, no matter what the background color is.
	  Dark blue on a black background is unreadable, as is yellow on a
	  light background. This patch turns on the bright attribute for
	  colors when on a dark background and turns *off* the bright
	  attribute when the -W command line option is used (indicating a
	  _light_ background). This ensures that text is readable in both
	  cases. Patch by: tilghman Review:
	  https://reviewboard.asterisk.org/r/2224 ........ Merged revisions
	  377509 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 377510 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

	* /, addons/cdr_mysql.c: Remove some dead code and additionally
	  handle a case that wasn't handled. ........ Merged revisions
	  377487 from http://svn.asterisk.org/svn/asterisk/branches/1.8
	  ........ Merged revisions 377504 from
	  http://svn.asterisk.org/svn/asterisk/branches/10

2012-12-09 01:22 +0000 [r377462]  Joshua Colp <jcolp@digium.com>

	* channels/chan_motif.c: Add missing support for "who hung up" to
	  chan_motif. (closes issue ASTERISK-20671) Reported by: Matt
	  Jordan Review: https://reviewboard.asterisk.org/r/2208/

2012-12-08 00:29 +0000 [r377401-377433]  Richard Mudgett <rmudgett@digium.com>

	* contrib/realtime/mysql/sippeers.sql, /: Fix order of SIP
	  allow/disallow in MySQL contrib script. Using the contrib
	  sippeers.sql script to create the sippeers MySQL table would
	  result in being unable to place calls if you set the disallow
	  value to all. (closes issue ASTERISK-20756) Reported by: Andre
